/* WebBackend.c generated by valac 0.56.18, the Vala compiler
 * generated from WebBackend.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
 * Copyright 2024 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: LGPL-2.0
 */

#include "web.h"
#include <gmodule.h>
#include "elementary-calendar.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <libedataserver/libedataserver.h>
#include <gee.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	MAYA_WEB_BACKEND_0_PROPERTY,
	MAYA_WEB_BACKEND_NUM_PROPERTIES
};
static GParamSpec* maya_web_backend_properties[MAYA_WEB_BACKEND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

VALA_EXTERN MayaBackend* backend;
MayaBackend* backend = NULL;
static gpointer maya_web_backend_parent_class = NULL;
static MayaBackendIface * maya_web_backend_maya_backend_parent_iface = NULL;

static gchar* maya_web_backend_real_get_name (MayaBackend* base);
static gchar* maya_web_backend_real_get_uid (MayaBackend* base);
static GeeCollection* maya_web_backend_real_get_new_calendar_widget (MayaBackend* base,
                                                              ESource* to_edit);
static void maya_web_backend_real_add_new_calendar (MayaBackend* base,
                                             const gchar* name,
                                             const gchar* color,
                                             gboolean set_default,
                                             GeeCollection* widgets);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void maya_web_backend_real_modify_calendar (MayaBackend* base,
                                            const gchar* name,
                                            const gchar* color,
                                            gboolean set_default,
                                            GeeCollection* widgets,
                                            ESource* source);
static GType maya_web_backend_get_type_once (void);

MayaBackend*
get_backend (GModule* module)
{
	MayaWebBackend* b = NULL;
	MayaWebBackend* _tmp0_;
	MayaBackend* result;
#line 7 "../plugins/Web/WebBackend.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 8 "../plugins/Web/WebBackend.vala"
	g_debug ("WebBackend.vala:8: Activating Web Backend");
#line 9 "../plugins/Web/WebBackend.vala"
	_tmp0_ = maya_web_backend_new ();
#line 9 "../plugins/Web/WebBackend.vala"
	b = _tmp0_;
#line 10 "../plugins/Web/WebBackend.vala"
	g_object_ref ((GObject*) b);
#line 11 "../plugins/Web/WebBackend.vala"
	result = (MayaBackend*) b;
#line 11 "../plugins/Web/WebBackend.vala"
	return result;
#line 86 "WebBackend.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 19 "../plugins/Web/WebBackend.vala"
	return self ? g_object_ref (self) : NULL;
#line 94 "WebBackend.c"
}

MayaWebBackend*
maya_web_backend_construct (GType object_type)
{
	MayaWebBackend * self = NULL;
	MayaBackend* _tmp0_;
#line 18 "../plugins/Web/WebBackend.vala"
	self = (MayaWebBackend*) g_object_new (object_type, NULL);
#line 19 "../plugins/Web/WebBackend.vala"
	_tmp0_ = _g_object_ref0 ((MayaBackend*) self);
#line 19 "../plugins/Web/WebBackend.vala"
	_g_object_unref0 (backend);
#line 19 "../plugins/Web/WebBackend.vala"
	backend = _tmp0_;
#line 18 "../plugins/Web/WebBackend.vala"
	return self;
#line 112 "WebBackend.c"
}

MayaWebBackend*
maya_web_backend_new (void)
{
#line 18 "../plugins/Web/WebBackend.vala"
	return maya_web_backend_construct (MAYA_TYPE_WEB_BACKEND);
#line 120 "WebBackend.c"
}

static gchar*
maya_web_backend_real_get_name (MayaBackend* base)
{
	MayaWebBackend * self;
	gchar* _tmp0_;
	gchar* result;
#line 22 "../plugins/Web/WebBackend.vala"
	self = (MayaWebBackend*) base;
#line 23 "../plugins/Web/WebBackend.vala"
	_tmp0_ = g_strdup (_ ("On the web"));
#line 23 "../plugins/Web/WebBackend.vala"
	result = _tmp0_;
#line 23 "../plugins/Web/WebBackend.vala"
	return result;
#line 137 "WebBackend.c"
}

static gchar*
maya_web_backend_real_get_uid (MayaBackend* base)
{
	MayaWebBackend * self;
	gchar* _tmp0_;
	gchar* result;
#line 26 "../plugins/Web/WebBackend.vala"
	self = (MayaWebBackend*) base;
#line 27 "../plugins/Web/WebBackend.vala"
	_tmp0_ = g_strdup ("webcal-stub");
#line 27 "../plugins/Web/WebBackend.vala"
	result = _tmp0_;
#line 27 "../plugins/Web/WebBackend.vala"
	return result;
#line 154 "WebBackend.c"
}

static GeeCollection*
maya_web_backend_real_get_new_calendar_widget (MayaBackend* base,
                                               ESource* to_edit)
{
	MayaWebBackend * self;
	GeeLinkedList* collection = NULL;
	GeeLinkedList* _tmp0_;
	gboolean keep_copy = FALSE;
	GeeLinkedList* _tmp6_;
	MayaPlacementWidget* _tmp7_;
	MayaPlacementWidget* _tmp8_;
	MayaPlacementWidget* url_label = NULL;
	MayaPlacementWidget* _tmp9_;
	MayaPlacementWidget* _tmp10_;
	GtkLabel* _tmp11_ = NULL;
	MayaPlacementWidget* _tmp12_;
	MayaPlacementWidget* _tmp13_;
	MayaPlacementWidget* _tmp14_;
	gchar* _tmp15_;
	GeeLinkedList* _tmp16_;
	MayaPlacementWidget* _tmp17_;
	MayaPlacementWidget* url_entry = NULL;
	MayaPlacementWidget* _tmp18_;
	MayaPlacementWidget* _tmp19_;
	gchar* _tmp20_;
	GtkEntry* _tmp21_ = NULL;
	MayaPlacementWidget* _tmp22_;
	MayaPlacementWidget* _tmp23_;
	MayaPlacementWidget* _tmp24_;
	gchar* _tmp25_;
	MayaPlacementWidget* _tmp26_;
	GeeLinkedList* _tmp27_;
	MayaPlacementWidget* _tmp28_;
	GeeCollection* result;
#line 30 "../plugins/Web/WebBackend.vala"
	self = (MayaWebBackend*) base;
#line 31 "../plugins/Web/WebBackend.vala"
	_tmp0_ = gee_linked_list_new (MAYA_TYPE_PLACEMENT_WIDGET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 31 "../plugins/Web/WebBackend.vala"
	collection = _tmp0_;
#line 33 "../plugins/Web/WebBackend.vala"
	keep_copy = FALSE;
#line 34 "../plugins/Web/WebBackend.vala"
	if (to_edit != NULL) {
#line 201 "WebBackend.c"
		ESourceOffline* source_offline = NULL;
		ESourceExtension* _tmp1_;
		ESourceOffline* _tmp2_;
		ESourceOffline* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 35 "../plugins/Web/WebBackend.vala"
		_tmp1_ = e_source_get_extension (to_edit, E_SOURCE_EXTENSION_OFFLINE);
#line 35 "../plugins/Web/WebBackend.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, e_source_offline_get_type (), ESourceOffline));
#line 35 "../plugins/Web/WebBackend.vala"
		source_offline = _tmp2_;
#line 36 "../plugins/Web/WebBackend.vala"
		_tmp3_ = source_offline;
#line 36 "../plugins/Web/WebBackend.vala"
		_tmp4_ = e_source_offline_get_stay_synchronized (_tmp3_);
#line 36 "../plugins/Web/WebBackend.vala"
		_tmp5_ = _tmp4_;
#line 36 "../plugins/Web/WebBackend.vala"
		keep_copy = _tmp5_;
#line 34 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (source_offline);
#line 224 "WebBackend.c"
	}
#line 39 "../plugins/Web/WebBackend.vala"
	_tmp6_ = collection;
#line 39 "../plugins/Web/WebBackend.vala"
	_tmp7_ = maya_default_placement_widgets_get_keep_copy (0, keep_copy);
#line 39 "../plugins/Web/WebBackend.vala"
	_tmp8_ = _tmp7_;
#line 39 "../plugins/Web/WebBackend.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp8_);
#line 39 "../plugins/Web/WebBackend.vala"
	_g_object_unref0 (_tmp8_);
#line 41 "../plugins/Web/WebBackend.vala"
	_tmp9_ = maya_placement_widget_new ();
#line 41 "../plugins/Web/WebBackend.vala"
	url_label = _tmp9_;
#line 42 "../plugins/Web/WebBackend.vala"
	_tmp10_ = url_label;
#line 42 "../plugins/Web/WebBackend.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new (_ ("URL:"));
#line 42 "../plugins/Web/WebBackend.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
#line 42 "../plugins/Web/WebBackend.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp11_, TRUE);
#line 42 "../plugins/Web/WebBackend.vala"
	gtk_label_set_xalign (_tmp11_, 1.0f);
#line 42 "../plugins/Web/WebBackend.vala"
	g_object_ref_sink (_tmp11_);
#line 42 "../plugins/Web/WebBackend.vala"
	_g_object_unref0 (_tmp10_->widget);
#line 42 "../plugins/Web/WebBackend.vala"
	_tmp10_->widget = (GtkWidget*) _tmp11_;
#line 47 "../plugins/Web/WebBackend.vala"
	_tmp12_ = url_label;
#line 47 "../plugins/Web/WebBackend.vala"
	_tmp12_->row = 1;
#line 48 "../plugins/Web/WebBackend.vala"
	_tmp13_ = url_label;
#line 48 "../plugins/Web/WebBackend.vala"
	_tmp13_->column = 0;
#line 49 "../plugins/Web/WebBackend.vala"
	_tmp14_ = url_label;
#line 49 "../plugins/Web/WebBackend.vala"
	_tmp15_ = g_strdup ("url_label");
#line 49 "../plugins/Web/WebBackend.vala"
	_g_free0 (_tmp14_->ref_name);
#line 49 "../plugins/Web/WebBackend.vala"
	_tmp14_->ref_name = _tmp15_;
#line 50 "../plugins/Web/WebBackend.vala"
	_tmp16_ = collection;
#line 50 "../plugins/Web/WebBackend.vala"
	_tmp17_ = url_label;
#line 50 "../plugins/Web/WebBackend.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 52 "../plugins/Web/WebBackend.vala"
	_tmp18_ = maya_placement_widget_new ();
#line 52 "../plugins/Web/WebBackend.vala"
	url_entry = _tmp18_;
#line 53 "../plugins/Web/WebBackend.vala"
	_tmp19_ = url_entry;
#line 53 "../plugins/Web/WebBackend.vala"
	_tmp20_ = g_strdup ("https://example.com");
#line 53 "../plugins/Web/WebBackend.vala"
	_tmp21_ = (GtkEntry*) gtk_entry_new ();
#line 53 "../plugins/Web/WebBackend.vala"
	gtk_entry_set_placeholder_text (_tmp21_, _tmp20_);
#line 53 "../plugins/Web/WebBackend.vala"
	_g_free0 (_tmp20_);
#line 53 "../plugins/Web/WebBackend.vala"
	g_object_ref_sink (_tmp21_);
#line 53 "../plugins/Web/WebBackend.vala"
	_g_object_unref0 (_tmp19_->widget);
#line 53 "../plugins/Web/WebBackend.vala"
	_tmp19_->widget = (GtkWidget*) _tmp21_;
#line 56 "../plugins/Web/WebBackend.vala"
	_tmp22_ = url_entry;
#line 56 "../plugins/Web/WebBackend.vala"
	_tmp22_->row = 1;
#line 57 "../plugins/Web/WebBackend.vala"
	_tmp23_ = url_entry;
#line 57 "../plugins/Web/WebBackend.vala"
	_tmp23_->column = 1;
#line 58 "../plugins/Web/WebBackend.vala"
	_tmp24_ = url_entry;
#line 58 "../plugins/Web/WebBackend.vala"
	_tmp25_ = g_strdup ("url_entry");
#line 58 "../plugins/Web/WebBackend.vala"
	_g_free0 (_tmp24_->ref_name);
#line 58 "../plugins/Web/WebBackend.vala"
	_tmp24_->ref_name = _tmp25_;
#line 59 "../plugins/Web/WebBackend.vala"
	_tmp26_ = url_entry;
#line 59 "../plugins/Web/WebBackend.vala"
	_tmp26_->needed = TRUE;
#line 60 "../plugins/Web/WebBackend.vala"
	_tmp27_ = collection;
#line 60 "../plugins/Web/WebBackend.vala"
	_tmp28_ = url_entry;
#line 60 "../plugins/Web/WebBackend.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
#line 61 "../plugins/Web/WebBackend.vala"
	if (to_edit != NULL) {
#line 326 "WebBackend.c"
		ESourceWebdav* webdav = NULL;
		ESourceExtension* _tmp29_;
		ESourceWebdav* _tmp30_;
		GUri* uri = NULL;
		ESourceWebdav* _tmp31_;
		GUri* _tmp32_;
		GUri* _tmp33_;
#line 62 "../plugins/Web/WebBackend.vala"
		_tmp29_ = e_source_get_extension (to_edit, E_SOURCE_EXTENSION_WEBDAV_BACKEND);
#line 62 "../plugins/Web/WebBackend.vala"
		_tmp30_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, e_source_webdav_get_type (), ESourceWebdav));
#line 62 "../plugins/Web/WebBackend.vala"
		webdav = _tmp30_;
#line 64 "../plugins/Web/WebBackend.vala"
		_tmp31_ = webdav;
#line 64 "../plugins/Web/WebBackend.vala"
		_tmp32_ = e_source_webdav_dup_uri (_tmp31_);
#line 64 "../plugins/Web/WebBackend.vala"
		uri = _tmp32_;
#line 68 "../plugins/Web/WebBackend.vala"
		_tmp33_ = uri;
#line 68 "../plugins/Web/WebBackend.vala"
		if (g_uri_get_port (_tmp33_) != 80) {
#line 350 "WebBackend.c"
			MayaPlacementWidget* _tmp34_;
			GtkWidget* _tmp35_;
			GUri* _tmp36_;
			const gchar* _tmp37_;
			GUri* _tmp38_;
			const gchar* _tmp39_;
			GUri* _tmp40_;
			GUri* _tmp41_;
			const gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp34_ = url_entry;
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp35_ = _tmp34_->widget;
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp36_ = uri;
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp37_ = g_uri_get_scheme (_tmp36_);
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp38_ = uri;
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp39_ = g_uri_get_host (_tmp38_);
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp40_ = uri;
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp41_ = uri;
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp42_ = g_uri_get_path (_tmp41_);
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp43_ = g_strdup_printf ("%s://%s:%u%s", _tmp37_, _tmp39_, (guint) g_uri_get_port (_tmp40_), _tmp42_);
#line 69 "../plugins/Web/WebBackend.vala"
			_tmp44_ = _tmp43_;
#line 69 "../plugins/Web/WebBackend.vala"
			gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_entry_get_type (), GtkEntry), _tmp44_);
#line 69 "../plugins/Web/WebBackend.vala"
			_g_free0 (_tmp44_);
#line 388 "WebBackend.c"
		} else {
			MayaPlacementWidget* _tmp45_;
			GtkWidget* _tmp46_;
			GUri* _tmp47_;
			const gchar* _tmp48_;
			GUri* _tmp49_;
			const gchar* _tmp50_;
			GUri* _tmp51_;
			const gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
#line 71 "../plugins/Web/WebBackend.vala"
			_tmp45_ = url_entry;
#line 71 "../plugins/Web/WebBackend.vala"
			_tmp46_ = _tmp45_->widget;
#line 71 "../plugins/Web/WebBackend.vala"
			_tmp47_ = uri;
#line 71 "../plugins/Web/WebBackend.vala"
			_tmp48_ = g_uri_get_scheme (_tmp47_);
#line 71 "../plugins/Web/WebBackend.vala"
			_tmp49_ = uri;
#line 71 "../plugins/Web/WebBackend.vala"
			_tmp50_ = g_uri_get_host (_tmp49_);
#line 71 "../plugins/Web/WebBackend.vala"
			_tmp51_ = uri;
#line 71 "../plugins/Web/WebBackend.vala"
			_tmp52_ = g_uri_get_path (_tmp51_);
#line 71 "../plugins/Web/WebBackend.vala"
			_tmp53_ = g_strdup_printf ("%s://%s%s", _tmp48_, _tmp50_, _tmp52_);
#line 71 "../plugins/Web/WebBackend.vala"
			_tmp54_ = _tmp53_;
#line 71 "../plugins/Web/WebBackend.vala"
			gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, gtk_entry_get_type (), GtkEntry), _tmp54_);
#line 71 "../plugins/Web/WebBackend.vala"
			_g_free0 (_tmp54_);
#line 424 "WebBackend.c"
		}
#line 61 "../plugins/Web/WebBackend.vala"
		_g_uri_unref0 (uri);
#line 61 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (webdav);
#line 430 "WebBackend.c"
	}
#line 75 "../plugins/Web/WebBackend.vala"
	result = (GeeCollection*) collection;
#line 75 "../plugins/Web/WebBackend.vala"
	_g_object_unref0 (url_entry);
#line 75 "../plugins/Web/WebBackend.vala"
	_g_object_unref0 (url_label);
#line 75 "../plugins/Web/WebBackend.vala"
	return result;
#line 440 "WebBackend.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 110 "../plugins/Web/WebBackend.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 448 "WebBackend.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 110 "../plugins/Web/WebBackend.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 456 "WebBackend.c"
}

static void
maya_web_backend_real_add_new_calendar (MayaBackend* base,
                                        const gchar* name,
                                        const gchar* color,
                                        gboolean set_default,
                                        GeeCollection* widgets)
{
	MayaWebBackend * self;
	GError* _inner_error0_ = NULL;
#line 78 "../plugins/Web/WebBackend.vala"
	self = (MayaWebBackend*) base;
#line 78 "../plugins/Web/WebBackend.vala"
	g_return_if_fail (name != NULL);
#line 78 "../plugins/Web/WebBackend.vala"
	g_return_if_fail (color != NULL);
#line 78 "../plugins/Web/WebBackend.vala"
	g_return_if_fail (widgets != NULL);
#line 476 "WebBackend.c"
	{
		ESource* new_source = NULL;
		gchar* _tmp0_;
		ESource* _tmp1_ = NULL;
		ESource* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		ESourceCalendar* cal = NULL;
		ESource* _tmp5_;
		ESourceExtension* _tmp6_;
		ESourceCalendar* _tmp7_;
		ESourceCalendar* _tmp8_;
		ESourceCalendar* _tmp9_;
		ESourceWebdav* webdav = NULL;
		ESource* _tmp10_;
		ESourceExtension* _tmp11_;
		ESourceWebdav* _tmp12_;
		ESource* _tmp13_;
		ESourceOffline* offline = NULL;
		ESource* _tmp14_;
		ESourceExtension* _tmp15_;
		ESourceOffline* _tmp16_;
		CalendarEventStore* calmodel = NULL;
		CalendarEventStore* _tmp38_;
		ESourceRegistry* registry = NULL;
		CalendarEventStore* _tmp39_;
		ESourceRegistry* _tmp40_;
		ESourceRegistry* _tmp41_;
		ESourceRegistry* _tmp42_;
		GList* list = NULL;
		ESource* _tmp43_;
		ESource* _tmp44_;
		ESourceRegistry* _tmp45_;
		GList* _tmp46_;
		CalendarEventStore* _tmp47_;
		ESource* _tmp48_;
#line 80 "../plugins/Web/WebBackend.vala"
		_tmp0_ = g_strdup (name);
#line 80 "../plugins/Web/WebBackend.vala"
		_tmp1_ = e_source_new (NULL, NULL, &_inner_error0_);
#line 80 "../plugins/Web/WebBackend.vala"
		e_source_set_display_name (_tmp1_, _tmp0_);
#line 80 "../plugins/Web/WebBackend.vala"
		_g_free0 (_tmp0_);
#line 80 "../plugins/Web/WebBackend.vala"
		new_source = _tmp1_;
#line 80 "../plugins/Web/WebBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 525 "WebBackend.c"
			goto __catch0_g_error;
		}
#line 83 "../plugins/Web/WebBackend.vala"
		_tmp2_ = new_source;
#line 83 "../plugins/Web/WebBackend.vala"
		_tmp3_ = maya_backend_get_uid ((MayaBackend*) self);
#line 83 "../plugins/Web/WebBackend.vala"
		_tmp4_ = _tmp3_;
#line 83 "../plugins/Web/WebBackend.vala"
		e_source_set_parent (_tmp2_, _tmp4_);
#line 83 "../plugins/Web/WebBackend.vala"
		_g_free0 (_tmp4_);
#line 84 "../plugins/Web/WebBackend.vala"
		_tmp5_ = new_source;
#line 84 "../plugins/Web/WebBackend.vala"
		_tmp6_ = e_source_get_extension (_tmp5_, E_SOURCE_EXTENSION_CALENDAR);
#line 84 "../plugins/Web/WebBackend.vala"
		_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, e_source_calendar_get_type (), ESourceCalendar));
#line 84 "../plugins/Web/WebBackend.vala"
		cal = _tmp7_;
#line 85 "../plugins/Web/WebBackend.vala"
		_tmp8_ = cal;
#line 85 "../plugins/Web/WebBackend.vala"
		e_source_selectable_set_color ((ESourceSelectable*) _tmp8_, color);
#line 86 "../plugins/Web/WebBackend.vala"
		_tmp9_ = cal;
#line 86 "../plugins/Web/WebBackend.vala"
		e_source_backend_set_backend_name ((ESourceBackend*) _tmp9_, "webcal");
#line 87 "../plugins/Web/WebBackend.vala"
		_tmp10_ = new_source;
#line 87 "../plugins/Web/WebBackend.vala"
		_tmp11_ = e_source_get_extension (_tmp10_, E_SOURCE_EXTENSION_WEBDAV_BACKEND);
#line 87 "../plugins/Web/WebBackend.vala"
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, e_source_webdav_get_type (), ESourceWebdav));
#line 87 "../plugins/Web/WebBackend.vala"
		webdav = _tmp12_;
#line 89 "../plugins/Web/WebBackend.vala"
		_tmp13_ = new_source;
#line 89 "../plugins/Web/WebBackend.vala"
		e_source_get_extension (_tmp13_, E_SOURCE_EXTENSION_AUTHENTICATION);
#line 90 "../plugins/Web/WebBackend.vala"
		_tmp14_ = new_source;
#line 90 "../plugins/Web/WebBackend.vala"
		_tmp15_ = e_source_get_extension (_tmp14_, E_SOURCE_EXTENSION_OFFLINE);
#line 90 "../plugins/Web/WebBackend.vala"
		_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, e_source_offline_get_type (), ESourceOffline));
#line 90 "../plugins/Web/WebBackend.vala"
		offline = _tmp16_;
#line 574 "WebBackend.c"
		{
			GeeIterator* _widget_it = NULL;
			GeeIterator* _tmp17_;
#line 91 "../plugins/Web/WebBackend.vala"
			_tmp17_ = gee_iterable_iterator ((GeeIterable*) widgets);
#line 91 "../plugins/Web/WebBackend.vala"
			_widget_it = _tmp17_;
#line 91 "../plugins/Web/WebBackend.vala"
			while (TRUE) {
#line 584 "WebBackend.c"
				GeeIterator* _tmp18_;
				MayaPlacementWidget* widget = NULL;
				GeeIterator* _tmp19_;
				gpointer _tmp20_;
				MayaPlacementWidget* _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				GQuark _tmp25_ = 0U;
#line 92 "../plugins/Web/WebBackend.vala"
				static GQuark _tmp24_label0 = 0;
#line 92 "../plugins/Web/WebBackend.vala"
				static GQuark _tmp24_label1 = 0;
#line 91 "../plugins/Web/WebBackend.vala"
				_tmp18_ = _widget_it;
#line 91 "../plugins/Web/WebBackend.vala"
				if (!gee_iterator_next (_tmp18_)) {
#line 91 "../plugins/Web/WebBackend.vala"
					break;
#line 603 "WebBackend.c"
				}
#line 91 "../plugins/Web/WebBackend.vala"
				_tmp19_ = _widget_it;
#line 91 "../plugins/Web/WebBackend.vala"
				_tmp20_ = gee_iterator_get (_tmp19_);
#line 91 "../plugins/Web/WebBackend.vala"
				widget = (MayaPlacementWidget*) _tmp20_;
#line 92 "../plugins/Web/WebBackend.vala"
				_tmp21_ = widget;
#line 92 "../plugins/Web/WebBackend.vala"
				_tmp22_ = _tmp21_->ref_name;
#line 92 "../plugins/Web/WebBackend.vala"
				_tmp23_ = _tmp22_;
#line 92 "../plugins/Web/WebBackend.vala"
				_tmp25_ = (NULL == _tmp23_) ? 0 : g_quark_from_string (_tmp23_);
#line 92 "../plugins/Web/WebBackend.vala"
				if (_tmp25_ == ((0 != _tmp24_label0) ? _tmp24_label0 : (_tmp24_label0 = g_quark_from_static_string ("url_entry")))) {
#line 92 "../plugins/Web/WebBackend.vala"
					switch (0) {
#line 623 "WebBackend.c"
						default:
						{
							GUri* _tmp26_ = NULL;
							MayaPlacementWidget* _tmp27_;
							GtkWidget* _tmp28_;
							const gchar* _tmp29_;
							const gchar* _tmp30_;
							GUri* _tmp31_;
							ESourceWebdav* _tmp32_;
#line 95 "../plugins/Web/WebBackend.vala"
							_tmp27_ = widget;
#line 95 "../plugins/Web/WebBackend.vala"
							_tmp28_ = _tmp27_->widget;
#line 95 "../plugins/Web/WebBackend.vala"
							_tmp29_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_entry_get_type (), GtkEntry));
#line 95 "../plugins/Web/WebBackend.vala"
							_tmp30_ = _tmp29_;
#line 95 "../plugins/Web/WebBackend.vala"
							_tmp31_ = g_uri_parse (_tmp30_, G_URI_FLAGS_NONE, &_inner_error0_);
#line 95 "../plugins/Web/WebBackend.vala"
							_tmp26_ = _tmp31_;
#line 95 "../plugins/Web/WebBackend.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (widget);
#line 95 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (_widget_it);
#line 95 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (offline);
#line 95 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (webdav);
#line 95 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (cal);
#line 95 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (new_source);
#line 659 "WebBackend.c"
								goto __catch0_g_error;
							}
#line 95 "../plugins/Web/WebBackend.vala"
							_tmp32_ = webdav;
#line 95 "../plugins/Web/WebBackend.vala"
							g_object_set (_tmp32_, "uri", _tmp26_, NULL);
#line 99 "../plugins/Web/WebBackend.vala"
							_g_uri_unref0 (_tmp26_);
#line 99 "../plugins/Web/WebBackend.vala"
							break;
#line 670 "WebBackend.c"
						}
					}
				} else if (_tmp25_ == ((0 != _tmp24_label1) ? _tmp24_label1 : (_tmp24_label1 = g_quark_from_static_string ("keep_copy")))) {
#line 92 "../plugins/Web/WebBackend.vala"
					switch (0) {
#line 676 "WebBackend.c"
						default:
						{
							ESourceOffline* _tmp33_;
							MayaPlacementWidget* _tmp34_;
							GtkWidget* _tmp35_;
							gboolean _tmp36_;
							gboolean _tmp37_;
#line 101 "../plugins/Web/WebBackend.vala"
							_tmp33_ = offline;
#line 101 "../plugins/Web/WebBackend.vala"
							_tmp34_ = widget;
#line 101 "../plugins/Web/WebBackend.vala"
							_tmp35_ = _tmp34_->widget;
#line 101 "../plugins/Web/WebBackend.vala"
							_tmp36_ = gtk_toggle_button_get_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_check_button_get_type (), GtkCheckButton));
#line 101 "../plugins/Web/WebBackend.vala"
							_tmp37_ = _tmp36_;
#line 101 "../plugins/Web/WebBackend.vala"
							e_source_offline_set_stay_synchronized (_tmp33_, _tmp37_);
#line 102 "../plugins/Web/WebBackend.vala"
							break;
#line 698 "WebBackend.c"
						}
					}
				}
#line 91 "../plugins/Web/WebBackend.vala"
				_g_object_unref0 (widget);
#line 704 "WebBackend.c"
			}
#line 91 "../plugins/Web/WebBackend.vala"
			_g_object_unref0 (_widget_it);
#line 708 "WebBackend.c"
		}
#line 106 "../plugins/Web/WebBackend.vala"
		_tmp38_ = calendar_event_store_get_default ();
#line 106 "../plugins/Web/WebBackend.vala"
		calmodel = _tmp38_;
#line 107 "../plugins/Web/WebBackend.vala"
		_tmp39_ = calmodel;
#line 107 "../plugins/Web/WebBackend.vala"
		_tmp40_ = calendar_event_store_get_registry (_tmp39_);
#line 107 "../plugins/Web/WebBackend.vala"
		_tmp41_ = _tmp40_;
#line 107 "../plugins/Web/WebBackend.vala"
		_tmp42_ = _g_object_ref0 (_tmp41_);
#line 107 "../plugins/Web/WebBackend.vala"
		registry = _tmp42_;
#line 108 "../plugins/Web/WebBackend.vala"
		list = NULL;
#line 109 "../plugins/Web/WebBackend.vala"
		_tmp43_ = new_source;
#line 109 "../plugins/Web/WebBackend.vala"
		_tmp44_ = _g_object_ref0 (_tmp43_);
#line 109 "../plugins/Web/WebBackend.vala"
		list = g_list_append (list, _tmp44_);
#line 110 "../plugins/Web/WebBackend.vala"
		_tmp45_ = registry;
#line 110 "../plugins/Web/WebBackend.vala"
		_tmp46_ = list;
#line 110 "../plugins/Web/WebBackend.vala"
		e_source_registry_create_sources_sync (_tmp45_, _tmp46_, NULL, &_inner_error0_);
#line 110 "../plugins/Web/WebBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 110 "../plugins/Web/WebBackend.vala"
			(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 110 "../plugins/Web/WebBackend.vala"
			_g_object_unref0 (registry);
#line 110 "../plugins/Web/WebBackend.vala"
			_g_object_unref0 (calmodel);
#line 110 "../plugins/Web/WebBackend.vala"
			_g_object_unref0 (offline);
#line 110 "../plugins/Web/WebBackend.vala"
			_g_object_unref0 (webdav);
#line 110 "../plugins/Web/WebBackend.vala"
			_g_object_unref0 (cal);
#line 110 "../plugins/Web/WebBackend.vala"
			_g_object_unref0 (new_source);
#line 754 "WebBackend.c"
			goto __catch0_g_error;
		}
#line 111 "../plugins/Web/WebBackend.vala"
		_tmp47_ = calmodel;
#line 111 "../plugins/Web/WebBackend.vala"
		_tmp48_ = new_source;
#line 111 "../plugins/Web/WebBackend.vala"
		calendar_event_store_add_source (_tmp47_, _tmp48_);
#line 112 "../plugins/Web/WebBackend.vala"
		if (set_default) {
#line 765 "WebBackend.c"
			ESourceRegistry* _tmp49_;
			ESource* _tmp50_;
#line 113 "../plugins/Web/WebBackend.vala"
			_tmp49_ = registry;
#line 113 "../plugins/Web/WebBackend.vala"
			_tmp50_ = new_source;
#line 113 "../plugins/Web/WebBackend.vala"
			g_object_set (_tmp49_, "default-calendar", _tmp50_, NULL);
#line 774 "WebBackend.c"
		}
#line 79 "../plugins/Web/WebBackend.vala"
		(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 79 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (registry);
#line 79 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (calmodel);
#line 79 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (offline);
#line 79 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (webdav);
#line 79 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (cal);
#line 79 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (new_source);
#line 790 "WebBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp51_;
		const gchar* _tmp52_;
#line 79 "../plugins/Web/WebBackend.vala"
		_error_ = _inner_error0_;
#line 79 "../plugins/Web/WebBackend.vala"
		_inner_error0_ = NULL;
#line 117 "../plugins/Web/WebBackend.vala"
		_tmp51_ = _error_;
#line 117 "../plugins/Web/WebBackend.vala"
		_tmp52_ = _tmp51_->message;
#line 117 "../plugins/Web/WebBackend.vala"
		g_critical ("WebBackend.vala:117: %s", _tmp52_);
#line 79 "../plugins/Web/WebBackend.vala"
		_g_error_free0 (_error_);
#line 810 "WebBackend.c"
	}
	__finally0:
#line 79 "../plugins/Web/WebBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../plugins/Web/WebBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "../plugins/Web/WebBackend.vala"
		g_clear_error (&_inner_error0_);
#line 79 "../plugins/Web/WebBackend.vala"
		return;
#line 821 "WebBackend.c"
	}
}

static void
maya_web_backend_real_modify_calendar (MayaBackend* base,
                                       const gchar* name,
                                       const gchar* color,
                                       gboolean set_default,
                                       GeeCollection* widgets,
                                       ESource* source)
{
	MayaWebBackend * self;
	GError* _inner_error0_ = NULL;
#line 121 "../plugins/Web/WebBackend.vala"
	self = (MayaWebBackend*) base;
#line 121 "../plugins/Web/WebBackend.vala"
	g_return_if_fail (name != NULL);
#line 121 "../plugins/Web/WebBackend.vala"
	g_return_if_fail (color != NULL);
#line 121 "../plugins/Web/WebBackend.vala"
	g_return_if_fail (widgets != NULL);
#line 121 "../plugins/Web/WebBackend.vala"
	g_return_if_fail (source != NULL);
#line 845 "WebBackend.c"
	{
		ESourceCalendar* cal = NULL;
		ESourceExtension* _tmp0_;
		ESourceCalendar* _tmp1_;
		ESourceCalendar* _tmp2_;
		ESourceWebdav* webdav = NULL;
		ESourceExtension* _tmp3_;
		ESourceWebdav* _tmp4_;
		ESourceOffline* offline = NULL;
		ESourceExtension* _tmp5_;
		ESourceOffline* _tmp6_;
#line 123 "../plugins/Web/WebBackend.vala"
		e_source_set_display_name (source, name);
#line 124 "../plugins/Web/WebBackend.vala"
		_tmp0_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
#line 124 "../plugins/Web/WebBackend.vala"
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_calendar_get_type (), ESourceCalendar));
#line 124 "../plugins/Web/WebBackend.vala"
		cal = _tmp1_;
#line 125 "../plugins/Web/WebBackend.vala"
		_tmp2_ = cal;
#line 125 "../plugins/Web/WebBackend.vala"
		e_source_selectable_set_color ((ESourceSelectable*) _tmp2_, color);
#line 126 "../plugins/Web/WebBackend.vala"
		_tmp3_ = e_source_get_extension (source, E_SOURCE_EXTENSION_WEBDAV_BACKEND);
#line 126 "../plugins/Web/WebBackend.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, e_source_webdav_get_type (), ESourceWebdav));
#line 126 "../plugins/Web/WebBackend.vala"
		webdav = _tmp4_;
#line 128 "../plugins/Web/WebBackend.vala"
		e_source_get_extension (source, E_SOURCE_EXTENSION_AUTHENTICATION);
#line 129 "../plugins/Web/WebBackend.vala"
		_tmp5_ = e_source_get_extension (source, E_SOURCE_EXTENSION_OFFLINE);
#line 129 "../plugins/Web/WebBackend.vala"
		_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, e_source_offline_get_type (), ESourceOffline));
#line 129 "../plugins/Web/WebBackend.vala"
		offline = _tmp6_;
#line 883 "WebBackend.c"
		{
			GeeIterator* _widget_it = NULL;
			GeeIterator* _tmp7_;
#line 130 "../plugins/Web/WebBackend.vala"
			_tmp7_ = gee_iterable_iterator ((GeeIterable*) widgets);
#line 130 "../plugins/Web/WebBackend.vala"
			_widget_it = _tmp7_;
#line 130 "../plugins/Web/WebBackend.vala"
			while (TRUE) {
#line 893 "WebBackend.c"
				GeeIterator* _tmp8_;
				MayaPlacementWidget* widget = NULL;
				GeeIterator* _tmp9_;
				gpointer _tmp10_;
				MayaPlacementWidget* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
				GQuark _tmp15_ = 0U;
#line 131 "../plugins/Web/WebBackend.vala"
				static GQuark _tmp14_label0 = 0;
#line 131 "../plugins/Web/WebBackend.vala"
				static GQuark _tmp14_label1 = 0;
#line 130 "../plugins/Web/WebBackend.vala"
				_tmp8_ = _widget_it;
#line 130 "../plugins/Web/WebBackend.vala"
				if (!gee_iterator_next (_tmp8_)) {
#line 130 "../plugins/Web/WebBackend.vala"
					break;
#line 912 "WebBackend.c"
				}
#line 130 "../plugins/Web/WebBackend.vala"
				_tmp9_ = _widget_it;
#line 130 "../plugins/Web/WebBackend.vala"
				_tmp10_ = gee_iterator_get (_tmp9_);
#line 130 "../plugins/Web/WebBackend.vala"
				widget = (MayaPlacementWidget*) _tmp10_;
#line 131 "../plugins/Web/WebBackend.vala"
				_tmp11_ = widget;
#line 131 "../plugins/Web/WebBackend.vala"
				_tmp12_ = _tmp11_->ref_name;
#line 131 "../plugins/Web/WebBackend.vala"
				_tmp13_ = _tmp12_;
#line 131 "../plugins/Web/WebBackend.vala"
				_tmp15_ = (NULL == _tmp13_) ? 0 : g_quark_from_string (_tmp13_);
#line 131 "../plugins/Web/WebBackend.vala"
				if (_tmp15_ == ((0 != _tmp14_label0) ? _tmp14_label0 : (_tmp14_label0 = g_quark_from_static_string ("url_entry")))) {
#line 131 "../plugins/Web/WebBackend.vala"
					switch (0) {
#line 932 "WebBackend.c"
						default:
						{
							GUri* _tmp16_ = NULL;
							MayaPlacementWidget* _tmp17_;
							GtkWidget* _tmp18_;
							const gchar* _tmp19_;
							const gchar* _tmp20_;
							GUri* _tmp21_;
							ESourceWebdav* _tmp22_;
#line 134 "../plugins/Web/WebBackend.vala"
							_tmp17_ = widget;
#line 134 "../plugins/Web/WebBackend.vala"
							_tmp18_ = _tmp17_->widget;
#line 134 "../plugins/Web/WebBackend.vala"
							_tmp19_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_entry_get_type (), GtkEntry));
#line 134 "../plugins/Web/WebBackend.vala"
							_tmp20_ = _tmp19_;
#line 134 "../plugins/Web/WebBackend.vala"
							_tmp21_ = g_uri_parse (_tmp20_, G_URI_FLAGS_NONE, &_inner_error0_);
#line 134 "../plugins/Web/WebBackend.vala"
							_tmp16_ = _tmp21_;
#line 134 "../plugins/Web/WebBackend.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (widget);
#line 134 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (_widget_it);
#line 134 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (offline);
#line 134 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (webdav);
#line 134 "../plugins/Web/WebBackend.vala"
								_g_object_unref0 (cal);
#line 966 "WebBackend.c"
								goto __catch0_g_error;
							}
#line 134 "../plugins/Web/WebBackend.vala"
							_tmp22_ = webdav;
#line 134 "../plugins/Web/WebBackend.vala"
							g_object_set (_tmp22_, "uri", _tmp16_, NULL);
#line 138 "../plugins/Web/WebBackend.vala"
							_g_uri_unref0 (_tmp16_);
#line 138 "../plugins/Web/WebBackend.vala"
							break;
#line 977 "WebBackend.c"
						}
					}
				} else if (_tmp15_ == ((0 != _tmp14_label1) ? _tmp14_label1 : (_tmp14_label1 = g_quark_from_static_string ("keep_copy")))) {
#line 131 "../plugins/Web/WebBackend.vala"
					switch (0) {
#line 983 "WebBackend.c"
						default:
						{
							ESourceOffline* _tmp23_;
							MayaPlacementWidget* _tmp24_;
							GtkWidget* _tmp25_;
							gboolean _tmp26_;
							gboolean _tmp27_;
#line 140 "../plugins/Web/WebBackend.vala"
							_tmp23_ = offline;
#line 140 "../plugins/Web/WebBackend.vala"
							_tmp24_ = widget;
#line 140 "../plugins/Web/WebBackend.vala"
							_tmp25_ = _tmp24_->widget;
#line 140 "../plugins/Web/WebBackend.vala"
							_tmp26_ = gtk_toggle_button_get_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_check_button_get_type (), GtkCheckButton));
#line 140 "../plugins/Web/WebBackend.vala"
							_tmp27_ = _tmp26_;
#line 140 "../plugins/Web/WebBackend.vala"
							e_source_offline_set_stay_synchronized (_tmp23_, _tmp27_);
#line 141 "../plugins/Web/WebBackend.vala"
							break;
#line 1005 "WebBackend.c"
						}
					}
				}
#line 130 "../plugins/Web/WebBackend.vala"
				_g_object_unref0 (widget);
#line 1011 "WebBackend.c"
			}
#line 130 "../plugins/Web/WebBackend.vala"
			_g_object_unref0 (_widget_it);
#line 1015 "WebBackend.c"
		}
#line 145 "../plugins/Web/WebBackend.vala"
		e_source_write (source, NULL, NULL, NULL);
#line 146 "../plugins/Web/WebBackend.vala"
		if (set_default) {
#line 1021 "WebBackend.c"
			ESourceRegistry* registry = NULL;
			ESourceRegistry* _tmp28_;
			ESourceRegistry* _tmp29_;
#line 147 "../plugins/Web/WebBackend.vala"
			_tmp28_ = e_source_registry_new_sync (NULL, &_inner_error0_);
#line 147 "../plugins/Web/WebBackend.vala"
			registry = _tmp28_;
#line 147 "../plugins/Web/WebBackend.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../plugins/Web/WebBackend.vala"
				_g_object_unref0 (offline);
#line 147 "../plugins/Web/WebBackend.vala"
				_g_object_unref0 (webdav);
#line 147 "../plugins/Web/WebBackend.vala"
				_g_object_unref0 (cal);
#line 1037 "WebBackend.c"
				goto __catch0_g_error;
			}
#line 148 "../plugins/Web/WebBackend.vala"
			_tmp29_ = registry;
#line 148 "../plugins/Web/WebBackend.vala"
			g_object_set (_tmp29_, "default-calendar", source, NULL);
#line 146 "../plugins/Web/WebBackend.vala"
			_g_object_unref0 (registry);
#line 1046 "WebBackend.c"
		}
#line 122 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (offline);
#line 122 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (webdav);
#line 122 "../plugins/Web/WebBackend.vala"
		_g_object_unref0 (cal);
#line 1054 "WebBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 122 "../plugins/Web/WebBackend.vala"
		_error_ = _inner_error0_;
#line 122 "../plugins/Web/WebBackend.vala"
		_inner_error0_ = NULL;
#line 152 "../plugins/Web/WebBackend.vala"
		_tmp30_ = _error_;
#line 152 "../plugins/Web/WebBackend.vala"
		_tmp31_ = _tmp30_->message;
#line 152 "../plugins/Web/WebBackend.vala"
		g_critical ("WebBackend.vala:152: %s", _tmp31_);
#line 122 "../plugins/Web/WebBackend.vala"
		_g_error_free0 (_error_);
#line 1074 "WebBackend.c"
	}
	__finally0:
#line 122 "../plugins/Web/WebBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "../plugins/Web/WebBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 122 "../plugins/Web/WebBackend.vala"
		g_clear_error (&_inner_error0_);
#line 122 "../plugins/Web/WebBackend.vala"
		return;
#line 1085 "WebBackend.c"
	}
}

static void
maya_web_backend_class_init (MayaWebBackendClass * klass,
                             gpointer klass_data)
{
#line 16 "../plugins/Web/WebBackend.vala"
	maya_web_backend_parent_class = g_type_class_peek_parent (klass);
#line 1095 "WebBackend.c"
}

static void
maya_web_backend_maya_backend_interface_init (MayaBackendIface * iface,
                                              gpointer iface_data)
{
#line 16 "../plugins/Web/WebBackend.vala"
	maya_web_backend_maya_backend_parent_iface = g_type_interface_peek_parent (iface);
#line 16 "../plugins/Web/WebBackend.vala"
	iface->get_name = (gchar* (*) (MayaBackend*)) maya_web_backend_real_get_name;
#line 16 "../plugins/Web/WebBackend.vala"
	iface->get_uid = (gchar* (*) (MayaBackend*)) maya_web_backend_real_get_uid;
#line 16 "../plugins/Web/WebBackend.vala"
	iface->get_new_calendar_widget = (GeeCollection* (*) (MayaBackend*, ESource*)) maya_web_backend_real_get_new_calendar_widget;
#line 16 "../plugins/Web/WebBackend.vala"
	iface->add_new_calendar = (void (*) (MayaBackend*, const gchar*, const gchar*, gboolean, GeeCollection*)) maya_web_backend_real_add_new_calendar;
#line 16 "../plugins/Web/WebBackend.vala"
	iface->modify_calendar = (void (*) (MayaBackend*, const gchar*, const gchar*, gboolean, GeeCollection*, ESource*)) maya_web_backend_real_modify_calendar;
#line 1114 "WebBackend.c"
}

static void
maya_web_backend_instance_init (MayaWebBackend * self,
                                gpointer klass)
{
}

static GType
maya_web_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MayaWebBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) maya_web_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MayaWebBackend), 0, (GInstanceInitFunc) maya_web_backend_instance_init, NULL };
	static const GInterfaceInfo maya_backend_info = { (GInterfaceInitFunc) maya_web_backend_maya_backend_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType maya_web_backend_type_id;
	maya_web_backend_type_id = g_type_register_static (G_TYPE_OBJECT, "MayaWebBackend", &g_define_type_info, 0);
	g_type_add_interface_static (maya_web_backend_type_id, MAYA_TYPE_BACKEND, &maya_backend_info);
	return maya_web_backend_type_id;
}

GType
maya_web_backend_get_type (void)
{
	static volatile gsize maya_web_backend_type_id__once = 0;
	if (g_once_init_enter (&maya_web_backend_type_id__once)) {
		GType maya_web_backend_type_id;
		maya_web_backend_type_id = maya_web_backend_get_type_once ();
		g_once_init_leave (&maya_web_backend_type_id__once, maya_web_backend_type_id);
	}
	return maya_web_backend_type_id__once;
}

