/* TodayEventMonitor.c generated by valac 0.56.18, the Vala compiler
 * generated from TodayEventMonitor.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc. (https://elementary.io)
 *           2014 Corentin Noël <corentin@elementary.io>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include <libecal/libecal.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "elementary-calendar.h"
#include <libedataserver/libedataserver.h>
#include <libical-glib/libical-glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <granite.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CALENDAR_TYPE_TODAY_EVENT_MONITOR (calendar_today_event_monitor_get_type ())
#define CALENDAR_TODAY_EVENT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CALENDAR_TYPE_TODAY_EVENT_MONITOR, CalendarTodayEventMonitor))
#define CALENDAR_TODAY_EVENT_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CALENDAR_TYPE_TODAY_EVENT_MONITOR, CalendarTodayEventMonitorClass))
#define CALENDAR_IS_TODAY_EVENT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CALENDAR_TYPE_TODAY_EVENT_MONITOR))
#define CALENDAR_IS_TODAY_EVENT_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CALENDAR_TYPE_TODAY_EVENT_MONITOR))
#define CALENDAR_TODAY_EVENT_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CALENDAR_TYPE_TODAY_EVENT_MONITOR, CalendarTodayEventMonitorClass))

typedef struct _CalendarTodayEventMonitor CalendarTodayEventMonitor;
typedef struct _CalendarTodayEventMonitorClass CalendarTodayEventMonitorClass;
typedef struct _CalendarTodayEventMonitorPrivate CalendarTodayEventMonitorPrivate;
enum  {
	CALENDAR_TODAY_EVENT_MONITOR_0_PROPERTY,
	CALENDAR_TODAY_EVENT_MONITOR_NUM_PROPERTIES
};
static GParamSpec* calendar_today_event_monitor_properties[CALENDAR_TODAY_EVENT_MONITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_ECalComponentAlarmTrigger_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentAlarmTrigger_free (var), NULL)))
#define __vala_ECalComponentAlarm_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentAlarm_free (var), NULL)))
typedef struct _Block8Data Block8Data;
typedef struct _CalendarTodayEventMonitorAddTimeoutData CalendarTodayEventMonitorAddTimeoutData;

struct _CalendarTodayEventMonitor {
	GObject parent_instance;
	CalendarTodayEventMonitorPrivate * priv;
};

struct _CalendarTodayEventMonitorClass {
	GObjectClass parent_class;
};

struct _CalendarTodayEventMonitorPrivate {
	GeeHashMultiMap* event_uids;
};

struct _Block5Data {
	int _ref_count_;
	CalendarTodayEventMonitor* self;
	ESource* source;
	GeeCollection* events;
};

struct _Block6Data {
	int _ref_count_;
	CalendarTodayEventMonitor* self;
	ESource* source;
	GeeCollection* events;
};

struct _Block7Data {
	int _ref_count_;
	CalendarTodayEventMonitor* self;
	ESource* source;
	GeeCollection* events;
};

struct _Block8Data {
	int _ref_count_;
	CalendarTodayEventMonitor* self;
	gchar* uid;
	ESource* source;
	ECalComponent* event;
	gpointer _async_data_;
};

struct _CalendarTodayEventMonitorAddTimeoutData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CalendarTodayEventMonitor* self;
	ESource* source;
	ECalComponent* event;
	guint interval;
	Block8Data* _data8_;
	gchar* _tmp0_;
	GeeHashMultiMap* _tmp1_;
};

static gint CalendarTodayEventMonitor_private_offset;
static gpointer calendar_today_event_monitor_parent_class = NULL;

VALA_EXTERN GType calendar_today_event_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CalendarTodayEventMonitor, g_object_unref)
static void calendar_today_event_monitor_load_today_events (CalendarTodayEventMonitor* self);
static void calendar_today_event_monitor_on_events_added (CalendarTodayEventMonitor* self,
                                                   ESource* source,
                                                   GeeCollection* events);
static void _calendar_today_event_monitor_on_events_added_calendar_event_store_events_added (CalendarEventStore* _sender,
                                                                                      ESource* source,
                                                                                      GeeCollection* events,
                                                                                      gpointer self);
static void calendar_today_event_monitor_on_events_updated (CalendarTodayEventMonitor* self,
                                                     ESource* source,
                                                     GeeCollection* events);
static void _calendar_today_event_monitor_on_events_updated_calendar_event_store_events_updated (CalendarEventStore* _sender,
                                                                                          ESource* source,
                                                                                          GeeCollection* events,
                                                                                          gpointer self);
static void calendar_today_event_monitor_on_events_removed (CalendarTodayEventMonitor* self,
                                                     ESource* source,
                                                     GeeCollection* events);
static void _calendar_today_event_monitor_on_events_removed_calendar_event_store_events_removed (CalendarEventStore* _sender,
                                                                                          ESource* source,
                                                                                          GeeCollection* events,
                                                                                          gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean __lambda197_ (Block5Data* _data5_);
static void calendar_today_event_monitor_add_event (CalendarTodayEventMonitor* self,
                                             ESource* source,
                                             ECalComponent* event);
static gboolean ___lambda197__gsource_func (gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean __lambda199_ (Block6Data* _data6_);
static void calendar_today_event_monitor_update_event (CalendarTodayEventMonitor* self,
                                                ESource* source,
                                                ECalComponent* event);
static gboolean ___lambda199__gsource_func (gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean __lambda200_ (Block7Data* _data7_);
static void calendar_today_event_monitor_remove_event (CalendarTodayEventMonitor* self,
                                                ESource* source,
                                                ECalComponent* event);
static gboolean ___lambda200__gsource_func (gpointer self);
static ECalComponentAlarmTrigger* _vala_ECalComponentAlarmTrigger_copy (ECalComponentAlarmTrigger* self);
static void _vala_ECalComponentAlarmTrigger_free (ECalComponentAlarmTrigger* self);
static void _vala_ECalComponentAlarm_free (ECalComponentAlarm* self);
static GTimeSpan calendar_today_event_monitor_time_until_now (CalendarTodayEventMonitor* self,
                                                       GDateTime* dt);
VALA_EXTERN void calendar_today_event_monitor_add_timeout (CalendarTodayEventMonitor* self,
                                               ESource* source,
                                               ECalComponent* event,
                                               guint interval,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
VALA_EXTERN void calendar_today_event_monitor_add_timeout_finish (CalendarTodayEventMonitor* self,
                                                      GAsyncResult* _res_);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void calendar_today_event_monitor_add_timeout_data_free (gpointer _data);
static gboolean calendar_today_event_monitor_add_timeout_co (CalendarTodayEventMonitorAddTimeoutData* _data_);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean __lambda198_ (Block8Data* _data8_);
VALA_EXTERN void calendar_today_event_monitor_send_event_notification (CalendarTodayEventMonitor* self,
                                                           ECalComponent* event,
                                                           const gchar* uid);
static gboolean ___lambda198__gsource_func (gpointer self);
VALA_EXTERN CalendarTodayEventMonitor* calendar_today_event_monitor_new (void);
VALA_EXTERN CalendarTodayEventMonitor* calendar_today_event_monitor_construct (GType object_type);
static GObject * calendar_today_event_monitor_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static gboolean _calendar_today_event_monitor___lambda201_ (CalendarTodayEventMonitor* self);
static gboolean __calendar_today_event_monitor___lambda201__gsource_func (gpointer self);
static void calendar_today_event_monitor_finalize (GObject * obj);
static GType calendar_today_event_monitor_get_type_once (void);

static inline gpointer
calendar_today_event_monitor_get_instance_private (CalendarTodayEventMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, CalendarTodayEventMonitor_private_offset);
}

static void
_calendar_today_event_monitor_on_events_added_calendar_event_store_events_added (CalendarEventStore* _sender,
                                                                                 ESource* source,
                                                                                 GeeCollection* events,
                                                                                 gpointer self)
{
#line 35 "../src/TodayEventMonitor.vala"
	calendar_today_event_monitor_on_events_added ((CalendarTodayEventMonitor*) self, source, events);
#line 234 "TodayEventMonitor.c"
}

static void
_calendar_today_event_monitor_on_events_updated_calendar_event_store_events_updated (CalendarEventStore* _sender,
                                                                                     ESource* source,
                                                                                     GeeCollection* events,
                                                                                     gpointer self)
{
#line 36 "../src/TodayEventMonitor.vala"
	calendar_today_event_monitor_on_events_updated ((CalendarTodayEventMonitor*) self, source, events);
#line 245 "TodayEventMonitor.c"
}

static void
_calendar_today_event_monitor_on_events_removed_calendar_event_store_events_removed (CalendarEventStore* _sender,
                                                                                     ESource* source,
                                                                                     GeeCollection* events,
                                                                                     gpointer self)
{
#line 37 "../src/TodayEventMonitor.vala"
	calendar_today_event_monitor_on_events_removed ((CalendarTodayEventMonitor*) self, source, events);
#line 256 "TodayEventMonitor.c"
}

static void
calendar_today_event_monitor_load_today_events (CalendarTodayEventMonitor* self)
{
	GeeHashMultiMap* _tmp0_;
	CalendarEventStore* model = NULL;
	CalendarEventStore* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
#line 32 "../src/TodayEventMonitor.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/TodayEventMonitor.vala"
	_tmp0_ = gee_hash_multi_map_new (e_cal_component_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 33 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (self->priv->event_uids);
#line 33 "../src/TodayEventMonitor.vala"
	self->priv->event_uids = _tmp0_;
#line 34 "../src/TodayEventMonitor.vala"
	_tmp1_ = calendar_event_store_new ();
#line 34 "../src/TodayEventMonitor.vala"
	model = _tmp1_;
#line 35 "../src/TodayEventMonitor.vala"
	g_signal_connect_object (model, "events-added", (GCallback) _calendar_today_event_monitor_on_events_added_calendar_event_store_events_added, self, 0);
#line 36 "../src/TodayEventMonitor.vala"
	g_signal_connect_object (model, "events-updated", (GCallback) _calendar_today_event_monitor_on_events_updated_calendar_event_store_events_updated, self, 0);
#line 37 "../src/TodayEventMonitor.vala"
	g_signal_connect_object (model, "events-removed", (GCallback) _calendar_today_event_monitor_on_events_removed_calendar_event_store_events_removed, self, 0);
#line 38 "../src/TodayEventMonitor.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 38 "../src/TodayEventMonitor.vala"
	_tmp3_ = calendar_util_datetime_get_start_of_month (_tmp2_);
#line 38 "../src/TodayEventMonitor.vala"
	_tmp4_ = _tmp3_;
#line 38 "../src/TodayEventMonitor.vala"
	calendar_event_store_set_month_start (model, _tmp4_);
#line 38 "../src/TodayEventMonitor.vala"
	_g_date_time_unref0 (_tmp4_);
#line 32 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (model);
#line 298 "TodayEventMonitor.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/TodayEventMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 306 "TodayEventMonitor.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 41 "../src/TodayEventMonitor.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 41 "../src/TodayEventMonitor.vala"
	return _data5_;
#line 316 "TodayEventMonitor.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 41 "../src/TodayEventMonitor.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 326 "TodayEventMonitor.c"
		CalendarTodayEventMonitor* self;
#line 41 "../src/TodayEventMonitor.vala"
		self = _data5_->self;
#line 41 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_data5_->source);
#line 41 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_data5_->events);
#line 41 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (self);
#line 41 "../src/TodayEventMonitor.vala"
		g_slice_free (Block5Data, _data5_);
#line 338 "TodayEventMonitor.c"
	}
}

static gboolean
__lambda197_ (Block5Data* _data5_)
{
	CalendarTodayEventMonitor* self;
	gboolean result;
#line 47 "../src/TodayEventMonitor.vala"
	self = _data5_->self;
#line 349 "TodayEventMonitor.c"
	{
		GeeIterator* _event_it = NULL;
		GeeIterator* _tmp0_;
#line 48 "../src/TodayEventMonitor.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) _data5_->events);
#line 48 "../src/TodayEventMonitor.vala"
		_event_it = _tmp0_;
#line 48 "../src/TodayEventMonitor.vala"
		while (TRUE) {
#line 359 "TodayEventMonitor.c"
			GeeIterator* _tmp1_;
			ECalComponent* event = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ECalComponent* _tmp4_;
#line 48 "../src/TodayEventMonitor.vala"
			_tmp1_ = _event_it;
#line 48 "../src/TodayEventMonitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 48 "../src/TodayEventMonitor.vala"
				break;
#line 371 "TodayEventMonitor.c"
			}
#line 48 "../src/TodayEventMonitor.vala"
			_tmp2_ = _event_it;
#line 48 "../src/TodayEventMonitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 48 "../src/TodayEventMonitor.vala"
			event = (ECalComponent*) _tmp3_;
#line 49 "../src/TodayEventMonitor.vala"
			_tmp4_ = event;
#line 49 "../src/TodayEventMonitor.vala"
			calendar_today_event_monitor_add_event (self, _data5_->source, _tmp4_);
#line 48 "../src/TodayEventMonitor.vala"
			_g_object_unref0 (event);
#line 385 "TodayEventMonitor.c"
		}
#line 48 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_event_it);
#line 389 "TodayEventMonitor.c"
	}
#line 51 "../src/TodayEventMonitor.vala"
	result = FALSE;
#line 51 "../src/TodayEventMonitor.vala"
	return result;
#line 395 "TodayEventMonitor.c"
}

static gboolean
___lambda197__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda197_ (self);
#line 47 "../src/TodayEventMonitor.vala"
	return result;
#line 405 "TodayEventMonitor.c"
}

static void
calendar_today_event_monitor_on_events_added (CalendarTodayEventMonitor* self,
                                              ESource* source,
                                              GeeCollection* events)
{
	Block5Data* _data5_;
	ESource* _tmp0_;
	GeeCollection* _tmp1_;
	ESourceAlarms* extension = NULL;
	ESourceExtension* _tmp2_;
	ESourceAlarms* _tmp3_;
	ESourceAlarms* _tmp4_;
#line 41 "../src/TodayEventMonitor.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/TodayEventMonitor.vala"
	g_return_if_fail (source != NULL);
#line 41 "../src/TodayEventMonitor.vala"
	g_return_if_fail (events != NULL);
#line 41 "../src/TodayEventMonitor.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 41 "../src/TodayEventMonitor.vala"
	_data5_->_ref_count_ = 1;
#line 41 "../src/TodayEventMonitor.vala"
	_data5_->self = g_object_ref (self);
#line 41 "../src/TodayEventMonitor.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 41 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data5_->source);
#line 41 "../src/TodayEventMonitor.vala"
	_data5_->source = _tmp0_;
#line 41 "../src/TodayEventMonitor.vala"
	_tmp1_ = _g_object_ref0 (events);
#line 41 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data5_->events);
#line 41 "../src/TodayEventMonitor.vala"
	_data5_->events = _tmp1_;
#line 42 "../src/TodayEventMonitor.vala"
	_tmp2_ = e_source_get_extension (_data5_->source, E_SOURCE_EXTENSION_ALARMS);
#line 42 "../src/TodayEventMonitor.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, e_source_alarms_get_type (), ESourceAlarms));
#line 42 "../src/TodayEventMonitor.vala"
	extension = _tmp3_;
#line 43 "../src/TodayEventMonitor.vala"
	_tmp4_ = extension;
#line 43 "../src/TodayEventMonitor.vala"
	if (e_source_alarms_get_include_me (_tmp4_) == FALSE) {
#line 44 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (extension);
#line 44 "../src/TodayEventMonitor.vala"
		block5_data_unref (_data5_);
#line 44 "../src/TodayEventMonitor.vala"
		_data5_ = NULL;
#line 44 "../src/TodayEventMonitor.vala"
		return;
#line 462 "TodayEventMonitor.c"
	}
#line 47 "../src/TodayEventMonitor.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda197__gsource_func, block5_data_ref (_data5_), block5_data_unref);
#line 41 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (extension);
#line 41 "../src/TodayEventMonitor.vala"
	block5_data_unref (_data5_);
#line 41 "../src/TodayEventMonitor.vala"
	_data5_ = NULL;
#line 472 "TodayEventMonitor.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 55 "../src/TodayEventMonitor.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 55 "../src/TodayEventMonitor.vala"
	return _data6_;
#line 482 "TodayEventMonitor.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 55 "../src/TodayEventMonitor.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 492 "TodayEventMonitor.c"
		CalendarTodayEventMonitor* self;
#line 55 "../src/TodayEventMonitor.vala"
		self = _data6_->self;
#line 55 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_data6_->source);
#line 55 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_data6_->events);
#line 55 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (self);
#line 55 "../src/TodayEventMonitor.vala"
		g_slice_free (Block6Data, _data6_);
#line 504 "TodayEventMonitor.c"
	}
}

static gboolean
__lambda199_ (Block6Data* _data6_)
{
	CalendarTodayEventMonitor* self;
	gboolean result;
#line 56 "../src/TodayEventMonitor.vala"
	self = _data6_->self;
#line 515 "TodayEventMonitor.c"
	{
		GeeIterator* _event_it = NULL;
		GeeIterator* _tmp0_;
#line 57 "../src/TodayEventMonitor.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) _data6_->events);
#line 57 "../src/TodayEventMonitor.vala"
		_event_it = _tmp0_;
#line 57 "../src/TodayEventMonitor.vala"
		while (TRUE) {
#line 525 "TodayEventMonitor.c"
			GeeIterator* _tmp1_;
			ECalComponent* event = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ECalComponent* _tmp4_;
#line 57 "../src/TodayEventMonitor.vala"
			_tmp1_ = _event_it;
#line 57 "../src/TodayEventMonitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 57 "../src/TodayEventMonitor.vala"
				break;
#line 537 "TodayEventMonitor.c"
			}
#line 57 "../src/TodayEventMonitor.vala"
			_tmp2_ = _event_it;
#line 57 "../src/TodayEventMonitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 57 "../src/TodayEventMonitor.vala"
			event = (ECalComponent*) _tmp3_;
#line 58 "../src/TodayEventMonitor.vala"
			_tmp4_ = event;
#line 58 "../src/TodayEventMonitor.vala"
			calendar_today_event_monitor_update_event (self, _data6_->source, _tmp4_);
#line 57 "../src/TodayEventMonitor.vala"
			_g_object_unref0 (event);
#line 551 "TodayEventMonitor.c"
		}
#line 57 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_event_it);
#line 555 "TodayEventMonitor.c"
	}
#line 60 "../src/TodayEventMonitor.vala"
	result = FALSE;
#line 60 "../src/TodayEventMonitor.vala"
	return result;
#line 561 "TodayEventMonitor.c"
}

static gboolean
___lambda199__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda199_ (self);
#line 56 "../src/TodayEventMonitor.vala"
	return result;
#line 571 "TodayEventMonitor.c"
}

static void
calendar_today_event_monitor_on_events_updated (CalendarTodayEventMonitor* self,
                                                ESource* source,
                                                GeeCollection* events)
{
	Block6Data* _data6_;
	ESource* _tmp0_;
	GeeCollection* _tmp1_;
#line 55 "../src/TodayEventMonitor.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/TodayEventMonitor.vala"
	g_return_if_fail (source != NULL);
#line 55 "../src/TodayEventMonitor.vala"
	g_return_if_fail (events != NULL);
#line 55 "../src/TodayEventMonitor.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 55 "../src/TodayEventMonitor.vala"
	_data6_->_ref_count_ = 1;
#line 55 "../src/TodayEventMonitor.vala"
	_data6_->self = g_object_ref (self);
#line 55 "../src/TodayEventMonitor.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 55 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data6_->source);
#line 55 "../src/TodayEventMonitor.vala"
	_data6_->source = _tmp0_;
#line 55 "../src/TodayEventMonitor.vala"
	_tmp1_ = _g_object_ref0 (events);
#line 55 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data6_->events);
#line 55 "../src/TodayEventMonitor.vala"
	_data6_->events = _tmp1_;
#line 56 "../src/TodayEventMonitor.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda199__gsource_func, block6_data_ref (_data6_), block6_data_unref);
#line 55 "../src/TodayEventMonitor.vala"
	block6_data_unref (_data6_);
#line 55 "../src/TodayEventMonitor.vala"
	_data6_ = NULL;
#line 612 "TodayEventMonitor.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 64 "../src/TodayEventMonitor.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 64 "../src/TodayEventMonitor.vala"
	return _data7_;
#line 622 "TodayEventMonitor.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 64 "../src/TodayEventMonitor.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 632 "TodayEventMonitor.c"
		CalendarTodayEventMonitor* self;
#line 64 "../src/TodayEventMonitor.vala"
		self = _data7_->self;
#line 64 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_data7_->source);
#line 64 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_data7_->events);
#line 64 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (self);
#line 64 "../src/TodayEventMonitor.vala"
		g_slice_free (Block7Data, _data7_);
#line 644 "TodayEventMonitor.c"
	}
}

static gboolean
__lambda200_ (Block7Data* _data7_)
{
	CalendarTodayEventMonitor* self;
	gboolean result;
#line 65 "../src/TodayEventMonitor.vala"
	self = _data7_->self;
#line 655 "TodayEventMonitor.c"
	{
		GeeIterator* _event_it = NULL;
		GeeIterator* _tmp0_;
#line 66 "../src/TodayEventMonitor.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) _data7_->events);
#line 66 "../src/TodayEventMonitor.vala"
		_event_it = _tmp0_;
#line 66 "../src/TodayEventMonitor.vala"
		while (TRUE) {
#line 665 "TodayEventMonitor.c"
			GeeIterator* _tmp1_;
			ECalComponent* event = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ECalComponent* _tmp4_;
#line 66 "../src/TodayEventMonitor.vala"
			_tmp1_ = _event_it;
#line 66 "../src/TodayEventMonitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 66 "../src/TodayEventMonitor.vala"
				break;
#line 677 "TodayEventMonitor.c"
			}
#line 66 "../src/TodayEventMonitor.vala"
			_tmp2_ = _event_it;
#line 66 "../src/TodayEventMonitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 66 "../src/TodayEventMonitor.vala"
			event = (ECalComponent*) _tmp3_;
#line 67 "../src/TodayEventMonitor.vala"
			_tmp4_ = event;
#line 67 "../src/TodayEventMonitor.vala"
			calendar_today_event_monitor_remove_event (self, _data7_->source, _tmp4_);
#line 66 "../src/TodayEventMonitor.vala"
			_g_object_unref0 (event);
#line 691 "TodayEventMonitor.c"
		}
#line 66 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_event_it);
#line 695 "TodayEventMonitor.c"
	}
#line 69 "../src/TodayEventMonitor.vala"
	result = FALSE;
#line 69 "../src/TodayEventMonitor.vala"
	return result;
#line 701 "TodayEventMonitor.c"
}

static gboolean
___lambda200__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda200_ (self);
#line 65 "../src/TodayEventMonitor.vala"
	return result;
#line 711 "TodayEventMonitor.c"
}

static void
calendar_today_event_monitor_on_events_removed (CalendarTodayEventMonitor* self,
                                                ESource* source,
                                                GeeCollection* events)
{
	Block7Data* _data7_;
	ESource* _tmp0_;
	GeeCollection* _tmp1_;
#line 64 "../src/TodayEventMonitor.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/TodayEventMonitor.vala"
	g_return_if_fail (source != NULL);
#line 64 "../src/TodayEventMonitor.vala"
	g_return_if_fail (events != NULL);
#line 64 "../src/TodayEventMonitor.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 64 "../src/TodayEventMonitor.vala"
	_data7_->_ref_count_ = 1;
#line 64 "../src/TodayEventMonitor.vala"
	_data7_->self = g_object_ref (self);
#line 64 "../src/TodayEventMonitor.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 64 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data7_->source);
#line 64 "../src/TodayEventMonitor.vala"
	_data7_->source = _tmp0_;
#line 64 "../src/TodayEventMonitor.vala"
	_tmp1_ = _g_object_ref0 (events);
#line 64 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data7_->events);
#line 64 "../src/TodayEventMonitor.vala"
	_data7_->events = _tmp1_;
#line 65 "../src/TodayEventMonitor.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda200__gsource_func, block7_data_ref (_data7_), block7_data_unref);
#line 64 "../src/TodayEventMonitor.vala"
	block7_data_unref (_data7_);
#line 64 "../src/TodayEventMonitor.vala"
	_data7_ = NULL;
#line 752 "TodayEventMonitor.c"
}

static ECalComponentAlarmTrigger*
_vala_ECalComponentAlarmTrigger_copy (ECalComponentAlarmTrigger* self)
{
#line 83 "../src/TodayEventMonitor.vala"
	return g_boxed_copy (e_cal_component_alarm_trigger_get_type (), self);
#line 760 "TodayEventMonitor.c"
}

static gpointer
__vala_ECalComponentAlarmTrigger_copy0 (gpointer self)
{
#line 83 "../src/TodayEventMonitor.vala"
	return self ? _vala_ECalComponentAlarmTrigger_copy (self) : NULL;
#line 768 "TodayEventMonitor.c"
}

static void
_vala_ECalComponentAlarmTrigger_free (ECalComponentAlarmTrigger* self)
{
#line 83 "../src/TodayEventMonitor.vala"
	g_boxed_free (e_cal_component_alarm_trigger_get_type (), self);
#line 776 "TodayEventMonitor.c"
}

static void
_vala_ECalComponentAlarm_free (ECalComponentAlarm* self)
{
#line 89 "../src/TodayEventMonitor.vala"
	g_boxed_free (e_cal_component_alarm_get_type (), self);
#line 784 "TodayEventMonitor.c"
}

static void
_g_free0_ (gpointer var)
{
#line 76 "../src/TodayEventMonitor.vala"
	var = (g_free (var), NULL);
#line 792 "TodayEventMonitor.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 76 "../src/TodayEventMonitor.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 800 "TodayEventMonitor.c"
}

static void
calendar_today_event_monitor_add_event (CalendarTodayEventMonitor* self,
                                        ESource* source,
                                        ECalComponent* event)
{
	ICalComponent* comp = NULL;
	ICalComponent* _tmp0_;
	ICalComponent* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	ICalComponent* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GSList* _tmp9_;
#line 73 "../src/TodayEventMonitor.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/TodayEventMonitor.vala"
	g_return_if_fail (source != NULL);
#line 73 "../src/TodayEventMonitor.vala"
	g_return_if_fail (event != NULL);
#line 74 "../src/TodayEventMonitor.vala"
	_tmp0_ = e_cal_component_get_icalcomponent (event);
#line 74 "../src/TodayEventMonitor.vala"
	comp = _tmp0_;
#line 75 "../src/TodayEventMonitor.vala"
	_tmp1_ = comp;
#line 75 "../src/TodayEventMonitor.vala"
	_tmp2_ = i_cal_component_get_summary (_tmp1_);
#line 75 "../src/TodayEventMonitor.vala"
	_tmp3_ = e_source_dup_display_name (source);
#line 75 "../src/TodayEventMonitor.vala"
	_tmp4_ = _tmp3_;
#line 75 "../src/TodayEventMonitor.vala"
	_tmp5_ = comp;
#line 75 "../src/TodayEventMonitor.vala"
	_tmp6_ = i_cal_component_get_uid (_tmp5_);
#line 75 "../src/TodayEventMonitor.vala"
	_tmp7_ = g_strdup_printf ("Event [%s, %s, %s]", _tmp2_, _tmp4_, _tmp6_);
#line 75 "../src/TodayEventMonitor.vala"
	_tmp8_ = _tmp7_;
#line 75 "../src/TodayEventMonitor.vala"
	g_debug ("TodayEventMonitor.vala:75: %s", _tmp8_);
#line 75 "../src/TodayEventMonitor.vala"
	_g_free0 (_tmp8_);
#line 75 "../src/TodayEventMonitor.vala"
	_g_free0 (_tmp4_);
#line 76 "../src/TodayEventMonitor.vala"
	_tmp9_ = e_cal_component_get_alarm_uids (event);
#line 853 "TodayEventMonitor.c"
	{
		GSList* alarm_uid_collection = NULL;
		GSList* alarm_uid_it = NULL;
#line 76 "../src/TodayEventMonitor.vala"
		alarm_uid_collection = _tmp9_;
#line 76 "../src/TodayEventMonitor.vala"
		for (alarm_uid_it = alarm_uid_collection; alarm_uid_it != NULL; alarm_uid_it = alarm_uid_it->next) {
#line 861 "TodayEventMonitor.c"
			gchar* _tmp10_;
			gchar* alarm_uid = NULL;
#line 76 "../src/TodayEventMonitor.vala"
			_tmp10_ = g_strdup ((const gchar*) alarm_uid_it->data);
#line 76 "../src/TodayEventMonitor.vala"
			alarm_uid = _tmp10_;
#line 868 "TodayEventMonitor.c"
			{
				ECalComponentAlarm* e_alarm = NULL;
				const gchar* _tmp11_;
				ECalComponentAlarm* _tmp12_;
				ECalComponentAlarmAction action = 0;
				ECalComponentAlarm* _tmp13_;
#line 77 "../src/TodayEventMonitor.vala"
				_tmp11_ = alarm_uid;
#line 77 "../src/TodayEventMonitor.vala"
				_tmp12_ = e_cal_component_get_alarm (event, _tmp11_);
#line 77 "../src/TodayEventMonitor.vala"
				e_alarm = _tmp12_;
#line 80 "../src/TodayEventMonitor.vala"
				_tmp13_ = e_alarm;
#line 80 "../src/TodayEventMonitor.vala"
				action = e_cal_component_alarm_get_action (_tmp13_);
#line 81 "../src/TodayEventMonitor.vala"
				if (action == E_CAL_COMPONENT_ALARM_DISPLAY) {
#line 887 "TodayEventMonitor.c"
					ECalComponentAlarmTrigger* trigger = NULL;
					ECalComponentAlarm* _tmp14_;
					ECalComponentAlarmTrigger* _tmp15_;
					ECalComponentAlarmTrigger* _tmp16_;
					ECalComponentAlarmTrigger* _tmp17_;
#line 83 "../src/TodayEventMonitor.vala"
					_tmp14_ = e_alarm;
#line 83 "../src/TodayEventMonitor.vala"
					_tmp15_ = e_cal_component_alarm_get_trigger (_tmp14_);
#line 83 "../src/TodayEventMonitor.vala"
					_tmp16_ = __vala_ECalComponentAlarmTrigger_copy0 (_tmp15_);
#line 83 "../src/TodayEventMonitor.vala"
					__vala_ECalComponentAlarmTrigger_free0 (trigger);
#line 83 "../src/TodayEventMonitor.vala"
					trigger = _tmp16_;
#line 84 "../src/TodayEventMonitor.vala"
					_tmp17_ = trigger;
#line 84 "../src/TodayEventMonitor.vala"
					if (e_cal_component_alarm_trigger_get_kind (_tmp17_) == E_CAL_COMPONENT_ALARM_TRIGGER_RELATIVE_START) {
#line 907 "TodayEventMonitor.c"
						ICalDuration* duration = NULL;
						ECalComponentAlarmTrigger* _tmp18_;
						ICalDuration* _tmp19_;
						ICalDuration* _tmp20_;
						GDateTime* start_time = NULL;
						ICalComponent* _tmp21_;
						ICalTime* _tmp22_;
						ICalTime* _tmp23_;
						GDateTime* _tmp24_;
						GDateTime* _tmp25_;
						GDateTime* now = NULL;
						GDateTime* _tmp26_;
						GDateTime* _tmp27_;
						GDateTime* _tmp28_;
						GDateTime* _tmp29_;
						ICalDuration* _tmp30_;
						GDateTime* _tmp31_;
						GDateTime* _tmp32_;
						ICalDuration* _tmp33_;
						GDateTime* _tmp34_;
						GDateTime* _tmp35_;
						ICalDuration* _tmp36_;
						GDateTime* _tmp37_;
						GDateTime* _tmp38_;
						ICalDuration* _tmp39_;
						GDateTime* _tmp40_;
						GDateTime* _tmp41_;
						ICalDuration* _tmp42_;
						GDateTime* _tmp43_;
						gboolean _tmp44_ = FALSE;
						GDateTime* _tmp45_;
						GDateTime* _tmp46_;
#line 85 "../src/TodayEventMonitor.vala"
						_tmp18_ = trigger;
#line 85 "../src/TodayEventMonitor.vala"
						_tmp19_ = e_cal_component_alarm_trigger_get_duration (_tmp18_);
#line 85 "../src/TodayEventMonitor.vala"
						_tmp20_ = _g_object_ref0 (_tmp19_);
#line 85 "../src/TodayEventMonitor.vala"
						duration = _tmp20_;
#line 86 "../src/TodayEventMonitor.vala"
						_tmp21_ = comp;
#line 86 "../src/TodayEventMonitor.vala"
						_tmp22_ = i_cal_component_get_dtstart (_tmp21_);
#line 86 "../src/TodayEventMonitor.vala"
						_tmp23_ = _tmp22_;
#line 86 "../src/TodayEventMonitor.vala"
						_tmp24_ = calendar_util_icaltime_to_datetime (_tmp23_);
#line 86 "../src/TodayEventMonitor.vala"
						_tmp25_ = _tmp24_;
#line 86 "../src/TodayEventMonitor.vala"
						_g_object_unref0 (_tmp23_);
#line 86 "../src/TodayEventMonitor.vala"
						start_time = _tmp25_;
#line 87 "../src/TodayEventMonitor.vala"
						_tmp26_ = g_date_time_new_now_local ();
#line 87 "../src/TodayEventMonitor.vala"
						now = _tmp26_;
#line 88 "../src/TodayEventMonitor.vala"
						_tmp27_ = now;
#line 88 "../src/TodayEventMonitor.vala"
						_tmp28_ = start_time;
#line 88 "../src/TodayEventMonitor.vala"
						if (g_date_time_compare (_tmp27_, _tmp28_) > 0) {
#line 89 "../src/TodayEventMonitor.vala"
							_g_date_time_unref0 (now);
#line 89 "../src/TodayEventMonitor.vala"
							_g_date_time_unref0 (start_time);
#line 89 "../src/TodayEventMonitor.vala"
							_g_object_unref0 (duration);
#line 89 "../src/TodayEventMonitor.vala"
							__vala_ECalComponentAlarmTrigger_free0 (trigger);
#line 89 "../src/TodayEventMonitor.vala"
							__vala_ECalComponentAlarm_free0 (e_alarm);
#line 89 "../src/TodayEventMonitor.vala"
							_g_free0 (alarm_uid);
#line 89 "../src/TodayEventMonitor.vala"
							continue;
#line 986 "TodayEventMonitor.c"
						}
#line 91 "../src/TodayEventMonitor.vala"
						_tmp29_ = start_time;
#line 91 "../src/TodayEventMonitor.vala"
						_tmp30_ = duration;
#line 91 "../src/TodayEventMonitor.vala"
						_tmp31_ = g_date_time_add_weeks (_tmp29_, -((gint) i_cal_duration_get_weeks (_tmp30_)));
#line 91 "../src/TodayEventMonitor.vala"
						_g_date_time_unref0 (start_time);
#line 91 "../src/TodayEventMonitor.vala"
						start_time = _tmp31_;
#line 92 "../src/TodayEventMonitor.vala"
						_tmp32_ = start_time;
#line 92 "../src/TodayEventMonitor.vala"
						_tmp33_ = duration;
#line 92 "../src/TodayEventMonitor.vala"
						_tmp34_ = g_date_time_add_days (_tmp32_, -((gint) i_cal_duration_get_days (_tmp33_)));
#line 92 "../src/TodayEventMonitor.vala"
						_g_date_time_unref0 (start_time);
#line 92 "../src/TodayEventMonitor.vala"
						start_time = _tmp34_;
#line 93 "../src/TodayEventMonitor.vala"
						_tmp35_ = start_time;
#line 93 "../src/TodayEventMonitor.vala"
						_tmp36_ = duration;
#line 93 "../src/TodayEventMonitor.vala"
						_tmp37_ = g_date_time_add_hours (_tmp35_, -((gint) i_cal_duration_get_hours (_tmp36_)));
#line 93 "../src/TodayEventMonitor.vala"
						_g_date_time_unref0 (start_time);
#line 93 "../src/TodayEventMonitor.vala"
						start_time = _tmp37_;
#line 94 "../src/TodayEventMonitor.vala"
						_tmp38_ = start_time;
#line 94 "../src/TodayEventMonitor.vala"
						_tmp39_ = duration;
#line 94 "../src/TodayEventMonitor.vala"
						_tmp40_ = g_date_time_add_minutes (_tmp38_, -((gint) i_cal_duration_get_minutes (_tmp39_)));
#line 94 "../src/TodayEventMonitor.vala"
						_g_date_time_unref0 (start_time);
#line 94 "../src/TodayEventMonitor.vala"
						start_time = _tmp40_;
#line 95 "../src/TodayEventMonitor.vala"
						_tmp41_ = start_time;
#line 95 "../src/TodayEventMonitor.vala"
						_tmp42_ = duration;
#line 95 "../src/TodayEventMonitor.vala"
						_tmp43_ = g_date_time_add_seconds (_tmp41_, (gdouble) (-((gint) i_cal_duration_get_seconds (_tmp42_))));
#line 95 "../src/TodayEventMonitor.vala"
						_g_date_time_unref0 (start_time);
#line 95 "../src/TodayEventMonitor.vala"
						start_time = _tmp43_;
#line 96 "../src/TodayEventMonitor.vala"
						_tmp45_ = start_time;
#line 96 "../src/TodayEventMonitor.vala"
						_tmp46_ = now;
#line 96 "../src/TodayEventMonitor.vala"
						if (g_date_time_get_year (_tmp45_) == g_date_time_get_year (_tmp46_)) {
#line 1044 "TodayEventMonitor.c"
							GDateTime* _tmp47_;
							GDateTime* _tmp48_;
#line 96 "../src/TodayEventMonitor.vala"
							_tmp47_ = start_time;
#line 96 "../src/TodayEventMonitor.vala"
							_tmp48_ = now;
#line 96 "../src/TodayEventMonitor.vala"
							_tmp44_ = g_date_time_get_day_of_year (_tmp47_) == g_date_time_get_day_of_year (_tmp48_);
#line 1053 "TodayEventMonitor.c"
						} else {
#line 96 "../src/TodayEventMonitor.vala"
							_tmp44_ = FALSE;
#line 1057 "TodayEventMonitor.c"
						}
#line 96 "../src/TodayEventMonitor.vala"
						if (_tmp44_) {
#line 1061 "TodayEventMonitor.c"
							GTimeSpan time = 0LL;
							GDateTime* _tmp49_;
#line 97 "../src/TodayEventMonitor.vala"
							_tmp49_ = start_time;
#line 97 "../src/TodayEventMonitor.vala"
							time = calendar_today_event_monitor_time_until_now (self, _tmp49_);
#line 98 "../src/TodayEventMonitor.vala"
							if (time >= ((GTimeSpan) 0)) {
#line 99 "../src/TodayEventMonitor.vala"
								calendar_today_event_monitor_add_timeout (self, source, event, (guint) time, NULL, NULL);
#line 1072 "TodayEventMonitor.c"
							}
						}
#line 84 "../src/TodayEventMonitor.vala"
						_g_date_time_unref0 (now);
#line 84 "../src/TodayEventMonitor.vala"
						_g_date_time_unref0 (start_time);
#line 84 "../src/TodayEventMonitor.vala"
						_g_object_unref0 (duration);
#line 1081 "TodayEventMonitor.c"
					}
#line 81 "../src/TodayEventMonitor.vala"
					__vala_ECalComponentAlarmTrigger_free0 (trigger);
#line 1085 "TodayEventMonitor.c"
				} else {
					ICalComponent* _tmp50_;
					const gchar* _tmp51_;
					gchar* _tmp52_;
					gchar* _tmp53_;
					ICalComponent* _tmp54_;
					const gchar* _tmp55_;
					GEnumValue* _tmp56_;
#line 105 "../src/TodayEventMonitor.vala"
					_tmp50_ = comp;
#line 105 "../src/TodayEventMonitor.vala"
					_tmp51_ = i_cal_component_get_summary (_tmp50_);
#line 105 "../src/TodayEventMonitor.vala"
					_tmp52_ = e_source_dup_display_name (source);
#line 105 "../src/TodayEventMonitor.vala"
					_tmp53_ = _tmp52_;
#line 105 "../src/TodayEventMonitor.vala"
					_tmp54_ = comp;
#line 105 "../src/TodayEventMonitor.vala"
					_tmp55_ = i_cal_component_get_uid (_tmp54_);
#line 105 "../src/TodayEventMonitor.vala"
					_tmp56_ = g_enum_get_value (g_type_class_ref (e_cal_component_alarm_action_get_type ()), action);
#line 105 "../src/TodayEventMonitor.vala"
					g_warning ("TodayEventMonitor.vala:105: Event [%s, %s, %s]: Unhandled alarm action" \
": %s", _tmp51_, _tmp53_, _tmp55_, (_tmp56_ != NULL) ? _tmp56_->value_name : NULL);
#line 105 "../src/TodayEventMonitor.vala"
					_g_free0 (_tmp53_);
#line 1112 "TodayEventMonitor.c"
				}
#line 76 "../src/TodayEventMonitor.vala"
				__vala_ECalComponentAlarm_free0 (e_alarm);
#line 76 "../src/TodayEventMonitor.vala"
				_g_free0 (alarm_uid);
#line 1118 "TodayEventMonitor.c"
			}
		}
#line 76 "../src/TodayEventMonitor.vala"
		(alarm_uid_collection == NULL) ? NULL : (alarm_uid_collection = (_g_slist_free__g_free0_ (alarm_uid_collection), NULL));
#line 1123 "TodayEventMonitor.c"
	}
}

static void
calendar_today_event_monitor_add_timeout_data_free (gpointer _data)
{
	CalendarTodayEventMonitorAddTimeoutData* _data_;
	_data_ = _data;
#line 20 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/TodayEventMonitor.vala"
	g_slice_free (CalendarTodayEventMonitorAddTimeoutData, _data_);
#line 1136 "TodayEventMonitor.c"
}

void
calendar_today_event_monitor_add_timeout (CalendarTodayEventMonitor* self,
                                          ESource* source,
                                          ECalComponent* event,
                                          guint interval,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	CalendarTodayEventMonitorAddTimeoutData* _data_;
	CalendarTodayEventMonitor* _tmp0_;
	ESource* _tmp1_;
	ECalComponent* _tmp2_;
#line 20 "../src/TodayEventMonitor.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/TodayEventMonitor.vala"
	g_return_if_fail (source != NULL);
#line 20 "../src/TodayEventMonitor.vala"
	g_return_if_fail (event != NULL);
#line 20 "../src/TodayEventMonitor.vala"
	_data_ = g_slice_new0 (CalendarTodayEventMonitorAddTimeoutData);
#line 20 "../src/TodayEventMonitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/TodayEventMonitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, calendar_today_event_monitor_add_timeout_data_free);
#line 20 "../src/TodayEventMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/TodayEventMonitor.vala"
	_data_->self = _tmp0_;
#line 20 "../src/TodayEventMonitor.vala"
	_tmp1_ = _g_object_ref0 (source);
#line 20 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data_->source);
#line 20 "../src/TodayEventMonitor.vala"
	_data_->source = _tmp1_;
#line 20 "../src/TodayEventMonitor.vala"
	_tmp2_ = _g_object_ref0 (event);
#line 20 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data_->event);
#line 20 "../src/TodayEventMonitor.vala"
	_data_->event = _tmp2_;
#line 20 "../src/TodayEventMonitor.vala"
	_data_->interval = interval;
#line 20 "../src/TodayEventMonitor.vala"
	calendar_today_event_monitor_add_timeout_co (_data_);
#line 1183 "TodayEventMonitor.c"
}

void
calendar_today_event_monitor_add_timeout_finish (CalendarTodayEventMonitor* self,
                                                 GAsyncResult* _res_)
{
	CalendarTodayEventMonitorAddTimeoutData* _data_;
#line 20 "../src/TodayEventMonitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1193 "TodayEventMonitor.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 110 "../src/TodayEventMonitor.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 110 "../src/TodayEventMonitor.vala"
	return _data8_;
#line 1203 "TodayEventMonitor.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 110 "../src/TodayEventMonitor.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 1213 "TodayEventMonitor.c"
		CalendarTodayEventMonitor* self;
#line 110 "../src/TodayEventMonitor.vala"
		self = _data8_->self;
#line 110 "../src/TodayEventMonitor.vala"
		_g_free0 (_data8_->uid);
#line 110 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_data8_->source);
#line 110 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (_data8_->event);
#line 110 "../src/TodayEventMonitor.vala"
		_g_object_unref0 (self);
#line 110 "../src/TodayEventMonitor.vala"
		g_slice_free (Block8Data, _data8_);
#line 1227 "TodayEventMonitor.c"
	}
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 1244 "TodayEventMonitor.c"
}

static gboolean
__lambda198_ (Block8Data* _data8_)
{
	CalendarTodayEventMonitor* self;
	ESourceAlarms* extension = NULL;
	ESourceExtension* _tmp0_;
	ESourceAlarms* _tmp1_;
	ESourceAlarms* _tmp2_;
	gboolean result;
#line 114 "../src/TodayEventMonitor.vala"
	self = _data8_->self;
#line 115 "../src/TodayEventMonitor.vala"
	_tmp0_ = e_source_get_extension (_data8_->source, E_SOURCE_EXTENSION_ALARMS);
#line 115 "../src/TodayEventMonitor.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_alarms_get_type (), ESourceAlarms));
#line 115 "../src/TodayEventMonitor.vala"
	extension = _tmp1_;
#line 116 "../src/TodayEventMonitor.vala"
	_tmp2_ = extension;
#line 116 "../src/TodayEventMonitor.vala"
	if (_tmp2_ != NULL) {
#line 1268 "TodayEventMonitor.c"
		ESourceAlarms* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 117 "../src/TodayEventMonitor.vala"
		_tmp3_ = extension;
#line 117 "../src/TodayEventMonitor.vala"
		_tmp4_ = g_date_time_new_now_local ();
#line 117 "../src/TodayEventMonitor.vala"
		_tmp5_ = _tmp4_;
#line 117 "../src/TodayEventMonitor.vala"
		_tmp6_ = g_date_time_to_string (_tmp5_);
#line 117 "../src/TodayEventMonitor.vala"
		_tmp7_ = _tmp6_;
#line 117 "../src/TodayEventMonitor.vala"
		e_source_alarms_set_last_notified (_tmp3_, _tmp7_);
#line 117 "../src/TodayEventMonitor.vala"
		_g_free0 (_tmp7_);
#line 117 "../src/TodayEventMonitor.vala"
		_g_date_time_unref0 (_tmp5_);
#line 1290 "TodayEventMonitor.c"
	}
#line 120 "../src/TodayEventMonitor.vala"
	calendar_today_event_monitor_send_event_notification (self, _data8_->event, _data8_->uid);
#line 121 "../src/TodayEventMonitor.vala"
	result = FALSE;
#line 121 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (extension);
#line 121 "../src/TodayEventMonitor.vala"
	return result;
#line 1300 "TodayEventMonitor.c"
}

static gboolean
___lambda198__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda198_ (self);
#line 114 "../src/TodayEventMonitor.vala"
	return result;
#line 1310 "TodayEventMonitor.c"
}

static gboolean
calendar_today_event_monitor_add_timeout_co (CalendarTodayEventMonitorAddTimeoutData* _data_)
{
#line 110 "../src/TodayEventMonitor.vala"
	switch (_data_->_state_) {
#line 110 "../src/TodayEventMonitor.vala"
		case 0:
#line 1320 "TodayEventMonitor.c"
		goto _state_0;
		default:
#line 110 "../src/TodayEventMonitor.vala"
		g_assert_not_reached ();
#line 1325 "TodayEventMonitor.c"
	}
	_state_0:
#line 110 "../src/TodayEventMonitor.vala"
	_data_->_data8_ = g_slice_new0 (Block8Data);
#line 110 "../src/TodayEventMonitor.vala"
	_data_->_data8_->_ref_count_ = 1;
#line 110 "../src/TodayEventMonitor.vala"
	_data_->_data8_->self = g_object_ref (_data_->self);
#line 110 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data_->_data8_->source);
#line 110 "../src/TodayEventMonitor.vala"
	_data_->_data8_->source = _data_->source;
#line 110 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_data_->_data8_->event);
#line 110 "../src/TodayEventMonitor.vala"
	_data_->_data8_->event = _data_->event;
#line 110 "../src/TodayEventMonitor.vala"
	_data_->_data8_->_async_data_ = _data_;
#line 111 "../src/TodayEventMonitor.vala"
	_data_->_tmp0_ = g_strdup_printf ("%u-%u", _data_->interval, (guint) g_random_int ());
#line 111 "../src/TodayEventMonitor.vala"
	_data_->_data8_->uid = _data_->_tmp0_;
#line 112 "../src/TodayEventMonitor.vala"
	_data_->_tmp1_ = _data_->self->priv->event_uids;
#line 112 "../src/TodayEventMonitor.vala"
	gee_multi_map_set ((GeeMultiMap*) _data_->_tmp1_, _data_->_data8_->event, _data_->_data8_->uid);
#line 113 "../src/TodayEventMonitor.vala"
	g_debug ("TodayEventMonitor.vala:113: adding timeout uid:%s", _data_->_data8_->uid);
#line 114 "../src/TodayEventMonitor.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, _data_->interval, ___lambda198__gsource_func, block8_data_ref (_data_->_data8_), block8_data_unref);
#line 110 "../src/TodayEventMonitor.vala"
	block8_data_unref (_data_->_data8_);
#line 110 "../src/TodayEventMonitor.vala"
	_data_->_data8_ = NULL;
#line 110 "../src/TodayEventMonitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 110 "../src/TodayEventMonitor.vala"
	if (_data_->_state_ != 0) {
#line 110 "../src/TodayEventMonitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 110 "../src/TodayEventMonitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1368 "TodayEventMonitor.c"
		}
	}
#line 110 "../src/TodayEventMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 110 "../src/TodayEventMonitor.vala"
	return FALSE;
#line 1375 "TodayEventMonitor.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1394 "TodayEventMonitor.c"
}

void
calendar_today_event_monitor_send_event_notification (CalendarTodayEventMonitor* self,
                                                      ECalComponent* event,
                                                      const gchar* uid)
{
	GeeHashMultiMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	gboolean _tmp3_;
	ICalComponent* comp = NULL;
	ICalComponent* _tmp4_;
	gchar* primary_text = NULL;
	ICalComponent* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GDateTime* start_time = NULL;
	ICalComponent* _tmp8_;
	ICalTime* _tmp9_;
	ICalTime* _tmp10_;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* now = NULL;
	GDateTime* _tmp13_;
	gchar* secondary_text = NULL;
	gchar* _tmp14_;
	GSettings* h24_settings = NULL;
	GSettings* _tmp15_;
	gchar* format = NULL;
	GSettings* _tmp16_;
	gchar* _tmp17_;
	gchar* text = NULL;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	GDateTime* _tmp20_;
	GDateTime* _tmp21_;
	GNotification* notification = NULL;
	const gchar* _tmp40_;
	GNotification* _tmp41_;
	GNotification* _tmp42_;
	const gchar* _tmp43_;
	GApplication* _tmp44_;
	GNotification* _tmp45_;
#line 125 "../src/TodayEventMonitor.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/TodayEventMonitor.vala"
	g_return_if_fail (event != NULL);
#line 125 "../src/TodayEventMonitor.vala"
	g_return_if_fail (uid != NULL);
#line 126 "../src/TodayEventMonitor.vala"
	_tmp0_ = self->priv->event_uids;
#line 126 "../src/TodayEventMonitor.vala"
	_tmp1_ = gee_multi_map_get ((GeeMultiMap*) _tmp0_, event);
#line 126 "../src/TodayEventMonitor.vala"
	_tmp2_ = _tmp1_;
#line 126 "../src/TodayEventMonitor.vala"
	_tmp3_ = !gee_collection_contains (_tmp2_, uid);
#line 126 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_tmp2_);
#line 126 "../src/TodayEventMonitor.vala"
	if (_tmp3_) {
#line 127 "../src/TodayEventMonitor.vala"
		return;
#line 1459 "TodayEventMonitor.c"
	}
#line 130 "../src/TodayEventMonitor.vala"
	_tmp4_ = e_cal_component_get_icalcomponent (event);
#line 130 "../src/TodayEventMonitor.vala"
	comp = _tmp4_;
#line 131 "../src/TodayEventMonitor.vala"
	_tmp5_ = comp;
#line 131 "../src/TodayEventMonitor.vala"
	_tmp6_ = i_cal_component_get_summary (_tmp5_);
#line 131 "../src/TodayEventMonitor.vala"
	_tmp7_ = g_strdup_printf ("%s", _tmp6_);
#line 131 "../src/TodayEventMonitor.vala"
	primary_text = _tmp7_;
#line 132 "../src/TodayEventMonitor.vala"
	_tmp8_ = comp;
#line 132 "../src/TodayEventMonitor.vala"
	_tmp9_ = i_cal_component_get_dtstart (_tmp8_);
#line 132 "../src/TodayEventMonitor.vala"
	_tmp10_ = _tmp9_;
#line 132 "../src/TodayEventMonitor.vala"
	_tmp11_ = calendar_util_icaltime_to_datetime (_tmp10_);
#line 132 "../src/TodayEventMonitor.vala"
	_tmp12_ = _tmp11_;
#line 132 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (_tmp10_);
#line 132 "../src/TodayEventMonitor.vala"
	start_time = _tmp12_;
#line 133 "../src/TodayEventMonitor.vala"
	_tmp13_ = g_date_time_new_now_local ();
#line 133 "../src/TodayEventMonitor.vala"
	now = _tmp13_;
#line 134 "../src/TodayEventMonitor.vala"
	_tmp14_ = g_strdup ("");
#line 134 "../src/TodayEventMonitor.vala"
	secondary_text = _tmp14_;
#line 135 "../src/TodayEventMonitor.vala"
	_tmp15_ = g_settings_new ("org.gnome.desktop.interface");
#line 135 "../src/TodayEventMonitor.vala"
	h24_settings = _tmp15_;
#line 136 "../src/TodayEventMonitor.vala"
	_tmp16_ = h24_settings;
#line 136 "../src/TodayEventMonitor.vala"
	_tmp17_ = g_settings_get_string (_tmp16_, "clock-format");
#line 136 "../src/TodayEventMonitor.vala"
	format = _tmp17_;
#line 137 "../src/TodayEventMonitor.vala"
	_tmp18_ = format;
#line 137 "../src/TodayEventMonitor.vala"
	_tmp19_ = granite_date_time_get_default_time_format (string_contains (_tmp18_, "12h"), FALSE);
#line 137 "../src/TodayEventMonitor.vala"
	text = _tmp19_;
#line 138 "../src/TodayEventMonitor.vala"
	_tmp20_ = start_time;
#line 138 "../src/TodayEventMonitor.vala"
	_tmp21_ = now;
#line 138 "../src/TodayEventMonitor.vala"
	if (g_date_time_get_year (_tmp20_) == g_date_time_get_year (_tmp21_)) {
#line 1517 "TodayEventMonitor.c"
		GDateTime* _tmp22_;
		GDateTime* _tmp23_;
#line 139 "../src/TodayEventMonitor.vala"
		_tmp22_ = start_time;
#line 139 "../src/TodayEventMonitor.vala"
		_tmp23_ = now;
#line 139 "../src/TodayEventMonitor.vala"
		if (g_date_time_get_day_of_year (_tmp22_) == g_date_time_get_day_of_year (_tmp23_)) {
#line 1526 "TodayEventMonitor.c"
			GDateTime* _tmp24_;
			gchar* _tmp25_;
#line 140 "../src/TodayEventMonitor.vala"
			_tmp24_ = start_time;
#line 140 "../src/TodayEventMonitor.vala"
			_tmp25_ = granite_date_time_get_relative_datetime (_tmp24_);
#line 140 "../src/TodayEventMonitor.vala"
			_g_free0 (secondary_text);
#line 140 "../src/TodayEventMonitor.vala"
			secondary_text = _tmp25_;
#line 1537 "TodayEventMonitor.c"
		} else {
			GDateTime* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
#line 142 "../src/TodayEventMonitor.vala"
			_tmp26_ = start_time;
#line 142 "../src/TodayEventMonitor.vala"
			_tmp27_ = granite_date_time_get_default_date_format (FALSE, TRUE, FALSE);
#line 142 "../src/TodayEventMonitor.vala"
			_tmp28_ = _tmp27_;
#line 142 "../src/TodayEventMonitor.vala"
			_tmp29_ = text;
#line 142 "../src/TodayEventMonitor.vala"
			_tmp30_ = g_strdup_printf ("%s, %s", _tmp28_, _tmp29_);
#line 142 "../src/TodayEventMonitor.vala"
			_tmp31_ = _tmp30_;
#line 142 "../src/TodayEventMonitor.vala"
			_tmp32_ = g_date_time_format (_tmp26_, _tmp31_);
#line 142 "../src/TodayEventMonitor.vala"
			_g_free0 (secondary_text);
#line 142 "../src/TodayEventMonitor.vala"
			secondary_text = _tmp32_;
#line 142 "../src/TodayEventMonitor.vala"
			_g_free0 (_tmp31_);
#line 142 "../src/TodayEventMonitor.vala"
			_g_free0 (_tmp28_);
#line 1568 "TodayEventMonitor.c"
		}
	} else {
		GDateTime* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
#line 145 "../src/TodayEventMonitor.vala"
		_tmp33_ = start_time;
#line 145 "../src/TodayEventMonitor.vala"
		_tmp34_ = granite_date_time_get_default_date_format (FALSE, TRUE, TRUE);
#line 145 "../src/TodayEventMonitor.vala"
		_tmp35_ = _tmp34_;
#line 145 "../src/TodayEventMonitor.vala"
		_tmp36_ = text;
#line 145 "../src/TodayEventMonitor.vala"
		_tmp37_ = g_strdup_printf ("%s, %s", _tmp35_, _tmp36_);
#line 145 "../src/TodayEventMonitor.vala"
		_tmp38_ = _tmp37_;
#line 145 "../src/TodayEventMonitor.vala"
		_tmp39_ = g_date_time_format (_tmp33_, _tmp38_);
#line 145 "../src/TodayEventMonitor.vala"
		_g_free0 (secondary_text);
#line 145 "../src/TodayEventMonitor.vala"
		secondary_text = _tmp39_;
#line 145 "../src/TodayEventMonitor.vala"
		_g_free0 (_tmp38_);
#line 145 "../src/TodayEventMonitor.vala"
		_g_free0 (_tmp35_);
#line 1600 "TodayEventMonitor.c"
	}
#line 148 "../src/TodayEventMonitor.vala"
	_tmp40_ = primary_text;
#line 148 "../src/TodayEventMonitor.vala"
	_tmp41_ = g_notification_new (_tmp40_);
#line 148 "../src/TodayEventMonitor.vala"
	notification = _tmp41_;
#line 149 "../src/TodayEventMonitor.vala"
	_tmp42_ = notification;
#line 149 "../src/TodayEventMonitor.vala"
	_tmp43_ = secondary_text;
#line 149 "../src/TodayEventMonitor.vala"
	g_notification_set_body (_tmp42_, _tmp43_);
#line 151 "../src/TodayEventMonitor.vala"
	_tmp44_ = g_application_get_default ();
#line 151 "../src/TodayEventMonitor.vala"
	_tmp45_ = notification;
#line 151 "../src/TodayEventMonitor.vala"
	g_application_send_notification (_tmp44_, uid, _tmp45_);
#line 125 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (notification);
#line 125 "../src/TodayEventMonitor.vala"
	_g_free0 (text);
#line 125 "../src/TodayEventMonitor.vala"
	_g_free0 (format);
#line 125 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (h24_settings);
#line 125 "../src/TodayEventMonitor.vala"
	_g_free0 (secondary_text);
#line 125 "../src/TodayEventMonitor.vala"
	_g_date_time_unref0 (now);
#line 125 "../src/TodayEventMonitor.vala"
	_g_date_time_unref0 (start_time);
#line 125 "../src/TodayEventMonitor.vala"
	_g_free0 (primary_text);
#line 1636 "TodayEventMonitor.c"
}

static void
calendar_today_event_monitor_update_event (CalendarTodayEventMonitor* self,
                                           ESource* source,
                                           ECalComponent* event)
{
#line 154 "../src/TodayEventMonitor.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/TodayEventMonitor.vala"
	g_return_if_fail (source != NULL);
#line 154 "../src/TodayEventMonitor.vala"
	g_return_if_fail (event != NULL);
#line 155 "../src/TodayEventMonitor.vala"
	calendar_today_event_monitor_remove_event (self, source, event);
#line 156 "../src/TodayEventMonitor.vala"
	e_cal_component_commit_sequence (event);
#line 157 "../src/TodayEventMonitor.vala"
	calendar_today_event_monitor_add_event (self, source, event);
#line 1656 "TodayEventMonitor.c"
}

static void
calendar_today_event_monitor_remove_event (CalendarTodayEventMonitor* self,
                                           ESource* source,
                                           ECalComponent* event)
{
	GeeHashMultiMap* _tmp0_;
#line 160 "../src/TodayEventMonitor.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/TodayEventMonitor.vala"
	g_return_if_fail (source != NULL);
#line 160 "../src/TodayEventMonitor.vala"
	g_return_if_fail (event != NULL);
#line 161 "../src/TodayEventMonitor.vala"
	_tmp0_ = self->priv->event_uids;
#line 161 "../src/TodayEventMonitor.vala"
	if (gee_multi_map_contains ((GeeMultiMap*) _tmp0_, event)) {
#line 1675 "TodayEventMonitor.c"
		GeeHashMultiMap* _tmp1_;
#line 162 "../src/TodayEventMonitor.vala"
		_tmp1_ = self->priv->event_uids;
#line 162 "../src/TodayEventMonitor.vala"
		gee_multi_map_remove_all ((GeeMultiMap*) _tmp1_, event);
#line 1681 "TodayEventMonitor.c"
	}
}

static GTimeSpan
calendar_today_event_monitor_time_until_now (CalendarTodayEventMonitor* self,
                                             GDateTime* dt)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GTimeSpan result;
#line 166 "../src/TodayEventMonitor.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 166 "../src/TodayEventMonitor.vala"
	g_return_val_if_fail (dt != NULL, 0LL);
#line 167 "../src/TodayEventMonitor.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 167 "../src/TodayEventMonitor.vala"
	now = _tmp0_;
#line 168 "../src/TodayEventMonitor.vala"
	result = g_date_time_difference (dt, now) / G_TIME_SPAN_SECOND;
#line 168 "../src/TodayEventMonitor.vala"
	_g_date_time_unref0 (now);
#line 168 "../src/TodayEventMonitor.vala"
	return result;
#line 1706 "TodayEventMonitor.c"
}

CalendarTodayEventMonitor*
calendar_today_event_monitor_construct (GType object_type)
{
	CalendarTodayEventMonitor * self = NULL;
#line 20 "../src/TodayEventMonitor.vala"
	self = (CalendarTodayEventMonitor*) g_object_new (object_type, NULL);
#line 20 "../src/TodayEventMonitor.vala"
	return self;
#line 1717 "TodayEventMonitor.c"
}

CalendarTodayEventMonitor*
calendar_today_event_monitor_new (void)
{
#line 20 "../src/TodayEventMonitor.vala"
	return calendar_today_event_monitor_construct (CALENDAR_TYPE_TODAY_EVENT_MONITOR);
#line 1725 "TodayEventMonitor.c"
}

static gboolean
_calendar_today_event_monitor___lambda201_ (CalendarTodayEventMonitor* self)
{
	GeeHashMultiMap* _tmp0_;
	gboolean result;
#line 26 "../src/TodayEventMonitor.vala"
	_tmp0_ = self->priv->event_uids;
#line 26 "../src/TodayEventMonitor.vala"
	gee_multi_map_clear ((GeeMultiMap*) _tmp0_);
#line 27 "../src/TodayEventMonitor.vala"
	calendar_today_event_monitor_load_today_events (self);
#line 28 "../src/TodayEventMonitor.vala"
	result = TRUE;
#line 28 "../src/TodayEventMonitor.vala"
	return result;
#line 1743 "TodayEventMonitor.c"
}

static gboolean
__calendar_today_event_monitor___lambda201__gsource_func (gpointer self)
{
	gboolean result;
	result = _calendar_today_event_monitor___lambda201_ ((CalendarTodayEventMonitor*) self);
#line 25 "../src/TodayEventMonitor.vala"
	return result;
#line 1753 "TodayEventMonitor.c"
}

static GObject *
calendar_today_event_monitor_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
#line 23 "../src/TodayEventMonitor.vala"
	static GWeakRef CalendarTodayEventMonitor_singleton__ref;
#line 23 "../src/TodayEventMonitor.vala"
	static GMutex CalendarTodayEventMonitor_singleton__lock;
#line 1767 "TodayEventMonitor.c"
	CalendarTodayEventMonitor * self;
#line 23 "../src/TodayEventMonitor.vala"
	g_mutex_lock (&CalendarTodayEventMonitor_singleton__lock);
#line 23 "../src/TodayEventMonitor.vala"
	obj = g_weak_ref_get (&CalendarTodayEventMonitor_singleton__ref);
#line 23 "../src/TodayEventMonitor.vala"
	if (obj != NULL) {
#line 1775 "TodayEventMonitor.c"
		g_mutex_unlock (&CalendarTodayEventMonitor_singleton__lock);
		return obj;
	}
#line 23 "../src/TodayEventMonitor.vala"
	parent_class = G_OBJECT_CLASS (calendar_today_event_monitor_parent_class);
#line 23 "../src/TodayEventMonitor.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 23 "../src/TodayEventMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CALENDAR_TYPE_TODAY_EVENT_MONITOR, CalendarTodayEventMonitor);
#line 24 "../src/TodayEventMonitor.vala"
	calendar_today_event_monitor_load_today_events (self);
#line 25 "../src/TodayEventMonitor.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 86400, __calendar_today_event_monitor___lambda201__gsource_func, g_object_ref (self), g_object_unref);
#line 23 "../src/TodayEventMonitor.vala"
	g_weak_ref_set (&CalendarTodayEventMonitor_singleton__ref, obj);
#line 23 "../src/TodayEventMonitor.vala"
	g_mutex_unlock (&CalendarTodayEventMonitor_singleton__lock);
#line 23 "../src/TodayEventMonitor.vala"
	return obj;
#line 1795 "TodayEventMonitor.c"
}

static void
calendar_today_event_monitor_class_init (CalendarTodayEventMonitorClass * klass,
                                         gpointer klass_data)
{
#line 20 "../src/TodayEventMonitor.vala"
	calendar_today_event_monitor_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/TodayEventMonitor.vala"
	g_type_class_adjust_private_offset (klass, &CalendarTodayEventMonitor_private_offset);
#line 20 "../src/TodayEventMonitor.vala"
	G_OBJECT_CLASS (klass)->constructor = calendar_today_event_monitor_constructor;
#line 20 "../src/TodayEventMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = calendar_today_event_monitor_finalize;
#line 1810 "TodayEventMonitor.c"
}

static void
calendar_today_event_monitor_instance_init (CalendarTodayEventMonitor * self,
                                            gpointer klass)
{
#line 20 "../src/TodayEventMonitor.vala"
	self->priv = calendar_today_event_monitor_get_instance_private (self);
#line 1819 "TodayEventMonitor.c"
}

static void
calendar_today_event_monitor_finalize (GObject * obj)
{
	CalendarTodayEventMonitor * self;
#line 20 "../src/TodayEventMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CALENDAR_TYPE_TODAY_EVENT_MONITOR, CalendarTodayEventMonitor);
#line 21 "../src/TodayEventMonitor.vala"
	_g_object_unref0 (self->priv->event_uids);
#line 20 "../src/TodayEventMonitor.vala"
	G_OBJECT_CLASS (calendar_today_event_monitor_parent_class)->finalize (obj);
#line 1832 "TodayEventMonitor.c"
}

static GType
calendar_today_event_monitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CalendarTodayEventMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) calendar_today_event_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CalendarTodayEventMonitor), 0, (GInstanceInitFunc) calendar_today_event_monitor_instance_init, NULL };
	GType calendar_today_event_monitor_type_id;
	calendar_today_event_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "CalendarTodayEventMonitor", &g_define_type_info, 0);
	CalendarTodayEventMonitor_private_offset = g_type_add_instance_private (calendar_today_event_monitor_type_id, sizeof (CalendarTodayEventMonitorPrivate));
	return calendar_today_event_monitor_type_id;
}

GType
calendar_today_event_monitor_get_type (void)
{
	static volatile gsize calendar_today_event_monitor_type_id__once = 0;
	if (g_once_init_enter (&calendar_today_event_monitor_type_id__once)) {
		GType calendar_today_event_monitor_type_id;
		calendar_today_event_monitor_type_id = calendar_today_event_monitor_get_type_once ();
		g_once_init_leave (&calendar_today_event_monitor_type_id__once, calendar_today_event_monitor_type_id);
	}
	return calendar_today_event_monitor_type_id__once;
}

