/* SourceRow.c generated by valac 0.56.18, the Vala compiler
 * generated from SourceRow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2015 Maya Developers (http://launchpad.net/maya)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <libedataserver/libedataserver.h>
#include <float.h>
#include <math.h>
#include "elementary-calendar.h"
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CALENDAR_TYPE_SOURCE_ROW (calendar_source_row_get_type ())
#define CALENDAR_SOURCE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CALENDAR_TYPE_SOURCE_ROW, CalendarSourceRow))
#define CALENDAR_SOURCE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CALENDAR_TYPE_SOURCE_ROW, CalendarSourceRowClass))
#define CALENDAR_IS_SOURCE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CALENDAR_TYPE_SOURCE_ROW))
#define CALENDAR_IS_SOURCE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CALENDAR_TYPE_SOURCE_ROW))
#define CALENDAR_SOURCE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CALENDAR_TYPE_SOURCE_ROW, CalendarSourceRowClass))

typedef struct _CalendarSourceRow CalendarSourceRow;
typedef struct _CalendarSourceRowClass CalendarSourceRowClass;
typedef struct _CalendarSourceRowPrivate CalendarSourceRowPrivate;
enum  {
	CALENDAR_SOURCE_ROW_0_PROPERTY,
	CALENDAR_SOURCE_ROW_LOCATION_PROPERTY,
	CALENDAR_SOURCE_ROW_LABEL_PROPERTY,
	CALENDAR_SOURCE_ROW_SOURCE_PROPERTY,
	CALENDAR_SOURCE_ROW_NUM_PROPERTIES
};
static GParamSpec* calendar_source_row_properties[CALENDAR_SOURCE_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block33Data Block33Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	CALENDAR_SOURCE_ROW_REMOVE_REQUEST_SIGNAL,
	CALENDAR_SOURCE_ROW_EDIT_REQUEST_SIGNAL,
	CALENDAR_SOURCE_ROW_NUM_SIGNALS
};
static guint calendar_source_row_signals[CALENDAR_SOURCE_ROW_NUM_SIGNALS] = {0};

struct _CalendarSourceRow {
	GtkListBoxRow parent_instance;
	CalendarSourceRowPrivate * priv;
};

struct _CalendarSourceRowClass {
	GtkListBoxRowClass parent_class;
};

struct _CalendarSourceRowPrivate {
	gchar* _location;
	gchar* _label;
	ESource* _source;
	GtkStack* stack;
	GtkGrid* info_grid;
	GtkButton* delete_button;
	GtkRevealer* delete_revealer;
	GtkButton* edit_button;
	GtkRevealer* edit_revealer;
	GtkLabel* calendar_name_label;
	GtkLabel* message_label;
	GtkCheckButton* visible_checkbutton;
};

struct _Block33Data {
	int _ref_count_;
	CalendarSourceRow* self;
	ESourceCalendar* cal;
	ESource* source;
};

static gint CalendarSourceRow_private_offset;
static gpointer calendar_source_row_parent_class = NULL;

VALA_EXTERN GType calendar_source_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CalendarSourceRow, g_object_unref)
VALA_EXTERN CalendarSourceRow* calendar_source_row_new (ESource* source);
VALA_EXTERN CalendarSourceRow* calendar_source_row_construct (GType object_type,
                                                  ESource* source);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
static void calendar_source_row_set_source (CalendarSourceRow* self,
                                     ESource* value);
static void calendar_source_row_set_label (CalendarSourceRow* self,
                                    const gchar* value);
static void calendar_source_row_set_location (CalendarSourceRow* self,
                                       const gchar* value);
static void __lambda152_ (Block33Data* _data33_);
static void ___lambda152__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self);
static void calendar_source_row_style_calendar_color (CalendarSourceRow* self,
                                               const gchar* color);
static void __lambda153_ (CalendarSourceRow* self);
static void ___lambda153__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda154_ (Block33Data* _data33_);
static void ___lambda154__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda155_ (Block33Data* _data33_);
static void ___lambda155__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void __lambda156_ (CalendarSourceRow* self);
static void ___lambda156__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static gboolean __lambda157_ (CalendarSourceRow* self,
                       GdkEventCrossing* event);
static gboolean ___lambda157__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                      GdkEventCrossing* event,
                                                      gpointer self);
static gboolean __lambda158_ (CalendarSourceRow* self,
                       GdkEventCrossing* event);
static gboolean ___lambda158__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                      GdkEventCrossing* event,
                                                      gpointer self);
VALA_EXTERN void calendar_source_row_source_has_changed (CalendarSourceRow* self);
static void _calendar_source_row_source_has_changed_e_source_changed (ESource* _sender,
                                                               gpointer self);
VALA_EXTERN ESource* calendar_source_row_get_source (CalendarSourceRow* self);
VALA_EXTERN void calendar_source_row_show_calendar_removed (CalendarSourceRow* self);
VALA_EXTERN const gchar* calendar_source_row_get_location (CalendarSourceRow* self);
VALA_EXTERN const gchar* calendar_source_row_get_label (CalendarSourceRow* self);
static void calendar_source_row_finalize (GObject * obj);
static GType calendar_source_row_get_type_once (void);
static void _vala_calendar_source_row_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_calendar_source_row_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
calendar_source_row_get_instance_private (CalendarSourceRow* self)
{
	return G_STRUCT_MEMBER_P (self, CalendarSourceRow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/Widgets/SourceRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 187 "SourceRow.c"
}

static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
#line 41 "../src/Widgets/SourceRow.vala"
	g_atomic_int_inc (&_data33_->_ref_count_);
#line 41 "../src/Widgets/SourceRow.vala"
	return _data33_;
#line 197 "SourceRow.c"
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
#line 41 "../src/Widgets/SourceRow.vala"
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
#line 207 "SourceRow.c"
		CalendarSourceRow* self;
#line 41 "../src/Widgets/SourceRow.vala"
		self = _data33_->self;
#line 41 "../src/Widgets/SourceRow.vala"
		_g_object_unref0 (_data33_->cal);
#line 41 "../src/Widgets/SourceRow.vala"
		_g_object_unref0 (_data33_->source);
#line 41 "../src/Widgets/SourceRow.vala"
		_g_object_unref0 (self);
#line 41 "../src/Widgets/SourceRow.vala"
		g_slice_free (Block33Data, _data33_);
#line 219 "SourceRow.c"
	}
}

static void
__lambda152_ (Block33Data* _data33_)
{
	CalendarSourceRow* self;
	CalendarEventStore* calmodel = NULL;
	CalendarEventStore* _tmp0_;
	GtkCheckButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	ESourceCalendar* _tmp6_;
	GtkCheckButton* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GError* _inner_error0_ = NULL;
#line 56 "../src/Widgets/SourceRow.vala"
	self = _data33_->self;
#line 57 "../src/Widgets/SourceRow.vala"
	_tmp0_ = calendar_event_store_get_default ();
#line 57 "../src/Widgets/SourceRow.vala"
	calmodel = _tmp0_;
#line 58 "../src/Widgets/SourceRow.vala"
	_tmp1_ = self->priv->visible_checkbutton;
#line 58 "../src/Widgets/SourceRow.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 58 "../src/Widgets/SourceRow.vala"
	_tmp3_ = _tmp2_;
#line 58 "../src/Widgets/SourceRow.vala"
	if (_tmp3_ == TRUE) {
#line 251 "SourceRow.c"
		CalendarEventStore* _tmp4_;
#line 59 "../src/Widgets/SourceRow.vala"
		_tmp4_ = calmodel;
#line 59 "../src/Widgets/SourceRow.vala"
		calendar_event_store_add_source (_tmp4_, _data33_->source);
#line 257 "SourceRow.c"
	} else {
		CalendarEventStore* _tmp5_;
#line 61 "../src/Widgets/SourceRow.vala"
		_tmp5_ = calmodel;
#line 61 "../src/Widgets/SourceRow.vala"
		calendar_event_store_remove_source (_tmp5_, _data33_->source);
#line 264 "SourceRow.c"
	}
#line 64 "../src/Widgets/SourceRow.vala"
	_tmp6_ = _data33_->cal;
#line 64 "../src/Widgets/SourceRow.vala"
	_tmp7_ = self->priv->visible_checkbutton;
#line 64 "../src/Widgets/SourceRow.vala"
	_tmp8_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp7_);
#line 64 "../src/Widgets/SourceRow.vala"
	_tmp9_ = _tmp8_;
#line 64 "../src/Widgets/SourceRow.vala"
	e_source_selectable_set_selected ((ESourceSelectable*) _tmp6_, _tmp9_);
#line 276 "SourceRow.c"
	{
#line 66 "../src/Widgets/SourceRow.vala"
		e_source_write_sync (_data33_->source, NULL, &_inner_error0_);
#line 66 "../src/Widgets/SourceRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 282 "SourceRow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 65 "../src/Widgets/SourceRow.vala"
		_error_ = _inner_error0_;
#line 65 "../src/Widgets/SourceRow.vala"
		_inner_error0_ = NULL;
#line 68 "../src/Widgets/SourceRow.vala"
		_tmp10_ = _error_;
#line 68 "../src/Widgets/SourceRow.vala"
		_tmp11_ = _tmp10_->message;
#line 68 "../src/Widgets/SourceRow.vala"
		g_critical ("SourceRow.vala:68: %s", _tmp11_);
#line 65 "../src/Widgets/SourceRow.vala"
		_g_error_free0 (_error_);
#line 304 "SourceRow.c"
	}
	__finally0:
#line 65 "../src/Widgets/SourceRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "../src/Widgets/SourceRow.vala"
		_g_object_unref0 (calmodel);
#line 65 "../src/Widgets/SourceRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../src/Widgets/SourceRow.vala"
		g_clear_error (&_inner_error0_);
#line 65 "../src/Widgets/SourceRow.vala"
		return;
#line 317 "SourceRow.c"
	}
#line 56 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (calmodel);
#line 321 "SourceRow.c"
}

static void
___lambda152__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                         gpointer self)
{
#line 56 "../src/Widgets/SourceRow.vala"
	__lambda152_ (self);
#line 330 "SourceRow.c"
}

static void
__lambda153_ (CalendarSourceRow* self)
{
#line 136 "../src/Widgets/SourceRow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 137 "../src/Widgets/SourceRow.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 340 "SourceRow.c"
}

static void
___lambda153__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 135 "../src/Widgets/SourceRow.vala"
	__lambda153_ ((CalendarSourceRow*) self);
#line 349 "SourceRow.c"
}

static void
__lambda154_ (Block33Data* _data33_)
{
	CalendarSourceRow* self;
#line 140 "../src/Widgets/SourceRow.vala"
	self = _data33_->self;
#line 140 "../src/Widgets/SourceRow.vala"
	g_signal_emit (self, calendar_source_row_signals[CALENDAR_SOURCE_ROW_REMOVE_REQUEST_SIGNAL], 0, _data33_->source);
#line 360 "SourceRow.c"
}

static void
___lambda154__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 140 "../src/Widgets/SourceRow.vala"
	__lambda154_ (self);
#line 369 "SourceRow.c"
}

static void
__lambda155_ (Block33Data* _data33_)
{
	CalendarSourceRow* self;
#line 142 "../src/Widgets/SourceRow.vala"
	self = _data33_->self;
#line 142 "../src/Widgets/SourceRow.vala"
	g_signal_emit (self, calendar_source_row_signals[CALENDAR_SOURCE_ROW_EDIT_REQUEST_SIGNAL], 0, _data33_->source);
#line 380 "SourceRow.c"
}

static void
___lambda155__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 142 "../src/Widgets/SourceRow.vala"
	__lambda155_ (self);
#line 389 "SourceRow.c"
}

static void
__lambda156_ (CalendarSourceRow* self)
{
	CalendarEventStore* _tmp0_;
	CalendarEventStore* _tmp1_;
	GtkStack* _tmp2_;
#line 145 "../src/Widgets/SourceRow.vala"
	_tmp0_ = calendar_event_store_get_default ();
#line 145 "../src/Widgets/SourceRow.vala"
	_tmp1_ = _tmp0_;
#line 145 "../src/Widgets/SourceRow.vala"
	calendar_event_store_restore_calendar (_tmp1_);
#line 145 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (_tmp1_);
#line 146 "../src/Widgets/SourceRow.vala"
	_tmp2_ = self->priv->stack;
#line 146 "../src/Widgets/SourceRow.vala"
	gtk_stack_set_visible_child_name (_tmp2_, "calendar");
#line 410 "SourceRow.c"
}

static void
___lambda156__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 144 "../src/Widgets/SourceRow.vala"
	__lambda156_ ((CalendarSourceRow*) self);
#line 419 "SourceRow.c"
}

static gboolean
__lambda157_ (CalendarSourceRow* self,
              GdkEventCrossing* event)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	gboolean result;
#line 150 "../src/Widgets/SourceRow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 151 "../src/Widgets/SourceRow.vala"
	_tmp0_ = self->priv->delete_revealer;
#line 151 "../src/Widgets/SourceRow.vala"
	gtk_revealer_set_reveal_child (_tmp0_, TRUE);
#line 152 "../src/Widgets/SourceRow.vala"
	_tmp1_ = self->priv->edit_revealer;
#line 152 "../src/Widgets/SourceRow.vala"
	gtk_revealer_set_reveal_child (_tmp1_, TRUE);
#line 153 "../src/Widgets/SourceRow.vala"
	result = FALSE;
#line 153 "../src/Widgets/SourceRow.vala"
	return result;
#line 443 "SourceRow.c"
}

static gboolean
___lambda157__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                             GdkEventCrossing* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda157_ ((CalendarSourceRow*) self, event);
#line 150 "../src/Widgets/SourceRow.vala"
	return result;
#line 455 "SourceRow.c"
}

static gboolean
__lambda158_ (CalendarSourceRow* self,
              GdkEventCrossing* event)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	gboolean result;
#line 156 "../src/Widgets/SourceRow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 157 "../src/Widgets/SourceRow.vala"
	if (event->detail == GDK_NOTIFY_INFERIOR) {
#line 158 "../src/Widgets/SourceRow.vala"
		result = FALSE;
#line 158 "../src/Widgets/SourceRow.vala"
		return result;
#line 473 "SourceRow.c"
	}
#line 160 "../src/Widgets/SourceRow.vala"
	_tmp0_ = self->priv->delete_revealer;
#line 160 "../src/Widgets/SourceRow.vala"
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
#line 161 "../src/Widgets/SourceRow.vala"
	_tmp1_ = self->priv->edit_revealer;
#line 161 "../src/Widgets/SourceRow.vala"
	gtk_revealer_set_reveal_child (_tmp1_, FALSE);
#line 162 "../src/Widgets/SourceRow.vala"
	result = FALSE;
#line 162 "../src/Widgets/SourceRow.vala"
	return result;
#line 487 "SourceRow.c"
}

static gboolean
___lambda158__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                             GdkEventCrossing* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda158_ ((CalendarSourceRow*) self, event);
#line 156 "../src/Widgets/SourceRow.vala"
	return result;
#line 499 "SourceRow.c"
}

static void
_calendar_source_row_source_has_changed_e_source_changed (ESource* _sender,
                                                          gpointer self)
{
#line 165 "../src/Widgets/SourceRow.vala"
	calendar_source_row_source_has_changed ((CalendarSourceRow*) self);
#line 508 "SourceRow.c"
}

CalendarSourceRow*
calendar_source_row_construct (GType object_type,
                               ESource* source)
{
	CalendarSourceRow * self = NULL;
	Block33Data* _data33_;
	ESource* _tmp0_;
	ESourceExtension* _tmp1_;
	ESourceCalendar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkCheckButton* _tmp12_;
	GtkCheckButton* _tmp13_;
	ESourceCalendar* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	GtkCheckButton* _tmp17_;
	ESourceCalendar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkButton* _tmp21_;
	const gchar* _tmp22_ = NULL;
	gboolean _tmp23_;
	gboolean _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	GtkButton* _tmp30_;
	GtkStyleContext* _tmp31_;
	GtkRevealer* _tmp32_;
	GtkRevealer* _tmp33_;
	GtkRevealer* _tmp34_;
	GtkButton* _tmp35_;
	GtkRevealer* _tmp36_;
	GtkRevealer* _tmp37_;
	GtkButton* _tmp38_;
	const gchar* _tmp39_ = NULL;
	gboolean _tmp40_;
	gboolean _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkButton* _tmp44_;
	gboolean _tmp45_;
	gboolean _tmp46_;
	GtkRevealer* _tmp47_;
	GtkRevealer* _tmp48_;
	GtkRevealer* _tmp49_;
	GtkButton* _tmp50_;
	GtkRevealer* _tmp51_;
	GtkRevealer* _tmp52_;
	GtkGrid* calendar_grid = NULL;
	GtkGrid* _tmp53_;
	GtkCheckButton* _tmp54_;
	GtkLabel* _tmp55_;
	GtkRevealer* _tmp56_;
	GtkRevealer* _tmp57_;
	GtkEventBox* calendar_event_box = NULL;
	GtkEventBox* _tmp58_;
	GtkButton* undo_button = NULL;
	GtkButton* _tmp59_;
	GtkButton* close_button = NULL;
	GtkButton* _tmp60_;
	const gchar* _tmp61_;
	const gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	GtkLabel* _tmp65_;
	GtkLabel* _tmp66_;
	GtkLabel* _tmp67_;
	GtkGrid* _tmp68_;
	GtkGrid* _tmp69_;
	GtkGrid* _tmp70_;
	GtkGrid* _tmp71_;
	GtkGrid* _tmp72_;
	GtkLabel* _tmp73_;
	GtkGrid* _tmp74_;
	GtkStack* _tmp75_;
	GtkStack* _tmp76_;
	GtkStack* _tmp77_;
	GtkGrid* _tmp78_;
	GtkStack* _tmp79_;
	GtkStack* _tmp80_;
	GtkStack* _tmp81_;
	GtkButton* _tmp82_;
	GtkButton* _tmp83_;
#line 41 "../src/Widgets/SourceRow.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 41 "../src/Widgets/SourceRow.vala"
	_data33_ = g_slice_new0 (Block33Data);
#line 41 "../src/Widgets/SourceRow.vala"
	_data33_->_ref_count_ = 1;
#line 41 "../src/Widgets/SourceRow.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 41 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (_data33_->source);
#line 41 "../src/Widgets/SourceRow.vala"
	_data33_->source = _tmp0_;
#line 41 "../src/Widgets/SourceRow.vala"
	self = (CalendarSourceRow*) g_object_new (object_type, NULL);
#line 41 "../src/Widgets/SourceRow.vala"
	_data33_->self = g_object_ref (self);
#line 42 "../src/Widgets/SourceRow.vala"
	calendar_source_row_set_source (self, _data33_->source);
#line 45 "../src/Widgets/SourceRow.vala"
	_tmp1_ = e_source_get_extension (_data33_->source, E_SOURCE_EXTENSION_CALENDAR);
#line 45 "../src/Widgets/SourceRow.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, e_source_calendar_get_type (), ESourceCalendar));
#line 45 "../src/Widgets/SourceRow.vala"
	_data33_->cal = _tmp2_;
#line 47 "../src/Widgets/SourceRow.vala"
	_tmp3_ = e_source_dup_display_name (_data33_->source);
#line 47 "../src/Widgets/SourceRow.vala"
	_tmp4_ = _tmp3_;
#line 47 "../src/Widgets/SourceRow.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 47 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp5_);
#line 47 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->calendar_name_label);
#line 47 "../src/Widgets/SourceRow.vala"
	self->priv->calendar_name_label = _tmp5_;
#line 47 "../src/Widgets/SourceRow.vala"
	_g_free0 (_tmp4_);
#line 48 "../src/Widgets/SourceRow.vala"
	_tmp6_ = self->priv->calendar_name_label;
#line 48 "../src/Widgets/SourceRow.vala"
	gtk_label_set_xalign (_tmp6_, (gfloat) 0);
#line 49 "../src/Widgets/SourceRow.vala"
	_tmp7_ = self->priv->calendar_name_label;
#line 49 "../src/Widgets/SourceRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp7_, TRUE);
#line 51 "../src/Widgets/SourceRow.vala"
	_tmp8_ = e_source_dup_display_name (_data33_->source);
#line 51 "../src/Widgets/SourceRow.vala"
	_tmp9_ = _tmp8_;
#line 51 "../src/Widgets/SourceRow.vala"
	calendar_source_row_set_label (self, _tmp9_);
#line 51 "../src/Widgets/SourceRow.vala"
	_g_free0 (_tmp9_);
#line 52 "../src/Widgets/SourceRow.vala"
	_tmp10_ = maya_util_get_source_location (_data33_->source);
#line 52 "../src/Widgets/SourceRow.vala"
	_tmp11_ = _tmp10_;
#line 52 "../src/Widgets/SourceRow.vala"
	calendar_source_row_set_location (self, _tmp11_);
#line 52 "../src/Widgets/SourceRow.vala"
	_g_free0 (_tmp11_);
#line 54 "../src/Widgets/SourceRow.vala"
	_tmp12_ = (GtkCheckButton*) gtk_check_button_new ();
#line 54 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp12_);
#line 54 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->visible_checkbutton);
#line 54 "../src/Widgets/SourceRow.vala"
	self->priv->visible_checkbutton = _tmp12_;
#line 55 "../src/Widgets/SourceRow.vala"
	_tmp13_ = self->priv->visible_checkbutton;
#line 55 "../src/Widgets/SourceRow.vala"
	_tmp14_ = _data33_->cal;
#line 55 "../src/Widgets/SourceRow.vala"
	_tmp15_ = e_source_selectable_get_selected ((ESourceSelectable*) _tmp14_);
#line 55 "../src/Widgets/SourceRow.vala"
	_tmp16_ = _tmp15_;
#line 55 "../src/Widgets/SourceRow.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp13_, _tmp16_);
#line 56 "../src/Widgets/SourceRow.vala"
	_tmp17_ = self->priv->visible_checkbutton;
#line 56 "../src/Widgets/SourceRow.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp17_, "toggled", (GCallback) ___lambda152__gtk_toggle_button_toggled, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
#line 72 "../src/Widgets/SourceRow.vala"
	_tmp18_ = _data33_->cal;
#line 72 "../src/Widgets/SourceRow.vala"
	_tmp19_ = e_source_selectable_dup_color ((ESourceSelectable*) _tmp18_);
#line 72 "../src/Widgets/SourceRow.vala"
	_tmp20_ = _tmp19_;
#line 72 "../src/Widgets/SourceRow.vala"
	calendar_source_row_style_calendar_color (self, _tmp20_);
#line 72 "../src/Widgets/SourceRow.vala"
	_g_free0 (_tmp20_);
#line 74 "../src/Widgets/SourceRow.vala"
	_tmp21_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-delete-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 74 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp21_);
#line 74 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->delete_button);
#line 74 "../src/Widgets/SourceRow.vala"
	self->priv->delete_button = _tmp21_;
#line 75 "../src/Widgets/SourceRow.vala"
	_tmp23_ = e_source_get_removable (_data33_->source);
#line 75 "../src/Widgets/SourceRow.vala"
	_tmp24_ = _tmp23_;
#line 75 "../src/Widgets/SourceRow.vala"
	if (_tmp24_) {
#line 75 "../src/Widgets/SourceRow.vala"
		_tmp22_ = _ ("Remove");
#line 715 "SourceRow.c"
	} else {
#line 75 "../src/Widgets/SourceRow.vala"
		_tmp22_ = _ ("Not Removable");
#line 719 "SourceRow.c"
	}
#line 75 "../src/Widgets/SourceRow.vala"
	_tmp25_ = self->priv->delete_button;
#line 75 "../src/Widgets/SourceRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp25_, _tmp22_);
#line 76 "../src/Widgets/SourceRow.vala"
	_tmp26_ = self->priv->delete_button;
#line 76 "../src/Widgets/SourceRow.vala"
	gtk_button_set_relief (_tmp26_, GTK_RELIEF_NONE);
#line 77 "../src/Widgets/SourceRow.vala"
	_tmp27_ = self->priv->delete_button;
#line 77 "../src/Widgets/SourceRow.vala"
	_tmp28_ = e_source_get_removable (_data33_->source);
#line 77 "../src/Widgets/SourceRow.vala"
	_tmp29_ = _tmp28_;
#line 77 "../src/Widgets/SourceRow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp27_, _tmp29_);
#line 78 "../src/Widgets/SourceRow.vala"
	_tmp30_ = self->priv->delete_button;
#line 78 "../src/Widgets/SourceRow.vala"
	_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
#line 78 "../src/Widgets/SourceRow.vala"
	gtk_style_context_add_class (_tmp31_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 80 "../src/Widgets/SourceRow.vala"
	_tmp32_ = (GtkRevealer*) gtk_revealer_new ();
#line 80 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp32_);
#line 80 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->delete_revealer);
#line 80 "../src/Widgets/SourceRow.vala"
	self->priv->delete_revealer = _tmp32_;
#line 81 "../src/Widgets/SourceRow.vala"
	_tmp33_ = self->priv->delete_revealer;
#line 81 "../src/Widgets/SourceRow.vala"
	gtk_revealer_set_transition_type (_tmp33_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 82 "../src/Widgets/SourceRow.vala"
	_tmp34_ = self->priv->delete_revealer;
#line 82 "../src/Widgets/SourceRow.vala"
	_tmp35_ = self->priv->delete_button;
#line 82 "../src/Widgets/SourceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
#line 83 "../src/Widgets/SourceRow.vala"
	_tmp36_ = self->priv->delete_revealer;
#line 83 "../src/Widgets/SourceRow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp36_);
#line 84 "../src/Widgets/SourceRow.vala"
	_tmp37_ = self->priv->delete_revealer;
#line 84 "../src/Widgets/SourceRow.vala"
	gtk_revealer_set_reveal_child (_tmp37_, FALSE);
#line 86 "../src/Widgets/SourceRow.vala"
	_tmp38_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 86 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp38_);
#line 86 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->edit_button);
#line 86 "../src/Widgets/SourceRow.vala"
	self->priv->edit_button = _tmp38_;
#line 87 "../src/Widgets/SourceRow.vala"
	_tmp40_ = e_source_get_writable (_data33_->source);
#line 87 "../src/Widgets/SourceRow.vala"
	_tmp41_ = _tmp40_;
#line 87 "../src/Widgets/SourceRow.vala"
	if (_tmp41_) {
#line 87 "../src/Widgets/SourceRow.vala"
		_tmp39_ = _ ("Edit…");
#line 785 "SourceRow.c"
	} else {
#line 87 "../src/Widgets/SourceRow.vala"
		_tmp39_ = _ ("Not Editable");
#line 789 "SourceRow.c"
	}
#line 87 "../src/Widgets/SourceRow.vala"
	_tmp42_ = self->priv->edit_button;
#line 87 "../src/Widgets/SourceRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp42_, _tmp39_);
#line 88 "../src/Widgets/SourceRow.vala"
	_tmp43_ = self->priv->edit_button;
#line 88 "../src/Widgets/SourceRow.vala"
	gtk_button_set_relief (_tmp43_, GTK_RELIEF_NONE);
#line 89 "../src/Widgets/SourceRow.vala"
	_tmp44_ = self->priv->edit_button;
#line 89 "../src/Widgets/SourceRow.vala"
	_tmp45_ = e_source_get_writable (_data33_->source);
#line 89 "../src/Widgets/SourceRow.vala"
	_tmp46_ = _tmp45_;
#line 89 "../src/Widgets/SourceRow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp44_, _tmp46_);
#line 91 "../src/Widgets/SourceRow.vala"
	_tmp47_ = (GtkRevealer*) gtk_revealer_new ();
#line 91 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp47_);
#line 91 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->edit_revealer);
#line 91 "../src/Widgets/SourceRow.vala"
	self->priv->edit_revealer = _tmp47_;
#line 92 "../src/Widgets/SourceRow.vala"
	_tmp48_ = self->priv->edit_revealer;
#line 92 "../src/Widgets/SourceRow.vala"
	gtk_revealer_set_transition_type (_tmp48_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 93 "../src/Widgets/SourceRow.vala"
	_tmp49_ = self->priv->edit_revealer;
#line 93 "../src/Widgets/SourceRow.vala"
	_tmp50_ = self->priv->edit_button;
#line 93 "../src/Widgets/SourceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp49_, (GtkWidget*) _tmp50_);
#line 94 "../src/Widgets/SourceRow.vala"
	_tmp51_ = self->priv->edit_revealer;
#line 94 "../src/Widgets/SourceRow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp51_);
#line 95 "../src/Widgets/SourceRow.vala"
	_tmp52_ = self->priv->edit_revealer;
#line 95 "../src/Widgets/SourceRow.vala"
	gtk_revealer_set_reveal_child (_tmp52_, FALSE);
#line 97 "../src/Widgets/SourceRow.vala"
	_tmp53_ = (GtkGrid*) gtk_grid_new ();
#line 97 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp53_);
#line 97 "../src/Widgets/SourceRow.vala"
	calendar_grid = _tmp53_;
#line 98 "../src/Widgets/SourceRow.vala"
	gtk_grid_set_column_spacing (calendar_grid, 6);
#line 99 "../src/Widgets/SourceRow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) calendar_grid, 8);
#line 100 "../src/Widgets/SourceRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) calendar_grid, 6);
#line 101 "../src/Widgets/SourceRow.vala"
	_tmp54_ = self->priv->visible_checkbutton;
#line 101 "../src/Widgets/SourceRow.vala"
	gtk_grid_attach (calendar_grid, (GtkWidget*) _tmp54_, 0, 0, 1, 1);
#line 102 "../src/Widgets/SourceRow.vala"
	_tmp55_ = self->priv->calendar_name_label;
#line 102 "../src/Widgets/SourceRow.vala"
	gtk_grid_attach (calendar_grid, (GtkWidget*) _tmp55_, 2, 0, 1, 1);
#line 103 "../src/Widgets/SourceRow.vala"
	_tmp56_ = self->priv->delete_revealer;
#line 103 "../src/Widgets/SourceRow.vala"
	gtk_grid_attach (calendar_grid, (GtkWidget*) _tmp56_, 3, 0, 1, 1);
#line 104 "../src/Widgets/SourceRow.vala"
	_tmp57_ = self->priv->edit_revealer;
#line 104 "../src/Widgets/SourceRow.vala"
	gtk_grid_attach (calendar_grid, (GtkWidget*) _tmp57_, 4, 0, 1, 1);
#line 106 "../src/Widgets/SourceRow.vala"
	_tmp58_ = (GtkEventBox*) gtk_event_box_new ();
#line 106 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp58_);
#line 106 "../src/Widgets/SourceRow.vala"
	calendar_event_box = _tmp58_;
#line 107 "../src/Widgets/SourceRow.vala"
	gtk_container_add ((GtkContainer*) calendar_event_box, (GtkWidget*) calendar_grid);
#line 108 "../src/Widgets/SourceRow.vala"
	gtk_widget_show ((GtkWidget*) calendar_event_box);
#line 110 "../src/Widgets/SourceRow.vala"
	_tmp59_ = (GtkButton*) gtk_button_new_with_label (_ ("Undo"));
#line 110 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp59_);
#line 110 "../src/Widgets/SourceRow.vala"
	undo_button = _tmp59_;
#line 111 "../src/Widgets/SourceRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) undo_button, 6);
#line 113 "../src/Widgets/SourceRow.vala"
	_tmp60_ = (GtkButton*) gtk_button_new_from_icon_name ("process-stop-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 113 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp60_);
#line 113 "../src/Widgets/SourceRow.vala"
	close_button = _tmp60_;
#line 114 "../src/Widgets/SourceRow.vala"
	gtk_button_set_relief (close_button, GTK_RELIEF_NONE);
#line 116 "../src/Widgets/SourceRow.vala"
	_tmp61_ = e_source_get_display_name (_data33_->source);
#line 116 "../src/Widgets/SourceRow.vala"
	_tmp62_ = _tmp61_;
#line 116 "../src/Widgets/SourceRow.vala"
	_tmp63_ = g_strdup_printf (_ ("\"%s\" removed"), _tmp62_);
#line 116 "../src/Widgets/SourceRow.vala"
	_tmp64_ = _tmp63_;
#line 116 "../src/Widgets/SourceRow.vala"
	_tmp65_ = (GtkLabel*) gtk_label_new (_tmp64_);
#line 116 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp65_);
#line 116 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->message_label);
#line 116 "../src/Widgets/SourceRow.vala"
	self->priv->message_label = _tmp65_;
#line 116 "../src/Widgets/SourceRow.vala"
	_g_free0 (_tmp64_);
#line 117 "../src/Widgets/SourceRow.vala"
	_tmp66_ = self->priv->message_label;
#line 117 "../src/Widgets/SourceRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp66_, TRUE);
#line 118 "../src/Widgets/SourceRow.vala"
	_tmp67_ = self->priv->message_label;
#line 118 "../src/Widgets/SourceRow.vala"
	gtk_label_set_xalign (_tmp67_, 0.0f);
#line 120 "../src/Widgets/SourceRow.vala"
	_tmp68_ = (GtkGrid*) gtk_grid_new ();
#line 120 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp68_);
#line 120 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->info_grid);
#line 120 "../src/Widgets/SourceRow.vala"
	self->priv->info_grid = _tmp68_;
#line 121 "../src/Widgets/SourceRow.vala"
	_tmp69_ = self->priv->info_grid;
#line 121 "../src/Widgets/SourceRow.vala"
	gtk_grid_set_column_spacing (_tmp69_, 12);
#line 122 "../src/Widgets/SourceRow.vala"
	_tmp70_ = self->priv->info_grid;
#line 122 "../src/Widgets/SourceRow.vala"
	gtk_grid_set_row_spacing (_tmp70_, 6);
#line 123 "../src/Widgets/SourceRow.vala"
	_tmp71_ = self->priv->info_grid;
#line 123 "../src/Widgets/SourceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp71_, (GtkWidget*) close_button);
#line 124 "../src/Widgets/SourceRow.vala"
	_tmp72_ = self->priv->info_grid;
#line 124 "../src/Widgets/SourceRow.vala"
	_tmp73_ = self->priv->message_label;
#line 124 "../src/Widgets/SourceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp72_, (GtkWidget*) _tmp73_);
#line 125 "../src/Widgets/SourceRow.vala"
	_tmp74_ = self->priv->info_grid;
#line 125 "../src/Widgets/SourceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp74_, (GtkWidget*) undo_button);
#line 127 "../src/Widgets/SourceRow.vala"
	_tmp75_ = (GtkStack*) gtk_stack_new ();
#line 127 "../src/Widgets/SourceRow.vala"
	g_object_ref_sink (_tmp75_);
#line 127 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->stack);
#line 127 "../src/Widgets/SourceRow.vala"
	self->priv->stack = _tmp75_;
#line 128 "../src/Widgets/SourceRow.vala"
	_tmp76_ = self->priv->stack;
#line 128 "../src/Widgets/SourceRow.vala"
	gtk_stack_set_transition_type (_tmp76_, GTK_STACK_TRANSITION_TYPE_OVER_RIGHT_LEFT);
#line 129 "../src/Widgets/SourceRow.vala"
	_tmp77_ = self->priv->stack;
#line 129 "../src/Widgets/SourceRow.vala"
	_tmp78_ = self->priv->info_grid;
#line 129 "../src/Widgets/SourceRow.vala"
	gtk_stack_add_named (_tmp77_, (GtkWidget*) _tmp78_, "info");
#line 130 "../src/Widgets/SourceRow.vala"
	_tmp79_ = self->priv->stack;
#line 130 "../src/Widgets/SourceRow.vala"
	gtk_stack_add_named (_tmp79_, (GtkWidget*) calendar_event_box, "calendar");
#line 131 "../src/Widgets/SourceRow.vala"
	_tmp80_ = self->priv->stack;
#line 131 "../src/Widgets/SourceRow.vala"
	gtk_stack_set_visible_child_name (_tmp80_, "calendar");
#line 133 "../src/Widgets/SourceRow.vala"
	_tmp81_ = self->priv->stack;
#line 133 "../src/Widgets/SourceRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp81_);
#line 135 "../src/Widgets/SourceRow.vala"
	g_signal_connect_object (close_button, "clicked", (GCallback) ___lambda153__gtk_button_clicked, self, 0);
#line 140 "../src/Widgets/SourceRow.vala"
	_tmp82_ = self->priv->delete_button;
#line 140 "../src/Widgets/SourceRow.vala"
	g_signal_connect_data (_tmp82_, "clicked", (GCallback) ___lambda154__gtk_button_clicked, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
#line 142 "../src/Widgets/SourceRow.vala"
	_tmp83_ = self->priv->edit_button;
#line 142 "../src/Widgets/SourceRow.vala"
	g_signal_connect_data (_tmp83_, "clicked", (GCallback) ___lambda155__gtk_button_clicked, block33_data_ref (_data33_), (GClosureNotify) block33_data_unref, 0);
#line 144 "../src/Widgets/SourceRow.vala"
	g_signal_connect_object (undo_button, "clicked", (GCallback) ___lambda156__gtk_button_clicked, self, 0);
#line 149 "../src/Widgets/SourceRow.vala"
	gtk_widget_add_events ((GtkWidget*) calendar_event_box, (gint) (GDK_ENTER_NOTIFY_MASK | GDK_LEAVE_NOTIFY_MASK));
#line 150 "../src/Widgets/SourceRow.vala"
	g_signal_connect_object ((GtkWidget*) calendar_event_box, "enter-notify-event", (GCallback) ___lambda157__gtk_widget_enter_notify_event, self, 0);
#line 156 "../src/Widgets/SourceRow.vala"
	g_signal_connect_object ((GtkWidget*) calendar_event_box, "leave-notify-event", (GCallback) ___lambda158__gtk_widget_leave_notify_event, self, 0);
#line 165 "../src/Widgets/SourceRow.vala"
	g_signal_connect_object (_data33_->source, "changed", (GCallback) _calendar_source_row_source_has_changed_e_source_changed, self, 0);
#line 41 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (close_button);
#line 41 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (undo_button);
#line 41 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (calendar_event_box);
#line 41 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (calendar_grid);
#line 41 "../src/Widgets/SourceRow.vala"
	block33_data_unref (_data33_);
#line 41 "../src/Widgets/SourceRow.vala"
	_data33_ = NULL;
#line 41 "../src/Widgets/SourceRow.vala"
	return self;
#line 1007 "SourceRow.c"
}

CalendarSourceRow*
calendar_source_row_new (ESource* source)
{
#line 41 "../src/Widgets/SourceRow.vala"
	return calendar_source_row_construct (CALENDAR_TYPE_SOURCE_ROW, source);
#line 1015 "SourceRow.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 1042 "SourceRow.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 1048 "SourceRow.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1054 "SourceRow.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1058 "SourceRow.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1066 "SourceRow.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1070 "SourceRow.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 1082 "SourceRow.c"
}

static void
calendar_source_row_style_calendar_color (CalendarSourceRow* self,
                                          const gchar* color)
{
	gchar* css_color = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkCssProvider* style_provider = NULL;
	GtkCssProvider* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 168 "../src/Widgets/SourceRow.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/Widgets/SourceRow.vala"
	g_return_if_fail (color != NULL);
#line 169 "../src/Widgets/SourceRow.vala"
	_tmp0_ = string_slice (color, (glong) 0, (glong) 7);
#line 169 "../src/Widgets/SourceRow.vala"
	_tmp1_ = _tmp0_;
#line 169 "../src/Widgets/SourceRow.vala"
	_tmp2_ = g_strdup_printf ("@define-color accent_color %s;", _tmp1_);
#line 169 "../src/Widgets/SourceRow.vala"
	_tmp3_ = _tmp2_;
#line 169 "../src/Widgets/SourceRow.vala"
	_g_free0 (_tmp1_);
#line 169 "../src/Widgets/SourceRow.vala"
	css_color = _tmp3_;
#line 171 "../src/Widgets/SourceRow.vala"
	_tmp4_ = gtk_css_provider_new ();
#line 171 "../src/Widgets/SourceRow.vala"
	style_provider = _tmp4_;
#line 1117 "SourceRow.c"
	{
		gint _tmp5_;
		gint _tmp6_;
		GtkCheckButton* _tmp7_;
		GtkStyleContext* _tmp8_;
#line 174 "../src/Widgets/SourceRow.vala"
		_tmp5_ = strlen (css_color);
#line 174 "../src/Widgets/SourceRow.vala"
		_tmp6_ = _tmp5_;
#line 174 "../src/Widgets/SourceRow.vala"
		gtk_css_provider_load_from_data (style_provider, css_color, (gssize) _tmp6_, &_inner_error0_);
#line 174 "../src/Widgets/SourceRow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1131 "SourceRow.c"
			goto __catch0_g_error;
		}
#line 175 "../src/Widgets/SourceRow.vala"
		_tmp7_ = self->priv->visible_checkbutton;
#line 175 "../src/Widgets/SourceRow.vala"
		_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 175 "../src/Widgets/SourceRow.vala"
		gtk_style_context_add_provider (_tmp8_, (GtkStyleProvider*) style_provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 1140 "SourceRow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 173 "../src/Widgets/SourceRow.vala"
		e = _inner_error0_;
#line 173 "../src/Widgets/SourceRow.vala"
		_inner_error0_ = NULL;
#line 177 "../src/Widgets/SourceRow.vala"
		_tmp9_ = e;
#line 177 "../src/Widgets/SourceRow.vala"
		_tmp10_ = _tmp9_->message;
#line 177 "../src/Widgets/SourceRow.vala"
		g_warning ("SourceRow.vala:177: Could not create CSS Provider: %s\n" \
"Stylesheet:\n" \
"%s", _tmp10_, css_color);
#line 173 "../src/Widgets/SourceRow.vala"
		_g_error_free0 (e);
#line 1160 "SourceRow.c"
	}
	__finally0:
#line 173 "../src/Widgets/SourceRow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "../src/Widgets/SourceRow.vala"
		_g_object_unref0 (style_provider);
#line 173 "../src/Widgets/SourceRow.vala"
		_g_free0 (css_color);
#line 173 "../src/Widgets/SourceRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 173 "../src/Widgets/SourceRow.vala"
		g_clear_error (&_inner_error0_);
#line 173 "../src/Widgets/SourceRow.vala"
		return;
#line 1175 "SourceRow.c"
	}
#line 168 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (style_provider);
#line 168 "../src/Widgets/SourceRow.vala"
	_g_free0 (css_color);
#line 1181 "SourceRow.c"
}

void
calendar_source_row_source_has_changed (CalendarSourceRow* self)
{
	GtkLabel* _tmp0_;
	ESource* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	ESource* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	ESourceCalendar* cal = NULL;
	ESource* _tmp10_;
	ESourceExtension* _tmp11_;
	ESourceCalendar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkCheckButton* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
#line 181 "../src/Widgets/SourceRow.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/Widgets/SourceRow.vala"
	_tmp0_ = self->priv->calendar_name_label;
#line 182 "../src/Widgets/SourceRow.vala"
	_tmp1_ = self->priv->_source;
#line 182 "../src/Widgets/SourceRow.vala"
	_tmp2_ = e_source_dup_display_name (_tmp1_);
#line 182 "../src/Widgets/SourceRow.vala"
	_tmp3_ = _tmp2_;
#line 182 "../src/Widgets/SourceRow.vala"
	gtk_label_set_label (_tmp0_, _tmp3_);
#line 182 "../src/Widgets/SourceRow.vala"
	_g_free0 (_tmp3_);
#line 183 "../src/Widgets/SourceRow.vala"
	_tmp4_ = self->priv->message_label;
#line 183 "../src/Widgets/SourceRow.vala"
	_tmp5_ = self->priv->_source;
#line 183 "../src/Widgets/SourceRow.vala"
	_tmp6_ = e_source_get_display_name (_tmp5_);
#line 183 "../src/Widgets/SourceRow.vala"
	_tmp7_ = _tmp6_;
#line 183 "../src/Widgets/SourceRow.vala"
	_tmp8_ = g_strdup_printf (_ ("\"%s\" removed"), _tmp7_);
#line 183 "../src/Widgets/SourceRow.vala"
	_tmp9_ = _tmp8_;
#line 183 "../src/Widgets/SourceRow.vala"
	gtk_label_set_label (_tmp4_, _tmp9_);
#line 183 "../src/Widgets/SourceRow.vala"
	_g_free0 (_tmp9_);
#line 185 "../src/Widgets/SourceRow.vala"
	_tmp10_ = self->priv->_source;
#line 185 "../src/Widgets/SourceRow.vala"
	_tmp11_ = e_source_get_extension (_tmp10_, E_SOURCE_EXTENSION_CALENDAR);
#line 185 "../src/Widgets/SourceRow.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, e_source_calendar_get_type (), ESourceCalendar));
#line 185 "../src/Widgets/SourceRow.vala"
	cal = _tmp12_;
#line 187 "../src/Widgets/SourceRow.vala"
	_tmp13_ = e_source_selectable_dup_color ((ESourceSelectable*) cal);
#line 187 "../src/Widgets/SourceRow.vala"
	_tmp14_ = _tmp13_;
#line 187 "../src/Widgets/SourceRow.vala"
	calendar_source_row_style_calendar_color (self, _tmp14_);
#line 187 "../src/Widgets/SourceRow.vala"
	_g_free0 (_tmp14_);
#line 189 "../src/Widgets/SourceRow.vala"
	_tmp15_ = self->priv->visible_checkbutton;
#line 189 "../src/Widgets/SourceRow.vala"
	_tmp16_ = e_source_selectable_get_selected ((ESourceSelectable*) cal);
#line 189 "../src/Widgets/SourceRow.vala"
	_tmp17_ = _tmp16_;
#line 189 "../src/Widgets/SourceRow.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp15_, _tmp17_);
#line 181 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (cal);
#line 1262 "SourceRow.c"
}

void
calendar_source_row_show_calendar_removed (CalendarSourceRow* self)
{
	GtkStack* _tmp0_;
#line 192 "../src/Widgets/SourceRow.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/Widgets/SourceRow.vala"
	_tmp0_ = self->priv->stack;
#line 193 "../src/Widgets/SourceRow.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "info");
#line 1275 "SourceRow.c"
}

const gchar*
calendar_source_row_get_location (CalendarSourceRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../src/Widgets/SourceRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Widgets/SourceRow.vala"
	_tmp0_ = self->priv->_location;
#line 25 "../src/Widgets/SourceRow.vala"
	result = _tmp0_;
#line 25 "../src/Widgets/SourceRow.vala"
	return result;
#line 1291 "SourceRow.c"
}

static void
calendar_source_row_set_location (CalendarSourceRow* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 25 "../src/Widgets/SourceRow.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/SourceRow.vala"
	old_value = calendar_source_row_get_location (self);
#line 25 "../src/Widgets/SourceRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1305 "SourceRow.c"
		gchar* _tmp0_;
#line 25 "../src/Widgets/SourceRow.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../src/Widgets/SourceRow.vala"
		_g_free0 (self->priv->_location);
#line 25 "../src/Widgets/SourceRow.vala"
		self->priv->_location = _tmp0_;
#line 25 "../src/Widgets/SourceRow.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_source_row_properties[CALENDAR_SOURCE_ROW_LOCATION_PROPERTY]);
#line 1315 "SourceRow.c"
	}
}

const gchar*
calendar_source_row_get_label (CalendarSourceRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/Widgets/SourceRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Widgets/SourceRow.vala"
	_tmp0_ = self->priv->_label;
#line 26 "../src/Widgets/SourceRow.vala"
	result = _tmp0_;
#line 26 "../src/Widgets/SourceRow.vala"
	return result;
#line 1332 "SourceRow.c"
}

static void
calendar_source_row_set_label (CalendarSourceRow* self,
                               const gchar* value)
{
	gchar* old_value;
#line 26 "../src/Widgets/SourceRow.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Widgets/SourceRow.vala"
	old_value = calendar_source_row_get_label (self);
#line 26 "../src/Widgets/SourceRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1346 "SourceRow.c"
		gchar* _tmp0_;
#line 26 "../src/Widgets/SourceRow.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/Widgets/SourceRow.vala"
		_g_free0 (self->priv->_label);
#line 26 "../src/Widgets/SourceRow.vala"
		self->priv->_label = _tmp0_;
#line 26 "../src/Widgets/SourceRow.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_source_row_properties[CALENDAR_SOURCE_ROW_LABEL_PROPERTY]);
#line 1356 "SourceRow.c"
	}
}

ESource*
calendar_source_row_get_source (CalendarSourceRow* self)
{
	ESource* result;
	ESource* _tmp0_;
#line 27 "../src/Widgets/SourceRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Widgets/SourceRow.vala"
	_tmp0_ = self->priv->_source;
#line 27 "../src/Widgets/SourceRow.vala"
	result = _tmp0_;
#line 27 "../src/Widgets/SourceRow.vala"
	return result;
#line 1373 "SourceRow.c"
}

static void
calendar_source_row_set_source (CalendarSourceRow* self,
                                ESource* value)
{
	ESource* old_value;
#line 27 "../src/Widgets/SourceRow.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Widgets/SourceRow.vala"
	old_value = calendar_source_row_get_source (self);
#line 27 "../src/Widgets/SourceRow.vala"
	if (old_value != value) {
#line 1387 "SourceRow.c"
		ESource* _tmp0_;
#line 27 "../src/Widgets/SourceRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../src/Widgets/SourceRow.vala"
		_g_object_unref0 (self->priv->_source);
#line 27 "../src/Widgets/SourceRow.vala"
		self->priv->_source = _tmp0_;
#line 27 "../src/Widgets/SourceRow.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_source_row_properties[CALENDAR_SOURCE_ROW_SOURCE_PROPERTY]);
#line 1397 "SourceRow.c"
	}
}

static void
calendar_source_row_class_init (CalendarSourceRowClass * klass,
                                gpointer klass_data)
{
#line 21 "../src/Widgets/SourceRow.vala"
	calendar_source_row_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/SourceRow.vala"
	g_type_class_adjust_private_offset (klass, &CalendarSourceRow_private_offset);
#line 21 "../src/Widgets/SourceRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_calendar_source_row_get_property;
#line 21 "../src/Widgets/SourceRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_calendar_source_row_set_property;
#line 21 "../src/Widgets/SourceRow.vala"
	G_OBJECT_CLASS (klass)->finalize = calendar_source_row_finalize;
#line 21 "../src/Widgets/SourceRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_SOURCE_ROW_LOCATION_PROPERTY, calendar_source_row_properties[CALENDAR_SOURCE_ROW_LOCATION_PROPERTY] = g_param_spec_string ("location", "location", "location", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Widgets/SourceRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_SOURCE_ROW_LABEL_PROPERTY, calendar_source_row_properties[CALENDAR_SOURCE_ROW_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Widgets/SourceRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_SOURCE_ROW_SOURCE_PROPERTY, calendar_source_row_properties[CALENDAR_SOURCE_ROW_SOURCE_PROPERTY] = g_param_spec_object ("source", "source", "source", e_source_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Widgets/SourceRow.vala"
	calendar_source_row_signals[CALENDAR_SOURCE_ROW_REMOVE_REQUEST_SIGNAL] = g_signal_new ("remove-request", CALENDAR_TYPE_SOURCE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, e_source_get_type ());
#line 21 "../src/Widgets/SourceRow.vala"
	calendar_source_row_signals[CALENDAR_SOURCE_ROW_EDIT_REQUEST_SIGNAL] = g_signal_new ("edit-request", CALENDAR_TYPE_SOURCE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, e_source_get_type ());
#line 1425 "SourceRow.c"
}

static void
calendar_source_row_instance_init (CalendarSourceRow * self,
                                   gpointer klass)
{
#line 21 "../src/Widgets/SourceRow.vala"
	self->priv = calendar_source_row_get_instance_private (self);
#line 1434 "SourceRow.c"
}

static void
calendar_source_row_finalize (GObject * obj)
{
	CalendarSourceRow * self;
#line 21 "../src/Widgets/SourceRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CALENDAR_TYPE_SOURCE_ROW, CalendarSourceRow);
#line 25 "../src/Widgets/SourceRow.vala"
	_g_free0 (self->priv->_location);
#line 26 "../src/Widgets/SourceRow.vala"
	_g_free0 (self->priv->_label);
#line 27 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->_source);
#line 29 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->stack);
#line 30 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->info_grid);
#line 32 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->delete_button);
#line 33 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->delete_revealer);
#line 34 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->edit_button);
#line 35 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->edit_revealer);
#line 37 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->calendar_name_label);
#line 38 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->message_label);
#line 39 "../src/Widgets/SourceRow.vala"
	_g_object_unref0 (self->priv->visible_checkbutton);
#line 21 "../src/Widgets/SourceRow.vala"
	G_OBJECT_CLASS (calendar_source_row_parent_class)->finalize (obj);
#line 1469 "SourceRow.c"
}

static GType
calendar_source_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CalendarSourceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) calendar_source_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CalendarSourceRow), 0, (GInstanceInitFunc) calendar_source_row_instance_init, NULL };
	GType calendar_source_row_type_id;
	calendar_source_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "CalendarSourceRow", &g_define_type_info, 0);
	CalendarSourceRow_private_offset = g_type_add_instance_private (calendar_source_row_type_id, sizeof (CalendarSourceRowPrivate));
	return calendar_source_row_type_id;
}

GType
calendar_source_row_get_type (void)
{
	static volatile gsize calendar_source_row_type_id__once = 0;
	if (g_once_init_enter (&calendar_source_row_type_id__once)) {
		GType calendar_source_row_type_id;
		calendar_source_row_type_id = calendar_source_row_get_type_once ();
		g_once_init_leave (&calendar_source_row_type_id__once, calendar_source_row_type_id);
	}
	return calendar_source_row_type_id__once;
}

static void
_vala_calendar_source_row_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	CalendarSourceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CALENDAR_TYPE_SOURCE_ROW, CalendarSourceRow);
#line 21 "../src/Widgets/SourceRow.vala"
	switch (property_id) {
#line 21 "../src/Widgets/SourceRow.vala"
		case CALENDAR_SOURCE_ROW_LOCATION_PROPERTY:
#line 21 "../src/Widgets/SourceRow.vala"
		g_value_set_string (value, calendar_source_row_get_location (self));
#line 21 "../src/Widgets/SourceRow.vala"
		break;
#line 21 "../src/Widgets/SourceRow.vala"
		case CALENDAR_SOURCE_ROW_LABEL_PROPERTY:
#line 21 "../src/Widgets/SourceRow.vala"
		g_value_set_string (value, calendar_source_row_get_label (self));
#line 21 "../src/Widgets/SourceRow.vala"
		break;
#line 21 "../src/Widgets/SourceRow.vala"
		case CALENDAR_SOURCE_ROW_SOURCE_PROPERTY:
#line 21 "../src/Widgets/SourceRow.vala"
		g_value_set_object (value, calendar_source_row_get_source (self));
#line 21 "../src/Widgets/SourceRow.vala"
		break;
#line 1522 "SourceRow.c"
		default:
#line 21 "../src/Widgets/SourceRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/SourceRow.vala"
		break;
#line 1528 "SourceRow.c"
	}
}

static void
_vala_calendar_source_row_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	CalendarSourceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CALENDAR_TYPE_SOURCE_ROW, CalendarSourceRow);
#line 21 "../src/Widgets/SourceRow.vala"
	switch (property_id) {
#line 21 "../src/Widgets/SourceRow.vala"
		case CALENDAR_SOURCE_ROW_LOCATION_PROPERTY:
#line 21 "../src/Widgets/SourceRow.vala"
		calendar_source_row_set_location (self, g_value_get_string (value));
#line 21 "../src/Widgets/SourceRow.vala"
		break;
#line 21 "../src/Widgets/SourceRow.vala"
		case CALENDAR_SOURCE_ROW_LABEL_PROPERTY:
#line 21 "../src/Widgets/SourceRow.vala"
		calendar_source_row_set_label (self, g_value_get_string (value));
#line 21 "../src/Widgets/SourceRow.vala"
		break;
#line 21 "../src/Widgets/SourceRow.vala"
		case CALENDAR_SOURCE_ROW_SOURCE_PROPERTY:
#line 21 "../src/Widgets/SourceRow.vala"
		calendar_source_row_set_source (self, g_value_get_object (value));
#line 21 "../src/Widgets/SourceRow.vala"
		break;
#line 1560 "SourceRow.c"
		default:
#line 21 "../src/Widgets/SourceRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/SourceRow.vala"
		break;
#line 1566 "SourceRow.c"
	}
}

