/* EventStore.c generated by valac 0.56.18, the Vala compiler
 * generated from EventStore.vala, do not modify */

/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "elementary-calendar.h"
#include <libedataserver/libedataserver.h>
#include <glib.h>
#include <libecal/libecal.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include <libedataserverui/libedataserverui.h>
#include <gio/gio.h>
#include <libical-glib/libical-glib.h>
#include <langinfo.h>
#include <float.h>
#include <math.h>
#include <time.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	CALENDAR_EVENT_STORE_0_PROPERTY,
	CALENDAR_EVENT_STORE_DATA_RANGE_PROPERTY,
	CALENDAR_EVENT_STORE_MONTH_RANGE_PROPERTY,
	CALENDAR_EVENT_STORE_REGISTRY_PROPERTY,
	CALENDAR_EVENT_STORE_MONTH_START_PROPERTY,
	CALENDAR_EVENT_STORE_NUM_WEEKS_PROPERTY,
	CALENDAR_EVENT_STORE_WEEK_STARTS_ON_PROPERTY,
	CALENDAR_EVENT_STORE_DRAG_COMPONENT_PROPERTY,
	CALENDAR_EVENT_STORE_NUM_PROPERTIES
};
static GParamSpec* calendar_event_store_properties[CALENDAR_EVENT_STORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _CalendarEventStoreOpenData CalendarEventStoreOpenData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _CalendarEventStoreAddEventAsyncData CalendarEventStoreAddEventAsyncData;
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _CalendarEventStoreAddSourceAsyncData CalendarEventStoreAddSourceAsyncData;
#define __vala_ECalComponentId_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentId_free (var), NULL)))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
enum  {
	CALENDAR_EVENT_STORE_EVENTS_ADDED_SIGNAL,
	CALENDAR_EVENT_STORE_EVENTS_UPDATED_SIGNAL,
	CALENDAR_EVENT_STORE_EVENTS_REMOVED_SIGNAL,
	CALENDAR_EVENT_STORE_CONNECTING_SIGNAL,
	CALENDAR_EVENT_STORE_CONNECTED_SIGNAL,
	CALENDAR_EVENT_STORE_ERROR_RECEIVED_SIGNAL,
	CALENDAR_EVENT_STORE_PARAMETERS_CHANGED_SIGNAL,
	CALENDAR_EVENT_STORE_NUM_SIGNALS
};
static guint calendar_event_store_signals[CALENDAR_EVENT_STORE_NUM_SIGNALS] = {0};

struct _CalendarEventStorePrivate {
	CalendarUtilDateRange* _data_range;
	CalendarUtilDateRange* _month_range;
	ESourceRegistry* _registry;
	GDateTime* _month_start;
	gint _num_weeks;
	GDateWeekday _week_starts_on;
	ECalComponent* _drag_component;
	GHashTable* source_client;
	GRecMutex __lock_source_client;
	GHashTable* source_view;
	GHashTable* source_events;
	ECredentialsPrompter* credentials_prompter;
};

struct _CalendarEventStoreOpenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CalendarEventStore* self;
	ESourceRegistry* _tmp0_;
	ESourceRegistry* _tmp1_;
	ESourceRegistry* _tmp2_;
	ECredentialsPrompter* _tmp3_;
	ECredentialsPrompter* _tmp4_;
	ESourceRegistry* _tmp5_;
	ESourceRegistry* _tmp6_;
	ESourceRegistry* _tmp7_;
	ESourceRegistry* _tmp8_;
	GList* _tmp9_;
	GList* _tmp10_;
	GError* _error_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

struct _CalendarEventStoreAddEventAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CalendarEventStore* self;
	ESource* source;
	ECalComponent* event;
	ICalComponent* comp;
	ICalComponent* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	ECalClient* client;
	GHashTable* _tmp5_;
	GHashTable* _tmp6_;
	const gchar* _tmp7_;
	gconstpointer _tmp8_;
	ECalClient* _tmp9_;
	GHashTable* _tmp10_;
	gchar* uid;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GError* _error_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

struct _Block1Data {
	int _ref_count_;
	CalendarEventStore* self;
	ECalClient* client;
	ESource* source;
	ECalComponent* event;
};

struct _Block2Data {
	int _ref_count_;
	CalendarEventStore* self;
	ECalClient* client;
};

struct _Block3Data {
	int _ref_count_;
	CalendarEventStore* self;
	GeeArrayList* events;
};

struct _Block4Data {
	int _ref_count_;
	CalendarEventStore* self;
	ECalClient* client;
	ESource* source;
};

struct _Block5Data {
	int _ref_count_;
	CalendarEventStore* self;
	ESource* source;
	gpointer _async_data_;
};

struct _CalendarEventStoreAddSourceAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CalendarEventStore* self;
	ESource* source;
	Block5Data* _data5_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GCancellable* cancellable;
	GCancellable* _tmp2_;
	EClient* _tmp3_;
	EClient* _tmp4_;
	ECalClient* client;
	ECalClient* _tmp5_;
	GHashTable* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	ECalClient* _tmp9_;
	ECalClient* _tmp10_;
	GError* e;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

struct _Block6Data {
	int _ref_count_;
	CalendarEventStore* self;
	GeeTreeMultiMap* events;
	GeeArrayList* added_events;
	ESource* source;
	ECalClient* client;
};

struct _Block7Data {
	int _ref_count_;
	Block6Data * _data6_;
	const gchar* uid;
};

struct _Block8Data {
	int _ref_count_;
	CalendarEventStore* self;
	GeeArrayList* updated_events;
	GeeArrayList* removed_events;
	GeeArrayList* added_events;
	ESource* source;
	ECalClient* client;
};

struct _Block9Data {
	int _ref_count_;
	Block8Data * _data8_;
	const gchar* uid;
	GeeTreeMultiMap* events_for_source;
};

struct _Block10Data {
	int _ref_count_;
	CalendarEventStore* self;
	GeeTreeMultiMap* events;
	GeeArrayList* removed_events;
	ESource* source;
};

static gint CalendarEventStore_private_offset;
static gpointer calendar_event_store_parent_class = NULL;
static CalendarEventStore* calendar_event_store_store;
static CalendarEventStore* calendar_event_store_store = NULL;
static GSettings* calendar_event_store_state_settings;
static GSettings* calendar_event_store_state_settings = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_queue_free__g_object_unref0_ (GQueue* self);
static GDateWeekday calendar_event_store_get_week_start (CalendarEventStore* self);
static GDateTime* calendar_event_store_get_page (CalendarEventStore* self);
static void calendar_event_store_compute_ranges (CalendarEventStore* self);
static void _g_free0_ (gpointer var);
static guint _e_source_hash_ghash_func (gconstpointer key);
static gboolean _e_source_equal_gequal_func (gconstpointer a,
                                      gconstpointer b);
static void calendar_event_store_on_parameter_changed (CalendarEventStore* self);
static void _calendar_event_store_on_parameter_changed_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void calendar_event_store_open_data_free (gpointer _data);
static gboolean calendar_event_store_open_co (CalendarEventStoreOpenData* _data_);
static void calendar_event_store_open_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void calendar_event_store_set_registry (CalendarEventStore* self,
                                        ESourceRegistry* value);
static void _calendar_event_store_remove_source_e_source_registry_source_removed (ESourceRegistry* _sender,
                                                                           ESource* source,
                                                                           gpointer self);
static void calendar_event_store_on_source_changed (CalendarEventStore* self,
                                             ESource* source);
static void _calendar_event_store_on_source_changed_e_source_registry_source_changed (ESourceRegistry* _sender,
                                                                               ESource* source,
                                                                               gpointer self);
static void _calendar_event_store_add_source_e_source_registry_source_added (ESourceRegistry* _sender,
                                                                      ESource* source,
                                                                      gpointer self);
static void ___lambda14_ (CalendarEventStore* self,
                   ESource* source);
static void ____lambda14__gfunc (gconstpointer data,
                          gpointer self);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void calendar_event_store_add_event_async (CalendarEventStore* self,
                                           ESource* source,
                                           ECalComponent* event,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void calendar_event_store_add_event_finish (CalendarEventStore* self,
                                            GAsyncResult* _res_);
static void calendar_event_store_add_event_async_data_free (gpointer _data);
static gboolean calendar_event_store_add_event_async_co (CalendarEventStoreAddEventAsyncData* _data_);
static void calendar_event_store_add_event_async_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda15_ (Block1Data* _data1_,
                  GObject* obj,
                  GAsyncResult* results);
static void ___lambda15__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda16_ (Block2Data* _data2_,
                  GObject* obj,
                  GAsyncResult* results);
static void ___lambda16__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void calendar_event_store_load_source (CalendarEventStore* self,
                                       ESource* source);
static void calendar_event_store_add_source_async (CalendarEventStore* self,
                                            ESource* source,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static void calendar_event_store_add_source_finish (CalendarEventStore* self,
                                             GAsyncResult* _res_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda17_ (Block3Data* _data3_,
                  ESource* source);
static void ___lambda17__gfunc (gconstpointer data,
                         gpointer self);
static void calendar_event_store_set_month_range (CalendarEventStore* self,
                                           CalendarUtilDateRange* value);
static void calendar_event_store_set_data_range (CalendarEventStore* self,
                                          CalendarUtilDateRange* value);
static void calendar_event_store_set_num_weeks (CalendarEventStore* self,
                                         gint value);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda4_ (Block4Data* _data4_,
                 GObject* obj,
                 GAsyncResult* results);
static void ___lambda5_ (Block4Data* _data4_,
                  GSList* objects);
static void calendar_event_store_on_objects_added (CalendarEventStore* self,
                                            ESource* source,
                                            ECalClient* client,
                                            GSList* objects);
static void ____lambda5__e_cal_client_view_objects_added (ECalClientView* _sender,
                                                   GSList* objects,
                                                   gpointer self);
static void ___lambda8_ (Block4Data* _data4_,
                  GSList* objects);
static void calendar_event_store_on_objects_removed (CalendarEventStore* self,
                                              ESource* source,
                                              ECalClient* client,
                                              GSList* cids);
static void ____lambda8__e_cal_client_view_objects_removed (ECalClientView* _sender,
                                                     GSList* uids,
                                                     gpointer self);
static void ___lambda10_ (Block4Data* _data4_,
                   GSList* objects);
static void calendar_event_store_on_objects_modified (CalendarEventStore* self,
                                               ESource* source,
                                               ECalClient* client,
                                               GSList* objects);
static void ____lambda10__e_cal_client_view_objects_modified (ECalClientView* _sender,
                                                       GSList* objects,
                                                       gpointer self);
static void ___lambda4__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void calendar_event_store_add_source_async_data_free (gpointer _data);
static gboolean calendar_event_store_add_source_async_co (CalendarEventStoreAddSourceAsyncData* _data_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void calendar_event_store_add_source_async_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static gboolean __lambda13_ (Block5Data* _data5_);
static gboolean ___lambda13__gsource_func (gpointer self);
static void calendar_event_store_debug_event (CalendarEventStore* self,
                                       ESource* source,
                                       ECalComponent* event,
                                       const gchar* message);
static void _vala_ECalComponentId_free (ECalComponentId* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda6_ (Block6Data* _data6_,
                 ICalComponent* comp);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block7Data* _data7_,
                     ICalComponent* comp,
                     ICalTime* start,
                     ICalTime* end,
                     GError** error);
static gboolean ___lambda7__ecal_recur_instance_cb (ICalComponent* icomp,
                                             ICalTime* instance_start,
                                             ICalTime* instance_end,
                                             gpointer self,
                                             GCancellable* cancellable,
                                             GError** error);
static void ___lambda6__gfunc (gconstpointer data,
                        gpointer self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda11_ (Block8Data* _data8_,
                  ICalComponent* comp);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static gboolean ___lambda12_ (Block9Data* _data9_,
                       ICalComponent* comp,
                       ICalTime* start,
                       ICalTime* end,
                       GError** error);
static gboolean ____lambda12__ecal_recur_instance_cb (ICalComponent* icomp,
                                               ICalTime* instance_start,
                                               ICalTime* instance_end,
                                               gpointer self,
                                               GCancellable* cancellable,
                                               GError** error);
static void ___lambda11__gfunc (gconstpointer data,
                         gpointer self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda9_ (Block10Data* _data10_,
                 ECalComponentId* cid);
static void ___lambda9__gfunc (gconstpointer data,
                        gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void calendar_event_store_finalize (GObject * obj);
static GType calendar_event_store_get_type_once (void);
static void _vala_calendar_event_store_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_calendar_event_store_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
calendar_event_store_get_instance_private (CalendarEventStore* self)
{
	return G_STRUCT_MEMBER_P (self, CalendarEventStore_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 59 "../core/Services/Calendar/EventStore.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 477 "EventStore.c"
}

static inline void
_g_queue_free__g_object_unref0_ (GQueue* self)
{
#line 59 "../core/Services/Calendar/EventStore.vala"
	g_queue_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 485 "EventStore.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 68 "../core/Services/Calendar/EventStore.vala"
	return self ? g_object_ref (self) : NULL;
#line 493 "EventStore.c"
}

CalendarEventStore*
calendar_event_store_get_default (void)
{
	CalendarEventStore* _tmp0_;
	CalendarEventStore* _tmp2_;
	CalendarEventStore* _tmp3_;
	CalendarEventStore* result;
#line 66 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = calendar_event_store_store;
#line 66 "../core/Services/Calendar/EventStore.vala"
	if (_tmp0_ == NULL) {
#line 507 "EventStore.c"
		CalendarEventStore* _tmp1_;
#line 67 "../core/Services/Calendar/EventStore.vala"
		_tmp1_ = calendar_event_store_new ();
#line 67 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (calendar_event_store_store);
#line 67 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_store = _tmp1_;
#line 515 "EventStore.c"
	}
#line 68 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = calendar_event_store_store;
#line 68 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 68 "../core/Services/Calendar/EventStore.vala"
	result = _tmp3_;
#line 68 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 525 "EventStore.c"
}

static void
_g_free0_ (gpointer var)
{
#line 82 "../core/Services/Calendar/EventStore.vala"
	var = (g_free (var), NULL);
#line 533 "EventStore.c"
}

static guint
_e_source_hash_ghash_func (gconstpointer key)
{
	guint result;
	result = e_source_hash (key);
#line 83 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 543 "EventStore.c"
}

static gboolean
_e_source_equal_gequal_func (gconstpointer a,
                             gconstpointer b)
{
	gboolean result;
	result = e_source_equal (a, (ESource*) b);
#line 83 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 554 "EventStore.c"
}

static void
_calendar_event_store_on_parameter_changed_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
#line 87 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_on_parameter_changed ((CalendarEventStore*) self);
#line 564 "EventStore.c"
}

CalendarEventStore*
calendar_event_store_construct (GType object_type)
{
	CalendarEventStore * self = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	GHashTable* _tmp6_;
	GHashFunc _tmp7_;
	GEqualFunc _tmp8_;
	GHashTable* _tmp9_;
	GQueue* _tmp10_;
#line 77 "../core/Services/Calendar/EventStore.vala"
	self = (CalendarEventStore*) g_object_new (object_type, NULL);
#line 78 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_set_week_starts_on (self, calendar_event_store_get_week_start (self));
#line 79 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = calendar_event_store_get_page (self);
#line 79 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = calendar_util_datetime_get_start_of_month (_tmp0_);
#line 79 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = _tmp1_;
#line 79 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_set_month_start (self, _tmp2_);
#line 79 "../core/Services/Calendar/EventStore.vala"
	_g_date_time_unref0 (_tmp2_);
#line 80 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_compute_ranges (self);
#line 82 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = g_str_hash;
#line 82 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = g_str_equal;
#line 82 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _g_object_unref0_);
#line 82 "../core/Services/Calendar/EventStore.vala"
	_g_hash_table_unref0 (self->priv->source_client);
#line 82 "../core/Services/Calendar/EventStore.vala"
	self->priv->source_client = _tmp5_;
#line 83 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = g_hash_table_new_full (_e_source_hash_ghash_func, _e_source_equal_gequal_func, _g_object_unref0_, _g_object_unref0_);
#line 83 "../core/Services/Calendar/EventStore.vala"
	_g_hash_table_unref0 (self->priv->source_events);
#line 83 "../core/Services/Calendar/EventStore.vala"
	self->priv->source_events = _tmp6_;
#line 84 "../core/Services/Calendar/EventStore.vala"
	_tmp7_ = g_str_hash;
#line 84 "../core/Services/Calendar/EventStore.vala"
	_tmp8_ = g_str_equal;
#line 84 "../core/Services/Calendar/EventStore.vala"
	_tmp9_ = g_hash_table_new_full (_tmp7_, _tmp8_, _g_free0_, _g_object_unref0_);
#line 84 "../core/Services/Calendar/EventStore.vala"
	_g_hash_table_unref0 (self->priv->source_view);
#line 84 "../core/Services/Calendar/EventStore.vala"
	self->priv->source_view = _tmp9_;
#line 85 "../core/Services/Calendar/EventStore.vala"
	_tmp10_ = g_queue_new ();
#line 85 "../core/Services/Calendar/EventStore.vala"
	(self->calendar_trash == NULL) ? NULL : (self->calendar_trash = (_g_queue_free__g_object_unref0_ (self->calendar_trash), NULL));
#line 85 "../core/Services/Calendar/EventStore.vala"
	self->calendar_trash = _tmp10_;
#line 87 "../core/Services/Calendar/EventStore.vala"
	g_signal_connect_object ((GObject*) self, "notify::month-start", (GCallback) _calendar_event_store_on_parameter_changed_g_object_notify, self, 0);
#line 88 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_open (self, NULL, NULL);
#line 77 "../core/Services/Calendar/EventStore.vala"
	return self;
#line 636 "EventStore.c"
}

CalendarEventStore*
calendar_event_store_new (void)
{
#line 77 "../core/Services/Calendar/EventStore.vala"
	return calendar_event_store_construct (CALENDAR_TYPE_EVENT_STORE);
#line 644 "EventStore.c"
}

static void
calendar_event_store_open_data_free (gpointer _data)
{
	CalendarEventStoreOpenData* _data_;
	_data_ = _data;
#line 15 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_slice_free (CalendarEventStoreOpenData, _data_);
#line 656 "EventStore.c"
}

void
calendar_event_store_open (CalendarEventStore* self,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	CalendarEventStoreOpenData* _data_;
	CalendarEventStore* _tmp0_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_ = g_slice_new0 (CalendarEventStoreOpenData);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_task_set_task_data (_data_->_async_result, _data_, calendar_event_store_open_data_free);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_->self = _tmp0_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_open_co (_data_);
#line 680 "EventStore.c"
}

void
calendar_event_store_open_finish (CalendarEventStore* self,
                                  GAsyncResult* _res_)
{
	CalendarEventStoreOpenData* _data_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 690 "EventStore.c"
}

static void
calendar_event_store_open_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	CalendarEventStoreOpenData* _data_;
#line 93 "../core/Services/Calendar/EventStore.vala"
	_data_ = _user_data_;
#line 93 "../core/Services/Calendar/EventStore.vala"
	_data_->_source_object_ = source_object;
#line 93 "../core/Services/Calendar/EventStore.vala"
	_data_->_res_ = _res_;
#line 93 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_open_co (_data_);
#line 707 "EventStore.c"
}

static void
_calendar_event_store_remove_source_e_source_registry_source_removed (ESourceRegistry* _sender,
                                                                      ESource* source,
                                                                      gpointer self)
{
#line 96 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_remove_source ((CalendarEventStore*) self, source);
#line 717 "EventStore.c"
}

static void
_calendar_event_store_on_source_changed_e_source_registry_source_changed (ESourceRegistry* _sender,
                                                                          ESource* source,
                                                                          gpointer self)
{
#line 97 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_on_source_changed ((CalendarEventStore*) self, source);
#line 727 "EventStore.c"
}

static void
_calendar_event_store_add_source_e_source_registry_source_added (ESourceRegistry* _sender,
                                                                 ESource* source,
                                                                 gpointer self)
{
#line 98 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_add_source ((CalendarEventStore*) self, source);
#line 737 "EventStore.c"
}

static void
___lambda14_ (CalendarEventStore* self,
              ESource* source)
{
	ESourceCalendar* cal = NULL;
	ESourceExtension* _tmp0_;
	ESourceCalendar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	ESourceCalendar* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 101 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 102 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
#line 102 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_calendar_get_type (), ESourceCalendar));
#line 102 "../core/Services/Calendar/EventStore.vala"
	cal = _tmp1_;
#line 103 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = cal;
#line 103 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = e_source_selectable_get_selected ((ESourceSelectable*) _tmp3_);
#line 103 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = _tmp4_;
#line 103 "../core/Services/Calendar/EventStore.vala"
	if (_tmp5_ == TRUE) {
#line 767 "EventStore.c"
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 103 "../core/Services/Calendar/EventStore.vala"
		_tmp6_ = e_source_get_enabled (source);
#line 103 "../core/Services/Calendar/EventStore.vala"
		_tmp7_ = _tmp6_;
#line 103 "../core/Services/Calendar/EventStore.vala"
		_tmp2_ = _tmp7_ == TRUE;
#line 776 "EventStore.c"
	} else {
#line 103 "../core/Services/Calendar/EventStore.vala"
		_tmp2_ = FALSE;
#line 780 "EventStore.c"
	}
#line 103 "../core/Services/Calendar/EventStore.vala"
	if (_tmp2_) {
#line 104 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_add_source (self, source);
#line 786 "EventStore.c"
	}
#line 101 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (cal);
#line 790 "EventStore.c"
}

static void
____lambda14__gfunc (gconstpointer data,
                     gpointer self)
{
#line 101 "../core/Services/Calendar/EventStore.vala"
	___lambda14_ ((CalendarEventStore*) self, (ESource*) data);
#line 799 "EventStore.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 101 "../core/Services/Calendar/EventStore.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 807 "EventStore.c"
}

static gboolean
calendar_event_store_open_co (CalendarEventStoreOpenData* _data_)
{
#line 91 "../core/Services/Calendar/EventStore.vala"
	switch (_data_->_state_) {
#line 91 "../core/Services/Calendar/EventStore.vala"
		case 0:
#line 817 "EventStore.c"
		goto _state_0;
#line 91 "../core/Services/Calendar/EventStore.vala"
		case 1:
#line 821 "EventStore.c"
		goto _state_1;
		default:
#line 91 "../core/Services/Calendar/EventStore.vala"
		g_assert_not_reached ();
#line 826 "EventStore.c"
	}
	_state_0:
	{
#line 93 "../core/Services/Calendar/EventStore.vala"
		_data_->_state_ = 1;
#line 93 "../core/Services/Calendar/EventStore.vala"
		e_source_registry_new (NULL, calendar_event_store_open_ready, _data_);
#line 93 "../core/Services/Calendar/EventStore.vala"
		return FALSE;
#line 836 "EventStore.c"
		_state_1:
#line 93 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp1_ = e_source_registry_new_finish (_data_->_res_, &_data_->_inner_error0_);
#line 93 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp0_ = _data_->_tmp1_;
#line 93 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 844 "EventStore.c"
			goto __catch0_g_error;
		}
#line 93 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_set_registry (_data_->self, _data_->_tmp0_);
#line 94 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp2_ = _data_->self->priv->_registry;
#line 94 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp3_ = e_credentials_prompter_new (_data_->_tmp2_);
#line 94 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data_->self->priv->credentials_prompter);
#line 94 "../core/Services/Calendar/EventStore.vala"
		_data_->self->priv->credentials_prompter = _data_->_tmp3_;
#line 95 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp4_ = _data_->self->priv->credentials_prompter;
#line 95 "../core/Services/Calendar/EventStore.vala"
		e_credentials_prompter_set_auto_prompt (_data_->_tmp4_, TRUE);
#line 96 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp5_ = _data_->self->priv->_registry;
#line 96 "../core/Services/Calendar/EventStore.vala"
		g_signal_connect_object (_data_->_tmp5_, "source-removed", (GCallback) _calendar_event_store_remove_source_e_source_registry_source_removed, _data_->self, 0);
#line 97 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp6_ = _data_->self->priv->_registry;
#line 97 "../core/Services/Calendar/EventStore.vala"
		g_signal_connect_object (_data_->_tmp6_, "source-changed", (GCallback) _calendar_event_store_on_source_changed_e_source_registry_source_changed, _data_->self, 0);
#line 98 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp7_ = _data_->self->priv->_registry;
#line 98 "../core/Services/Calendar/EventStore.vala"
		g_signal_connect_object (_data_->_tmp7_, "source-added", (GCallback) _calendar_event_store_add_source_e_source_registry_source_added, _data_->self, 0);
#line 101 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp8_ = _data_->self->priv->_registry;
#line 101 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp9_ = e_source_registry_list_sources (_data_->_tmp8_, E_SOURCE_EXTENSION_CALENDAR);
#line 101 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 101 "../core/Services/Calendar/EventStore.vala"
		g_list_foreach (_data_->_tmp10_, ____lambda14__gfunc, _data_->self);
#line 101 "../core/Services/Calendar/EventStore.vala"
		(_data_->_tmp10_ == NULL) ? NULL : (_data_->_tmp10_ = (_g_list_free__g_object_unref0_ (_data_->_tmp10_), NULL));
#line 92 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 885 "EventStore.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 92 "../core/Services/Calendar/EventStore.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 92 "../core/Services/Calendar/EventStore.vala"
		_data_->_inner_error0_ = NULL;
#line 108 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp11_ = _data_->_error_;
#line 108 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 108 "../core/Services/Calendar/EventStore.vala"
		g_critical ("EventStore.vala:108: %s", _data_->_tmp12_);
#line 92 "../core/Services/Calendar/EventStore.vala"
		_g_error_free0 (_data_->_error_);
#line 902 "EventStore.c"
	}
	__finally0:
#line 92 "../core/Services/Calendar/EventStore.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 92 "../core/Services/Calendar/EventStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 92 "../core/Services/Calendar/EventStore.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 92 "../core/Services/Calendar/EventStore.vala"
		g_object_unref (_data_->_async_result);
#line 92 "../core/Services/Calendar/EventStore.vala"
		return FALSE;
#line 915 "EventStore.c"
	}
#line 91 "../core/Services/Calendar/EventStore.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 91 "../core/Services/Calendar/EventStore.vala"
	if (_data_->_state_ != 0) {
#line 91 "../core/Services/Calendar/EventStore.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 91 "../core/Services/Calendar/EventStore.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 925 "EventStore.c"
		}
	}
#line 91 "../core/Services/Calendar/EventStore.vala"
	g_object_unref (_data_->_async_result);
#line 91 "../core/Services/Calendar/EventStore.vala"
	return FALSE;
#line 932 "EventStore.c"
}

void
calendar_event_store_add_event (CalendarEventStore* self,
                                ESource* source,
                                ECalComponent* event)
{
#line 114 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 114 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 114 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (event != NULL);
#line 115 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_add_event_async (self, source, event, NULL, NULL);
#line 948 "EventStore.c"
}

gboolean
calendar_event_store_calclient_is_readonly (CalendarEventStore* self,
                                            ESource* source)
{
	ECalClient* client = NULL;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 118 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 118 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 962 "EventStore.c"
	{
		GHashTable* _tmp0_;
#line 120 "../core/Services/Calendar/EventStore.vala"
		_tmp0_ = self->priv->source_client;
#line 120 "../core/Services/Calendar/EventStore.vala"
		g_rec_mutex_lock (&self->priv->__lock_source_client);
#line 969 "EventStore.c"
		{
			GHashTable* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			gconstpointer _tmp4_;
			ECalClient* _tmp5_;
#line 121 "../core/Services/Calendar/EventStore.vala"
			_tmp1_ = self->priv->source_client;
#line 121 "../core/Services/Calendar/EventStore.vala"
			_tmp2_ = e_source_dup_uid (source);
#line 121 "../core/Services/Calendar/EventStore.vala"
			_tmp3_ = _tmp2_;
#line 121 "../core/Services/Calendar/EventStore.vala"
			_tmp4_ = g_hash_table_lookup (_tmp1_, _tmp3_);
#line 121 "../core/Services/Calendar/EventStore.vala"
			_tmp5_ = _g_object_ref0 ((ECalClient*) _tmp4_);
#line 121 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (client);
#line 121 "../core/Services/Calendar/EventStore.vala"
			client = _tmp5_;
#line 121 "../core/Services/Calendar/EventStore.vala"
			_g_free0 (_tmp3_);
#line 992 "EventStore.c"
		}
		__finally0:
		{
			GHashTable* _tmp6_;
#line 120 "../core/Services/Calendar/EventStore.vala"
			_tmp6_ = self->priv->source_client;
#line 120 "../core/Services/Calendar/EventStore.vala"
			g_rec_mutex_unlock (&self->priv->__lock_source_client);
#line 1001 "EventStore.c"
		}
#line 120 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1005 "EventStore.c"
			gboolean _tmp7_ = FALSE;
#line 120 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (client);
#line 120 "../core/Services/Calendar/EventStore.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../core/Services/Calendar/EventStore.vala"
			g_clear_error (&_inner_error0_);
#line 120 "../core/Services/Calendar/EventStore.vala"
			return _tmp7_;
#line 1015 "EventStore.c"
		}
	}
#line 123 "../core/Services/Calendar/EventStore.vala"
	if (client != NULL) {
#line 124 "../core/Services/Calendar/EventStore.vala"
		result = e_client_is_readonly ((EClient*) client);
#line 124 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (client);
#line 124 "../core/Services/Calendar/EventStore.vala"
		return result;
#line 1026 "EventStore.c"
	} else {
#line 126 "../core/Services/Calendar/EventStore.vala"
		g_critical ("EventStore.vala:126: No calendar client was found");
#line 1030 "EventStore.c"
	}
#line 129 "../core/Services/Calendar/EventStore.vala"
	result = TRUE;
#line 129 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (client);
#line 129 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 1038 "EventStore.c"
}

static void
calendar_event_store_add_event_async_data_free (gpointer _data)
{
	CalendarEventStoreAddEventAsyncData* _data_;
	_data_ = _data;
#line 15 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data_->source);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data_->event);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_slice_free (CalendarEventStoreAddEventAsyncData, _data_);
#line 1054 "EventStore.c"
}

static void
calendar_event_store_add_event_async (CalendarEventStore* self,
                                      ESource* source,
                                      ECalComponent* event,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	CalendarEventStoreAddEventAsyncData* _data_;
	CalendarEventStore* _tmp0_;
	ESource* _tmp1_;
	ECalComponent* _tmp2_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (event != NULL);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_ = g_slice_new0 (CalendarEventStoreAddEventAsyncData);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_task_set_task_data (_data_->_async_result, _data_, calendar_event_store_add_event_async_data_free);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_->self = _tmp0_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = _g_object_ref0 (source);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data_->source);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_->source = _tmp1_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = _g_object_ref0 (event);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data_->event);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_->event = _tmp2_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_add_event_async_co (_data_);
#line 1098 "EventStore.c"
}

static void
calendar_event_store_add_event_finish (CalendarEventStore* self,
                                       GAsyncResult* _res_)
{
	CalendarEventStoreAddEventAsyncData* _data_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1108 "EventStore.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 1121 "EventStore.c"
}

static void
calendar_event_store_add_event_async_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	CalendarEventStoreAddEventAsyncData* _data_;
#line 143 "../core/Services/Calendar/EventStore.vala"
	_data_ = _user_data_;
#line 143 "../core/Services/Calendar/EventStore.vala"
	_data_->_source_object_ = source_object;
#line 143 "../core/Services/Calendar/EventStore.vala"
	_data_->_res_ = _res_;
#line 143 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_add_event_async_co (_data_);
#line 1138 "EventStore.c"
}

static gboolean
calendar_event_store_add_event_async_co (CalendarEventStoreAddEventAsyncData* _data_)
{
#line 132 "../core/Services/Calendar/EventStore.vala"
	switch (_data_->_state_) {
#line 132 "../core/Services/Calendar/EventStore.vala"
		case 0:
#line 1148 "EventStore.c"
		goto _state_0;
#line 132 "../core/Services/Calendar/EventStore.vala"
		case 1:
#line 1152 "EventStore.c"
		goto _state_1;
		default:
#line 132 "../core/Services/Calendar/EventStore.vala"
		g_assert_not_reached ();
#line 1157 "EventStore.c"
	}
	_state_0:
#line 133 "../core/Services/Calendar/EventStore.vala"
	_data_->_tmp0_ = e_cal_component_get_icalcomponent (_data_->event);
#line 133 "../core/Services/Calendar/EventStore.vala"
	_data_->comp = _data_->_tmp0_;
#line 134 "../core/Services/Calendar/EventStore.vala"
	_data_->_tmp1_ = i_cal_component_get_uid (_data_->comp);
#line 134 "../core/Services/Calendar/EventStore.vala"
	_data_->_tmp2_ = string_to_string (_data_->_tmp1_);
#line 134 "../core/Services/Calendar/EventStore.vala"
	_data_->_tmp3_ = g_strconcat ("Adding event '", _data_->_tmp2_, "'", NULL);
#line 134 "../core/Services/Calendar/EventStore.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 134 "../core/Services/Calendar/EventStore.vala"
	g_debug ("EventStore.vala:134: %s", _data_->_tmp4_);
#line 134 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_data_->_tmp4_);
#line 1176 "EventStore.c"
	{
#line 136 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp5_ = _data_->self->priv->source_client;
#line 136 "../core/Services/Calendar/EventStore.vala"
		g_rec_mutex_lock (&_data_->self->priv->__lock_source_client);
#line 1182 "EventStore.c"
		{
#line 137 "../core/Services/Calendar/EventStore.vala"
			_data_->_tmp6_ = _data_->self->priv->source_client;
#line 137 "../core/Services/Calendar/EventStore.vala"
			_data_->_tmp7_ = e_source_get_uid (_data_->source);
#line 137 "../core/Services/Calendar/EventStore.vala"
			_data_->_tmp8_ = g_hash_table_lookup (_data_->_tmp6_, _data_->_tmp7_);
#line 137 "../core/Services/Calendar/EventStore.vala"
			_data_->_tmp9_ = _g_object_ref0 ((ECalClient*) _data_->_tmp8_);
#line 137 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (_data_->client);
#line 137 "../core/Services/Calendar/EventStore.vala"
			_data_->client = _data_->_tmp9_;
#line 1196 "EventStore.c"
		}
		__finally0:
		{
#line 136 "../core/Services/Calendar/EventStore.vala"
			_data_->_tmp10_ = _data_->self->priv->source_client;
#line 136 "../core/Services/Calendar/EventStore.vala"
			g_rec_mutex_unlock (&_data_->self->priv->__lock_source_client);
#line 1204 "EventStore.c"
		}
#line 136 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 136 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (_data_->client);
#line 136 "../core/Services/Calendar/EventStore.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 136 "../core/Services/Calendar/EventStore.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 136 "../core/Services/Calendar/EventStore.vala"
			g_object_unref (_data_->_async_result);
#line 136 "../core/Services/Calendar/EventStore.vala"
			return FALSE;
#line 1218 "EventStore.c"
		}
	}
#line 140 "../core/Services/Calendar/EventStore.vala"
	if (_data_->client != NULL) {
#line 1223 "EventStore.c"
		{
#line 143 "../core/Services/Calendar/EventStore.vala"
			_data_->_tmp11_ = NULL;
#line 143 "../core/Services/Calendar/EventStore.vala"
			_data_->_state_ = 1;
#line 143 "../core/Services/Calendar/EventStore.vala"
			e_cal_client_create_object (_data_->client, _data_->comp, E_CAL_OPERATION_FLAG_NONE, NULL, calendar_event_store_add_event_async_ready, _data_);
#line 143 "../core/Services/Calendar/EventStore.vala"
			return FALSE;
#line 1233 "EventStore.c"
			_state_1:
#line 143 "../core/Services/Calendar/EventStore.vala"
			e_cal_client_create_object_finish (_data_->client, _data_->_res_, &_data_->_tmp11_, &_data_->_inner_error0_);
#line 143 "../core/Services/Calendar/EventStore.vala"
			_g_free0 (_data_->uid);
#line 143 "../core/Services/Calendar/EventStore.vala"
			_data_->uid = _data_->_tmp11_;
#line 143 "../core/Services/Calendar/EventStore.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 143 "../core/Services/Calendar/EventStore.vala"
				_g_free0 (_data_->uid);
#line 1245 "EventStore.c"
				goto __catch1_g_error;
			}
#line 144 "../core/Services/Calendar/EventStore.vala"
			_data_->_tmp12_ = _data_->uid;
#line 144 "../core/Services/Calendar/EventStore.vala"
			if (_data_->_tmp12_ != NULL) {
#line 145 "../core/Services/Calendar/EventStore.vala"
				_data_->_tmp13_ = _data_->uid;
#line 145 "../core/Services/Calendar/EventStore.vala"
				i_cal_component_set_uid (_data_->comp, _data_->_tmp13_);
#line 1256 "EventStore.c"
			}
#line 141 "../core/Services/Calendar/EventStore.vala"
			_g_free0 (_data_->uid);
#line 1260 "EventStore.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 141 "../core/Services/Calendar/EventStore.vala"
			_data_->_error_ = _data_->_inner_error0_;
#line 141 "../core/Services/Calendar/EventStore.vala"
			_data_->_inner_error0_ = NULL;
#line 148 "../core/Services/Calendar/EventStore.vala"
			_data_->_tmp14_ = _data_->_error_;
#line 148 "../core/Services/Calendar/EventStore.vala"
			_data_->_tmp15_ = _data_->_tmp14_->message;
#line 148 "../core/Services/Calendar/EventStore.vala"
			g_critical ("EventStore.vala:148: %s", _data_->_tmp15_);
#line 141 "../core/Services/Calendar/EventStore.vala"
			_g_error_free0 (_data_->_error_);
#line 1277 "EventStore.c"
		}
		__finally1:
#line 141 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 141 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (_data_->client);
#line 141 "../core/Services/Calendar/EventStore.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 141 "../core/Services/Calendar/EventStore.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 141 "../core/Services/Calendar/EventStore.vala"
			g_object_unref (_data_->_async_result);
#line 141 "../core/Services/Calendar/EventStore.vala"
			return FALSE;
#line 1292 "EventStore.c"
		}
	} else {
#line 151 "../core/Services/Calendar/EventStore.vala"
		g_critical ("EventStore.vala:151: No calendar was found, event not added");
#line 1297 "EventStore.c"
	}
#line 132 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data_->client);
#line 132 "../core/Services/Calendar/EventStore.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 132 "../core/Services/Calendar/EventStore.vala"
	if (_data_->_state_ != 0) {
#line 132 "../core/Services/Calendar/EventStore.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 132 "../core/Services/Calendar/EventStore.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1309 "EventStore.c"
		}
	}
#line 132 "../core/Services/Calendar/EventStore.vala"
	g_object_unref (_data_->_async_result);
#line 132 "../core/Services/Calendar/EventStore.vala"
	return FALSE;
#line 1316 "EventStore.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 155 "../core/Services/Calendar/EventStore.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 155 "../core/Services/Calendar/EventStore.vala"
	return _data1_;
#line 1326 "EventStore.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 155 "../core/Services/Calendar/EventStore.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1336 "EventStore.c"
		CalendarEventStore* self;
#line 155 "../core/Services/Calendar/EventStore.vala"
		self = _data1_->self;
#line 155 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data1_->client);
#line 155 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data1_->source);
#line 155 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data1_->event);
#line 155 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self);
#line 155 "../core/Services/Calendar/EventStore.vala"
		g_slice_free (Block1Data, _data1_);
#line 1350 "EventStore.c"
	}
}

static void
__lambda15_ (Block1Data* _data1_,
             GObject* obj,
             GAsyncResult* results)
{
	CalendarEventStore* self;
	GError* _inner_error0_ = NULL;
#line 163 "../core/Services/Calendar/EventStore.vala"
	self = _data1_->self;
#line 163 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (results != NULL);
#line 1365 "EventStore.c"
	{
#line 165 "../core/Services/Calendar/EventStore.vala"
		e_cal_client_modify_object_finish (_data1_->client, results, &_inner_error0_);
#line 165 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1371 "EventStore.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 164 "../core/Services/Calendar/EventStore.vala"
		e = _inner_error0_;
#line 164 "../core/Services/Calendar/EventStore.vala"
		_inner_error0_ = NULL;
#line 167 "../core/Services/Calendar/EventStore.vala"
		_tmp0_ = e;
#line 167 "../core/Services/Calendar/EventStore.vala"
		_tmp1_ = _tmp0_->message;
#line 167 "../core/Services/Calendar/EventStore.vala"
		_tmp2_ = g_strconcat (_tmp1_, " - try to add instead", NULL);
#line 167 "../core/Services/Calendar/EventStore.vala"
		_tmp3_ = _tmp2_;
#line 167 "../core/Services/Calendar/EventStore.vala"
		g_warning ("EventStore.vala:167: %s", _tmp3_);
#line 167 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (_tmp3_);
#line 168 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_add_event (self, _data1_->source, _data1_->event);
#line 164 "../core/Services/Calendar/EventStore.vala"
		_g_error_free0 (e);
#line 1403 "EventStore.c"
	}
	__finally0:
#line 164 "../core/Services/Calendar/EventStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../core/Services/Calendar/EventStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../core/Services/Calendar/EventStore.vala"
		g_clear_error (&_inner_error0_);
#line 164 "../core/Services/Calendar/EventStore.vala"
		return;
#line 1414 "EventStore.c"
	}
}

static void
___lambda15__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 163 "../core/Services/Calendar/EventStore.vala"
	__lambda15_ (self, source_object, res);
#line 163 "../core/Services/Calendar/EventStore.vala"
	block1_data_unref (self);
#line 1427 "EventStore.c"
}

void
calendar_event_store_update_event (CalendarEventStore* self,
                                   ESource* source,
                                   ECalComponent* event,
                                   ECalObjModType mod_type)
{
	Block1Data* _data1_;
	ESource* _tmp0_;
	ECalComponent* _tmp1_;
	ICalComponent* comp = NULL;
	ICalComponent* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GFlagsValue* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 155 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 155 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 155 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (event != NULL);
#line 155 "../core/Services/Calendar/EventStore.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 155 "../core/Services/Calendar/EventStore.vala"
	_data1_->_ref_count_ = 1;
#line 155 "../core/Services/Calendar/EventStore.vala"
	_data1_->self = g_object_ref (self);
#line 155 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 155 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data1_->source);
#line 155 "../core/Services/Calendar/EventStore.vala"
	_data1_->source = _tmp0_;
#line 155 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = _g_object_ref0 (event);
#line 155 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data1_->event);
#line 155 "../core/Services/Calendar/EventStore.vala"
	_data1_->event = _tmp1_;
#line 156 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = e_cal_component_get_icalcomponent (_data1_->event);
#line 156 "../core/Services/Calendar/EventStore.vala"
	comp = _tmp2_;
#line 157 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = i_cal_component_get_uid (comp);
#line 157 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = string_to_string (_tmp3_);
#line 157 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = g_flags_get_first_value (g_type_class_ref (e_cal_obj_mod_type_get_type ()), mod_type);
#line 157 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = g_strconcat ("Updating event '", _tmp4_, "' [mod_type=", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL, "]", NULL);
#line 157 "../core/Services/Calendar/EventStore.vala"
	_tmp7_ = _tmp6_;
#line 157 "../core/Services/Calendar/EventStore.vala"
	g_debug ("EventStore.vala:157: %s", _tmp7_);
#line 157 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp7_);
#line 1489 "EventStore.c"
	{
		GHashTable* _tmp8_;
#line 159 "../core/Services/Calendar/EventStore.vala"
		_tmp8_ = self->priv->source_client;
#line 159 "../core/Services/Calendar/EventStore.vala"
		g_rec_mutex_lock (&self->priv->__lock_source_client);
#line 1496 "EventStore.c"
		{
			GHashTable* _tmp9_;
			const gchar* _tmp10_;
			gconstpointer _tmp11_;
			ECalClient* _tmp12_;
#line 160 "../core/Services/Calendar/EventStore.vala"
			_tmp9_ = self->priv->source_client;
#line 160 "../core/Services/Calendar/EventStore.vala"
			_tmp10_ = e_source_get_uid (_data1_->source);
#line 160 "../core/Services/Calendar/EventStore.vala"
			_tmp11_ = g_hash_table_lookup (_tmp9_, _tmp10_);
#line 160 "../core/Services/Calendar/EventStore.vala"
			_tmp12_ = _g_object_ref0 ((ECalClient*) _tmp11_);
#line 160 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (_data1_->client);
#line 160 "../core/Services/Calendar/EventStore.vala"
			_data1_->client = _tmp12_;
#line 1514 "EventStore.c"
		}
		__finally0:
		{
			GHashTable* _tmp13_;
#line 159 "../core/Services/Calendar/EventStore.vala"
			_tmp13_ = self->priv->source_client;
#line 159 "../core/Services/Calendar/EventStore.vala"
			g_rec_mutex_unlock (&self->priv->__lock_source_client);
#line 1523 "EventStore.c"
		}
#line 159 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../core/Services/Calendar/EventStore.vala"
			block1_data_unref (_data1_);
#line 159 "../core/Services/Calendar/EventStore.vala"
			_data1_ = NULL;
#line 159 "../core/Services/Calendar/EventStore.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 159 "../core/Services/Calendar/EventStore.vala"
			g_clear_error (&_inner_error0_);
#line 159 "../core/Services/Calendar/EventStore.vala"
			return;
#line 1537 "EventStore.c"
		}
	}
#line 163 "../core/Services/Calendar/EventStore.vala"
	e_cal_client_modify_object (_data1_->client, comp, mod_type, E_CAL_OPERATION_FLAG_NONE, NULL, ___lambda15__gasync_ready_callback, block1_data_ref (_data1_));
#line 155 "../core/Services/Calendar/EventStore.vala"
	block1_data_unref (_data1_);
#line 155 "../core/Services/Calendar/EventStore.vala"
	_data1_ = NULL;
#line 1546 "EventStore.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 173 "../core/Services/Calendar/EventStore.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 173 "../core/Services/Calendar/EventStore.vala"
	return _data2_;
#line 1556 "EventStore.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 173 "../core/Services/Calendar/EventStore.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1566 "EventStore.c"
		CalendarEventStore* self;
#line 173 "../core/Services/Calendar/EventStore.vala"
		self = _data2_->self;
#line 173 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data2_->client);
#line 173 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self);
#line 173 "../core/Services/Calendar/EventStore.vala"
		g_slice_free (Block2Data, _data2_);
#line 1576 "EventStore.c"
	}
}

static void
__lambda16_ (Block2Data* _data2_,
             GObject* obj,
             GAsyncResult* results)
{
	CalendarEventStore* self;
	GError* _inner_error0_ = NULL;
#line 189 "../core/Services/Calendar/EventStore.vala"
	self = _data2_->self;
#line 189 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (results != NULL);
#line 1591 "EventStore.c"
	{
#line 191 "../core/Services/Calendar/EventStore.vala"
		e_cal_client_remove_object_finish (_data2_->client, results, &_inner_error0_);
#line 191 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1597 "EventStore.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 190 "../core/Services/Calendar/EventStore.vala"
		e = _inner_error0_;
#line 190 "../core/Services/Calendar/EventStore.vala"
		_inner_error0_ = NULL;
#line 193 "../core/Services/Calendar/EventStore.vala"
		_tmp0_ = e;
#line 193 "../core/Services/Calendar/EventStore.vala"
		_tmp1_ = _tmp0_->message;
#line 193 "../core/Services/Calendar/EventStore.vala"
		g_warning ("EventStore.vala:193: %s", _tmp1_);
#line 190 "../core/Services/Calendar/EventStore.vala"
		_g_error_free0 (e);
#line 1619 "EventStore.c"
	}
	__finally0:
#line 190 "../core/Services/Calendar/EventStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../core/Services/Calendar/EventStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "../core/Services/Calendar/EventStore.vala"
		g_clear_error (&_inner_error0_);
#line 190 "../core/Services/Calendar/EventStore.vala"
		return;
#line 1630 "EventStore.c"
	}
}

static void
___lambda16__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 189 "../core/Services/Calendar/EventStore.vala"
	__lambda16_ (self, source_object, res);
#line 189 "../core/Services/Calendar/EventStore.vala"
	block2_data_unref (self);
#line 1643 "EventStore.c"
}

void
calendar_event_store_remove_event (CalendarEventStore* self,
                                   ESource* source,
                                   ECalComponent* event,
                                   ECalObjModType mod_type)
{
	Block2Data* _data2_;
	ICalComponent* comp = NULL;
	ICalComponent* _tmp0_;
	gchar* uid = NULL;
	ICalComponent* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* rid = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
#line 173 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 173 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 173 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (event != NULL);
#line 173 "../core/Services/Calendar/EventStore.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 173 "../core/Services/Calendar/EventStore.vala"
	_data2_->_ref_count_ = 1;
#line 173 "../core/Services/Calendar/EventStore.vala"
	_data2_->self = g_object_ref (self);
#line 174 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = e_cal_component_get_icalcomponent (event);
#line 174 "../core/Services/Calendar/EventStore.vala"
	comp = _tmp0_;
#line 175 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = comp;
#line 175 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = i_cal_component_get_uid (_tmp1_);
#line 175 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 175 "../core/Services/Calendar/EventStore.vala"
	uid = _tmp3_;
#line 176 "../core/Services/Calendar/EventStore.vala"
	rid = NULL;
#line 178 "../core/Services/Calendar/EventStore.vala"
	if (e_cal_component_has_recurrences (event)) {
#line 178 "../core/Services/Calendar/EventStore.vala"
		_tmp4_ = mod_type != E_CAL_OBJ_MOD_ALL;
#line 1698 "EventStore.c"
	} else {
#line 178 "../core/Services/Calendar/EventStore.vala"
		_tmp4_ = FALSE;
#line 1702 "EventStore.c"
	}
#line 178 "../core/Services/Calendar/EventStore.vala"
	if (_tmp4_) {
#line 1706 "EventStore.c"
		gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 179 "../core/Services/Calendar/EventStore.vala"
		_tmp5_ = e_cal_component_get_recurid_as_string (event);
#line 179 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (rid);
#line 179 "../core/Services/Calendar/EventStore.vala"
		rid = _tmp5_;
#line 180 "../core/Services/Calendar/EventStore.vala"
		_tmp6_ = rid;
#line 180 "../core/Services/Calendar/EventStore.vala"
		_tmp7_ = string_to_string (_tmp6_);
#line 180 "../core/Services/Calendar/EventStore.vala"
		_tmp8_ = g_strconcat ("Removing recurrent event '", _tmp7_, "'", NULL);
#line 180 "../core/Services/Calendar/EventStore.vala"
		_tmp9_ = _tmp8_;
#line 180 "../core/Services/Calendar/EventStore.vala"
		g_debug ("EventStore.vala:180: %s", _tmp9_);
#line 180 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (_tmp9_);
#line 1730 "EventStore.c"
	}
#line 183 "../core/Services/Calendar/EventStore.vala"
	_tmp10_ = uid;
#line 183 "../core/Services/Calendar/EventStore.vala"
	_tmp11_ = string_to_string (_tmp10_);
#line 183 "../core/Services/Calendar/EventStore.vala"
	_tmp12_ = g_strconcat ("Removing event '", _tmp11_, "'", NULL);
#line 183 "../core/Services/Calendar/EventStore.vala"
	_tmp13_ = _tmp12_;
#line 183 "../core/Services/Calendar/EventStore.vala"
	g_debug ("EventStore.vala:183: %s", _tmp13_);
#line 183 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp13_);
#line 1744 "EventStore.c"
	{
		GHashTable* _tmp14_;
#line 185 "../core/Services/Calendar/EventStore.vala"
		_tmp14_ = self->priv->source_client;
#line 185 "../core/Services/Calendar/EventStore.vala"
		g_rec_mutex_lock (&self->priv->__lock_source_client);
#line 1751 "EventStore.c"
		{
			GHashTable* _tmp15_;
			const gchar* _tmp16_;
			gconstpointer _tmp17_;
			ECalClient* _tmp18_;
#line 186 "../core/Services/Calendar/EventStore.vala"
			_tmp15_ = self->priv->source_client;
#line 186 "../core/Services/Calendar/EventStore.vala"
			_tmp16_ = e_source_get_uid (source);
#line 186 "../core/Services/Calendar/EventStore.vala"
			_tmp17_ = g_hash_table_lookup (_tmp15_, _tmp16_);
#line 186 "../core/Services/Calendar/EventStore.vala"
			_tmp18_ = _g_object_ref0 ((ECalClient*) _tmp17_);
#line 186 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (_data2_->client);
#line 186 "../core/Services/Calendar/EventStore.vala"
			_data2_->client = _tmp18_;
#line 1769 "EventStore.c"
		}
		__finally0:
		{
			GHashTable* _tmp19_;
#line 185 "../core/Services/Calendar/EventStore.vala"
			_tmp19_ = self->priv->source_client;
#line 185 "../core/Services/Calendar/EventStore.vala"
			g_rec_mutex_unlock (&self->priv->__lock_source_client);
#line 1778 "EventStore.c"
		}
#line 185 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "../core/Services/Calendar/EventStore.vala"
			_g_free0 (rid);
#line 185 "../core/Services/Calendar/EventStore.vala"
			_g_free0 (uid);
#line 185 "../core/Services/Calendar/EventStore.vala"
			block2_data_unref (_data2_);
#line 185 "../core/Services/Calendar/EventStore.vala"
			_data2_ = NULL;
#line 185 "../core/Services/Calendar/EventStore.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 185 "../core/Services/Calendar/EventStore.vala"
			g_clear_error (&_inner_error0_);
#line 185 "../core/Services/Calendar/EventStore.vala"
			return;
#line 1796 "EventStore.c"
		}
	}
#line 189 "../core/Services/Calendar/EventStore.vala"
	_tmp20_ = uid;
#line 189 "../core/Services/Calendar/EventStore.vala"
	_tmp21_ = rid;
#line 189 "../core/Services/Calendar/EventStore.vala"
	e_cal_client_remove_object (_data2_->client, _tmp20_, _tmp21_, mod_type, E_CAL_OPERATION_FLAG_NONE, NULL, ___lambda16__gasync_ready_callback, block2_data_ref (_data2_));
#line 173 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (rid);
#line 173 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (uid);
#line 173 "../core/Services/Calendar/EventStore.vala"
	block2_data_unref (_data2_);
#line 173 "../core/Services/Calendar/EventStore.vala"
	_data2_ = NULL;
#line 1813 "EventStore.c"
}

void
calendar_event_store_trash_calendar (CalendarEventStore* self,
                                     ESource* source)
{
	GQueue* _tmp0_;
	ESource* _tmp1_;
#line 198 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 198 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 199 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = self->calendar_trash;
#line 199 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = _g_object_ref0 (source);
#line 199 "../core/Services/Calendar/EventStore.vala"
	g_queue_push_tail (_tmp0_, _tmp1_);
#line 200 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_remove_source (self, source);
#line 201 "../core/Services/Calendar/EventStore.vala"
	e_source_set_enabled (source, FALSE);
#line 1836 "EventStore.c"
}

void
calendar_event_store_restore_calendar (CalendarEventStore* self)
{
	GQueue* _tmp0_;
	ESource* source = NULL;
	GQueue* _tmp1_;
	gpointer _tmp2_;
	ESource* _tmp3_;
	ESource* _tmp4_;
#line 204 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 205 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = self->calendar_trash;
#line 205 "../core/Services/Calendar/EventStore.vala"
	if (g_queue_is_empty (_tmp0_)) {
#line 206 "../core/Services/Calendar/EventStore.vala"
		return;
#line 1856 "EventStore.c"
	}
#line 208 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = self->calendar_trash;
#line 208 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = g_queue_pop_tail (_tmp1_);
#line 208 "../core/Services/Calendar/EventStore.vala"
	source = (ESource*) _tmp2_;
#line 209 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = source;
#line 209 "../core/Services/Calendar/EventStore.vala"
	e_source_set_enabled (_tmp3_, TRUE);
#line 210 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = source;
#line 210 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_add_source (self, _tmp4_);
#line 204 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (source);
#line 1874 "EventStore.c"
}

void
calendar_event_store_delete_trashed_calendars (CalendarEventStore* self)
{
	ESource* source = NULL;
	GQueue* _tmp0_;
	gpointer _tmp1_;
#line 213 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 214 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = self->calendar_trash;
#line 214 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = g_queue_pop_tail (_tmp0_);
#line 214 "../core/Services/Calendar/EventStore.vala"
	source = (ESource*) _tmp1_;
#line 215 "../core/Services/Calendar/EventStore.vala"
	while (TRUE) {
#line 1893 "EventStore.c"
		ESource* _tmp2_;
		ESource* _tmp3_;
		GQueue* _tmp4_;
		gpointer _tmp5_;
#line 215 "../core/Services/Calendar/EventStore.vala"
		_tmp2_ = source;
#line 215 "../core/Services/Calendar/EventStore.vala"
		if (!(_tmp2_ != NULL)) {
#line 215 "../core/Services/Calendar/EventStore.vala"
			break;
#line 1904 "EventStore.c"
		}
#line 216 "../core/Services/Calendar/EventStore.vala"
		_tmp3_ = source;
#line 216 "../core/Services/Calendar/EventStore.vala"
		e_source_remove (_tmp3_, NULL, NULL, NULL);
#line 217 "../core/Services/Calendar/EventStore.vala"
		_tmp4_ = self->calendar_trash;
#line 217 "../core/Services/Calendar/EventStore.vala"
		_tmp5_ = g_queue_pop_tail (_tmp4_);
#line 217 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (source);
#line 217 "../core/Services/Calendar/EventStore.vala"
		source = (ESource*) _tmp5_;
#line 1918 "EventStore.c"
	}
#line 213 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (source);
#line 1922 "EventStore.c"
}

void
calendar_event_store_change_month (CalendarEventStore* self,
                                   gint relative)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 221 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 222 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = self->priv->_month_start;
#line 222 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = g_date_time_add_months (_tmp0_, relative);
#line 222 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = _tmp1_;
#line 222 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_set_month_start (self, _tmp2_);
#line 222 "../core/Services/Calendar/EventStore.vala"
	_g_date_time_unref0 (_tmp2_);
#line 1944 "EventStore.c"
}

void
calendar_event_store_change_year (CalendarEventStore* self,
                                  gint relative)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 225 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 226 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = self->priv->_month_start;
#line 226 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = g_date_time_add_years (_tmp0_, relative);
#line 226 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = _tmp1_;
#line 226 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_set_month_start (self, _tmp2_);
#line 226 "../core/Services/Calendar/EventStore.vala"
	_g_date_time_unref0 (_tmp2_);
#line 1966 "EventStore.c"
}

void
calendar_event_store_load_all_sources (CalendarEventStore* self)
{
	GError* _inner_error0_ = NULL;
#line 229 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 1975 "EventStore.c"
	{
		GHashTable* _tmp0_;
#line 230 "../core/Services/Calendar/EventStore.vala"
		_tmp0_ = self->priv->source_client;
#line 230 "../core/Services/Calendar/EventStore.vala"
		g_rec_mutex_lock (&self->priv->__lock_source_client);
#line 1982 "EventStore.c"
		{
			GHashTable* _tmp1_;
			GList* _tmp2_;
#line 231 "../core/Services/Calendar/EventStore.vala"
			_tmp1_ = self->priv->source_client;
#line 231 "../core/Services/Calendar/EventStore.vala"
			_tmp2_ = g_hash_table_get_keys (_tmp1_);
#line 1990 "EventStore.c"
			{
				GList* id_collection = NULL;
				GList* id_it = NULL;
#line 231 "../core/Services/Calendar/EventStore.vala"
				id_collection = _tmp2_;
#line 231 "../core/Services/Calendar/EventStore.vala"
				for (id_it = id_collection; id_it != NULL; id_it = id_it->next) {
#line 1998 "EventStore.c"
					const gchar* id = NULL;
#line 231 "../core/Services/Calendar/EventStore.vala"
					id = (const gchar*) id_it->data;
#line 2002 "EventStore.c"
					{
						ESource* source = NULL;
						ESourceRegistry* _tmp3_;
						const gchar* _tmp4_;
						ESource* _tmp5_;
						ESourceCalendar* cal = NULL;
						ESource* _tmp6_;
						ESourceExtension* _tmp7_;
						ESourceCalendar* _tmp8_;
						gboolean _tmp9_ = FALSE;
						ESourceCalendar* _tmp10_;
						gboolean _tmp11_;
						gboolean _tmp12_;
#line 232 "../core/Services/Calendar/EventStore.vala"
						_tmp3_ = self->priv->_registry;
#line 232 "../core/Services/Calendar/EventStore.vala"
						_tmp4_ = id;
#line 232 "../core/Services/Calendar/EventStore.vala"
						_tmp5_ = e_source_registry_ref_source (_tmp3_, _tmp4_);
#line 232 "../core/Services/Calendar/EventStore.vala"
						source = _tmp5_;
#line 233 "../core/Services/Calendar/EventStore.vala"
						_tmp6_ = source;
#line 233 "../core/Services/Calendar/EventStore.vala"
						_tmp7_ = e_source_get_extension (_tmp6_, E_SOURCE_EXTENSION_CALENDAR);
#line 233 "../core/Services/Calendar/EventStore.vala"
						_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, e_source_calendar_get_type (), ESourceCalendar));
#line 233 "../core/Services/Calendar/EventStore.vala"
						cal = _tmp8_;
#line 234 "../core/Services/Calendar/EventStore.vala"
						_tmp10_ = cal;
#line 234 "../core/Services/Calendar/EventStore.vala"
						_tmp11_ = e_source_selectable_get_selected ((ESourceSelectable*) _tmp10_);
#line 234 "../core/Services/Calendar/EventStore.vala"
						_tmp12_ = _tmp11_;
#line 234 "../core/Services/Calendar/EventStore.vala"
						if (_tmp12_ == TRUE) {
#line 2040 "EventStore.c"
							ESource* _tmp13_;
							gboolean _tmp14_;
							gboolean _tmp15_;
#line 234 "../core/Services/Calendar/EventStore.vala"
							_tmp13_ = source;
#line 234 "../core/Services/Calendar/EventStore.vala"
							_tmp14_ = e_source_get_enabled (_tmp13_);
#line 234 "../core/Services/Calendar/EventStore.vala"
							_tmp15_ = _tmp14_;
#line 234 "../core/Services/Calendar/EventStore.vala"
							_tmp9_ = _tmp15_ == TRUE;
#line 2052 "EventStore.c"
						} else {
#line 234 "../core/Services/Calendar/EventStore.vala"
							_tmp9_ = FALSE;
#line 2056 "EventStore.c"
						}
#line 234 "../core/Services/Calendar/EventStore.vala"
						if (_tmp9_) {
#line 2060 "EventStore.c"
							ESource* _tmp16_;
#line 235 "../core/Services/Calendar/EventStore.vala"
							_tmp16_ = source;
#line 235 "../core/Services/Calendar/EventStore.vala"
							calendar_event_store_load_source (self, _tmp16_);
#line 2066 "EventStore.c"
						}
#line 231 "../core/Services/Calendar/EventStore.vala"
						_g_object_unref0 (cal);
#line 231 "../core/Services/Calendar/EventStore.vala"
						_g_object_unref0 (source);
#line 2072 "EventStore.c"
					}
				}
#line 231 "../core/Services/Calendar/EventStore.vala"
				(id_collection == NULL) ? NULL : (id_collection = (g_list_free (id_collection), NULL));
#line 2077 "EventStore.c"
			}
		}
		__finally0:
		{
			GHashTable* _tmp17_;
#line 230 "../core/Services/Calendar/EventStore.vala"
			_tmp17_ = self->priv->source_client;
#line 230 "../core/Services/Calendar/EventStore.vala"
			g_rec_mutex_unlock (&self->priv->__lock_source_client);
#line 2087 "EventStore.c"
		}
#line 230 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../core/Services/Calendar/EventStore.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "../core/Services/Calendar/EventStore.vala"
			g_clear_error (&_inner_error0_);
#line 230 "../core/Services/Calendar/EventStore.vala"
			return;
#line 2097 "EventStore.c"
		}
	}
}

void
calendar_event_store_add_source (CalendarEventStore* self,
                                 ESource* source)
{
#line 241 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 241 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 242 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_add_source_async (self, source, NULL, NULL);
#line 2112 "EventStore.c"
}

void
calendar_event_store_remove_source (CalendarEventStore* self,
                                    ESource* source)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* uid = NULL;
	const gchar* _tmp2_;
	GHashTable* _tmp3_;
	const gchar* _tmp4_;
	ECalClientView* current_view = NULL;
	GHashTable* _tmp5_;
	const gchar* _tmp6_;
	gconstpointer _tmp7_;
	ECalClientView* _tmp8_;
	GHashTable* _tmp12_;
	const gchar* _tmp13_;
	GeeCollection* events = NULL;
	GHashTable* _tmp18_;
	gconstpointer _tmp19_;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* _tmp22_;
	GeeCollection* _tmp23_;
	GeeCollection* _tmp24_;
	GeeCollection* _tmp25_;
	GHashTable* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 245 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 245 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 246 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = e_source_dup_display_name (source);
#line 246 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = _tmp0_;
#line 246 "../core/Services/Calendar/EventStore.vala"
	g_debug ("EventStore.vala:246: Removing source '%s'", _tmp1_);
#line 246 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp1_);
#line 248 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = e_source_get_uid (source);
#line 248 "../core/Services/Calendar/EventStore.vala"
	uid = _tmp2_;
#line 249 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = self->priv->source_view;
#line 249 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = uid;
#line 249 "../core/Services/Calendar/EventStore.vala"
	if (!g_hash_table_contains (_tmp3_, _tmp4_)) {
#line 250 "../core/Services/Calendar/EventStore.vala"
		return;
#line 2167 "EventStore.c"
	}
#line 253 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = self->priv->source_view;
#line 253 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = uid;
#line 253 "../core/Services/Calendar/EventStore.vala"
	_tmp7_ = g_hash_table_lookup (_tmp5_, _tmp6_);
#line 253 "../core/Services/Calendar/EventStore.vala"
	_tmp8_ = _g_object_ref0 ((ECalClientView*) _tmp7_);
#line 253 "../core/Services/Calendar/EventStore.vala"
	current_view = _tmp8_;
#line 2179 "EventStore.c"
	{
		ECalClientView* _tmp9_;
#line 255 "../core/Services/Calendar/EventStore.vala"
		_tmp9_ = current_view;
#line 255 "../core/Services/Calendar/EventStore.vala"
		e_cal_client_view_stop (_tmp9_, &_inner_error0_);
#line 255 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2188 "EventStore.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 254 "../core/Services/Calendar/EventStore.vala"
		e = _inner_error0_;
#line 254 "../core/Services/Calendar/EventStore.vala"
		_inner_error0_ = NULL;
#line 257 "../core/Services/Calendar/EventStore.vala"
		_tmp10_ = e;
#line 257 "../core/Services/Calendar/EventStore.vala"
		_tmp11_ = _tmp10_->message;
#line 257 "../core/Services/Calendar/EventStore.vala"
		g_warning ("EventStore.vala:257: %s", _tmp11_);
#line 254 "../core/Services/Calendar/EventStore.vala"
		_g_error_free0 (e);
#line 2210 "EventStore.c"
	}
	__finally0:
#line 254 "../core/Services/Calendar/EventStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (current_view);
#line 254 "../core/Services/Calendar/EventStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 254 "../core/Services/Calendar/EventStore.vala"
		g_clear_error (&_inner_error0_);
#line 254 "../core/Services/Calendar/EventStore.vala"
		return;
#line 2223 "EventStore.c"
	}
#line 260 "../core/Services/Calendar/EventStore.vala"
	_tmp12_ = self->priv->source_view;
#line 260 "../core/Services/Calendar/EventStore.vala"
	_tmp13_ = uid;
#line 260 "../core/Services/Calendar/EventStore.vala"
	g_hash_table_remove (_tmp12_, _tmp13_);
#line 2231 "EventStore.c"
	{
		GHashTable* _tmp14_;
#line 261 "../core/Services/Calendar/EventStore.vala"
		_tmp14_ = self->priv->source_client;
#line 261 "../core/Services/Calendar/EventStore.vala"
		g_rec_mutex_lock (&self->priv->__lock_source_client);
#line 2238 "EventStore.c"
		{
			GHashTable* _tmp15_;
			const gchar* _tmp16_;
#line 262 "../core/Services/Calendar/EventStore.vala"
			_tmp15_ = self->priv->source_client;
#line 262 "../core/Services/Calendar/EventStore.vala"
			_tmp16_ = uid;
#line 262 "../core/Services/Calendar/EventStore.vala"
			g_hash_table_remove (_tmp15_, _tmp16_);
#line 2248 "EventStore.c"
		}
		__finally1:
		{
			GHashTable* _tmp17_;
#line 261 "../core/Services/Calendar/EventStore.vala"
			_tmp17_ = self->priv->source_client;
#line 261 "../core/Services/Calendar/EventStore.vala"
			g_rec_mutex_unlock (&self->priv->__lock_source_client);
#line 2257 "EventStore.c"
		}
#line 261 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (current_view);
#line 261 "../core/Services/Calendar/EventStore.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 261 "../core/Services/Calendar/EventStore.vala"
			g_clear_error (&_inner_error0_);
#line 261 "../core/Services/Calendar/EventStore.vala"
			return;
#line 2269 "EventStore.c"
		}
	}
#line 265 "../core/Services/Calendar/EventStore.vala"
	_tmp18_ = self->priv->source_events;
#line 265 "../core/Services/Calendar/EventStore.vala"
	_tmp19_ = g_hash_table_lookup (_tmp18_, source);
#line 265 "../core/Services/Calendar/EventStore.vala"
	_tmp20_ = gee_multi_map_get_values ((GeeMultiMap*) ((GeeTreeMultiMap*) _tmp19_));
#line 265 "../core/Services/Calendar/EventStore.vala"
	_tmp21_ = _tmp20_;
#line 265 "../core/Services/Calendar/EventStore.vala"
	_tmp22_ = gee_collection_get_read_only_view (_tmp21_);
#line 265 "../core/Services/Calendar/EventStore.vala"
	_tmp23_ = _tmp22_;
#line 265 "../core/Services/Calendar/EventStore.vala"
	_tmp24_ = _tmp23_;
#line 265 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_tmp21_);
#line 265 "../core/Services/Calendar/EventStore.vala"
	events = _tmp24_;
#line 266 "../core/Services/Calendar/EventStore.vala"
	_tmp25_ = events;
#line 266 "../core/Services/Calendar/EventStore.vala"
	g_signal_emit (self, calendar_event_store_signals[CALENDAR_EVENT_STORE_EVENTS_REMOVED_SIGNAL], 0, source, _tmp25_);
#line 267 "../core/Services/Calendar/EventStore.vala"
	_tmp26_ = self->priv->source_events;
#line 267 "../core/Services/Calendar/EventStore.vala"
	g_hash_table_remove (_tmp26_, source);
#line 245 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (events);
#line 245 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (current_view);
#line 2302 "EventStore.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 270 "../core/Services/Calendar/EventStore.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 270 "../core/Services/Calendar/EventStore.vala"
	return _data3_;
#line 2312 "EventStore.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 270 "../core/Services/Calendar/EventStore.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2322 "EventStore.c"
		CalendarEventStore* self;
#line 270 "../core/Services/Calendar/EventStore.vala"
		self = _data3_->self;
#line 270 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data3_->events);
#line 270 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self);
#line 270 "../core/Services/Calendar/EventStore.vala"
		g_slice_free (Block3Data, _data3_);
#line 2332 "EventStore.c"
	}
}

static void
__lambda17_ (Block3Data* _data3_,
             ESource* source)
{
	CalendarEventStore* self;
	ESourceCalendar* cal = NULL;
	ESourceExtension* _tmp0_;
	ESourceCalendar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	ESourceCalendar* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 272 "../core/Services/Calendar/EventStore.vala"
	self = _data3_->self;
#line 272 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 273 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
#line 273 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_calendar_get_type (), ESourceCalendar));
#line 273 "../core/Services/Calendar/EventStore.vala"
	cal = _tmp1_;
#line 274 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = cal;
#line 274 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = e_source_selectable_get_selected ((ESourceSelectable*) _tmp3_);
#line 274 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = _tmp4_;
#line 274 "../core/Services/Calendar/EventStore.vala"
	if (_tmp5_ == TRUE) {
#line 2366 "EventStore.c"
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 274 "../core/Services/Calendar/EventStore.vala"
		_tmp6_ = e_source_get_enabled (source);
#line 274 "../core/Services/Calendar/EventStore.vala"
		_tmp7_ = _tmp6_;
#line 274 "../core/Services/Calendar/EventStore.vala"
		_tmp2_ = _tmp7_ == TRUE;
#line 2375 "EventStore.c"
	} else {
#line 274 "../core/Services/Calendar/EventStore.vala"
		_tmp2_ = FALSE;
#line 2379 "EventStore.c"
	}
#line 274 "../core/Services/Calendar/EventStore.vala"
	if (_tmp2_) {
#line 2383 "EventStore.c"
		GHashTable* _tmp8_;
		gconstpointer _tmp9_;
		GeeCollection* _tmp10_;
		GeeCollection* _tmp11_;
		GeeCollection* _tmp12_;
		GeeCollection* _tmp13_;
		GeeCollection* _tmp14_;
#line 275 "../core/Services/Calendar/EventStore.vala"
		_tmp8_ = self->priv->source_events;
#line 275 "../core/Services/Calendar/EventStore.vala"
		_tmp9_ = g_hash_table_lookup (_tmp8_, source);
#line 275 "../core/Services/Calendar/EventStore.vala"
		_tmp10_ = gee_multi_map_get_values ((GeeMultiMap*) ((GeeTreeMultiMap*) _tmp9_));
#line 275 "../core/Services/Calendar/EventStore.vala"
		_tmp11_ = _tmp10_;
#line 275 "../core/Services/Calendar/EventStore.vala"
		_tmp12_ = gee_collection_get_read_only_view (_tmp11_);
#line 275 "../core/Services/Calendar/EventStore.vala"
		_tmp13_ = _tmp12_;
#line 275 "../core/Services/Calendar/EventStore.vala"
		_tmp14_ = _tmp13_;
#line 275 "../core/Services/Calendar/EventStore.vala"
		gee_array_list_add_all (_data3_->events, _tmp14_);
#line 275 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_tmp14_);
#line 275 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_tmp11_);
#line 2411 "EventStore.c"
	}
#line 272 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (cal);
#line 2415 "EventStore.c"
}

static void
___lambda17__gfunc (gconstpointer data,
                    gpointer self)
{
#line 272 "../core/Services/Calendar/EventStore.vala"
	__lambda17_ (self, (ESource*) data);
#line 2424 "EventStore.c"
}

GeeCollection*
calendar_event_store_get_events (CalendarEventStore* self)
{
	Block3Data* _data3_;
	GeeArrayList* _tmp0_;
	ESourceRegistry* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* result;
#line 270 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 270 "../core/Services/Calendar/EventStore.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 270 "../core/Services/Calendar/EventStore.vala"
	_data3_->_ref_count_ = 1;
#line 270 "../core/Services/Calendar/EventStore.vala"
	_data3_->self = g_object_ref (self);
#line 271 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = gee_array_list_new (e_cal_component_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 271 "../core/Services/Calendar/EventStore.vala"
	_data3_->events = _tmp0_;
#line 272 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = self->priv->_registry;
#line 272 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = e_source_registry_list_sources (_tmp1_, E_SOURCE_EXTENSION_CALENDAR);
#line 272 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = _tmp2_;
#line 272 "../core/Services/Calendar/EventStore.vala"
	g_list_foreach (_tmp3_, ___lambda17__gfunc, _data3_);
#line 272 "../core/Services/Calendar/EventStore.vala"
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (_g_list_free__g_object_unref0_ (_tmp3_), NULL));
#line 278 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = _g_object_ref0 ((GeeCollection*) _data3_->events);
#line 278 "../core/Services/Calendar/EventStore.vala"
	result = _tmp4_;
#line 278 "../core/Services/Calendar/EventStore.vala"
	block3_data_unref (_data3_);
#line 278 "../core/Services/Calendar/EventStore.vala"
	_data3_ = NULL;
#line 278 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 2469 "EventStore.c"
}

/** Set the week_starts_on property: the first day of the week.
     *
     * Locale handling is based on information from
     * https://sourceware.org/glibc/wiki/Locales
     */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 2511 "EventStore.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 2517 "EventStore.c"
}

static GDateWeekday
calendar_event_store_get_week_start (CalendarEventStore* self)
{
	guint week_day1 = 0U;
	const gchar* _tmp0_;
	gint week_1stday = 0;
	gint glib_offset = 0;
	gint week_start_posix = 0;
	const gchar* _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_ = 0;
	guint8* _tmp4_;
	gint _tmp4__length1;
	guint8 _tmp5_;
	gint week_start = 0;
	GDateWeekday result;
#line 288 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 295 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = nl_langinfo (_NL_TIME_WEEK_1STDAY);
#line 295 "../core/Services/Calendar/EventStore.vala"
	week_day1 = (guint) _tmp0_;
#line 296 "../core/Services/Calendar/EventStore.vala"
	week_1stday = 0;
#line 297 "../core/Services/Calendar/EventStore.vala"
	if (week_day1 == ((guint) 19971130)) {
#line 298 "../core/Services/Calendar/EventStore.vala"
		week_1stday = 0;
#line 2549 "EventStore.c"
	} else {
#line 299 "../core/Services/Calendar/EventStore.vala"
		if (week_day1 == ((guint) 19971201)) {
#line 300 "../core/Services/Calendar/EventStore.vala"
			week_1stday = 1;
#line 2555 "EventStore.c"
		} else {
#line 302 "../core/Services/Calendar/EventStore.vala"
			g_warning ("EventStore.vala:302: Unknown value of _NL_TIME_WEEK_1STDAY: %u", week_day1);
#line 2559 "EventStore.c"
		}
	}
#line 309 "../core/Services/Calendar/EventStore.vala"
	glib_offset = week_1stday - 1;
#line 314 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = nl_langinfo (_NL_TIME_FIRST_WEEKDAY);
#line 314 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = string_get_data (_tmp1_, &_tmp3_);
#line 314 "../core/Services/Calendar/EventStore.vala"
	_tmp2__length1 = _tmp3_;
#line 314 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = _tmp2_;
#line 314 "../core/Services/Calendar/EventStore.vala"
	_tmp4__length1 = _tmp2__length1;
#line 314 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = _tmp4_[0];
#line 314 "../core/Services/Calendar/EventStore.vala"
	week_start_posix = (gint) _tmp5_;
#line 316 "../core/Services/Calendar/EventStore.vala"
	week_start = week_start_posix + glib_offset;
#line 317 "../core/Services/Calendar/EventStore.vala"
	if (week_start == 0) {
#line 318 "../core/Services/Calendar/EventStore.vala"
		week_start = 7;
#line 2584 "EventStore.c"
	}
#line 321 "../core/Services/Calendar/EventStore.vala"
	result = (GDateWeekday) week_start;
#line 321 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 2590 "EventStore.c"
}

static GDateTime*
calendar_event_store_get_page (CalendarEventStore* self)
{
	gchar* month_page = NULL;
	GSettings* _tmp0_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gchar** numbers = NULL;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint numbers_length1;
	gint _numbers_size_;
	GDateTime* dt = NULL;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	const gchar* _tmp15_;
	GDateTime* _tmp16_;
	GDateTime* result;
#line 324 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 325 "../core/Services/Calendar/EventStore.vala"
	month_page = NULL;
#line 326 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = calendar_event_store_state_settings;
#line 326 "../core/Services/Calendar/EventStore.vala"
	if (_tmp0_ != NULL) {
#line 2625 "EventStore.c"
		GSettings* _tmp1_;
		gchar* _tmp2_;
#line 327 "../core/Services/Calendar/EventStore.vala"
		_tmp1_ = calendar_event_store_state_settings;
#line 327 "../core/Services/Calendar/EventStore.vala"
		_tmp2_ = g_settings_get_string (_tmp1_, "month-page");
#line 327 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (month_page);
#line 327 "../core/Services/Calendar/EventStore.vala"
		month_page = _tmp2_;
#line 2636 "EventStore.c"
	}
#line 330 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = month_page;
#line 330 "../core/Services/Calendar/EventStore.vala"
	if (_tmp4_ == NULL) {
#line 330 "../core/Services/Calendar/EventStore.vala"
		_tmp3_ = TRUE;
#line 2644 "EventStore.c"
	} else {
		const gchar* _tmp5_;
#line 330 "../core/Services/Calendar/EventStore.vala"
		_tmp5_ = month_page;
#line 330 "../core/Services/Calendar/EventStore.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "") == 0;
#line 2651 "EventStore.c"
	}
#line 330 "../core/Services/Calendar/EventStore.vala"
	if (_tmp3_) {
#line 2655 "EventStore.c"
		GDateTime* _tmp6_;
#line 331 "../core/Services/Calendar/EventStore.vala"
		_tmp6_ = g_date_time_new_now_local ();
#line 331 "../core/Services/Calendar/EventStore.vala"
		result = _tmp6_;
#line 331 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (month_page);
#line 331 "../core/Services/Calendar/EventStore.vala"
		return result;
#line 2665 "EventStore.c"
	}
#line 334 "../core/Services/Calendar/EventStore.vala"
	_tmp7_ = month_page;
#line 334 "../core/Services/Calendar/EventStore.vala"
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "-", 2);
#line 334 "../core/Services/Calendar/EventStore.vala"
	numbers = _tmp9_;
#line 334 "../core/Services/Calendar/EventStore.vala"
	numbers_length1 = _vala_array_length (_tmp8_);
#line 334 "../core/Services/Calendar/EventStore.vala"
	_numbers_size_ = numbers_length1;
#line 335 "../core/Services/Calendar/EventStore.vala"
	_tmp10_ = numbers;
#line 335 "../core/Services/Calendar/EventStore.vala"
	_tmp10__length1 = numbers_length1;
#line 335 "../core/Services/Calendar/EventStore.vala"
	_tmp11_ = _tmp10_[0];
#line 335 "../core/Services/Calendar/EventStore.vala"
	_tmp12_ = g_date_time_new_local (atoi (_tmp11_), 1, 1, 0, 0, (gdouble) 0);
#line 335 "../core/Services/Calendar/EventStore.vala"
	dt = _tmp12_;
#line 336 "../core/Services/Calendar/EventStore.vala"
	_tmp13_ = dt;
#line 336 "../core/Services/Calendar/EventStore.vala"
	_tmp14_ = numbers;
#line 336 "../core/Services/Calendar/EventStore.vala"
	_tmp14__length1 = numbers_length1;
#line 336 "../core/Services/Calendar/EventStore.vala"
	_tmp15_ = _tmp14_[1];
#line 336 "../core/Services/Calendar/EventStore.vala"
	_tmp16_ = g_date_time_add_months (_tmp13_, atoi (_tmp15_) - 1);
#line 336 "../core/Services/Calendar/EventStore.vala"
	_g_date_time_unref0 (dt);
#line 336 "../core/Services/Calendar/EventStore.vala"
	dt = _tmp16_;
#line 337 "../core/Services/Calendar/EventStore.vala"
	result = dt;
#line 337 "../core/Services/Calendar/EventStore.vala"
	numbers = (_vala_array_free (numbers, numbers_length1, (GDestroyNotify) g_free), NULL);
#line 337 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (month_page);
#line 337 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 2709 "EventStore.c"
}

/** Set the values of month_range and data_range.
     *
     * month_range contains the entire month starting with month_start.
     *
     * data_range fills in the rest of the visible calendar block, including the
     *  week before the month starts and the week after it ends.
     */
static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 2732 "EventStore.c"
}

static void
calendar_event_store_compute_ranges (CalendarEventStore* self)
{
	GSettings* _tmp0_;
	GDateTime* month_end = NULL;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	CalendarUtilDateRange* _tmp9_;
	CalendarUtilDateRange* _tmp10_;
	gint dow = 0;
	GDateTime* _tmp11_;
	gint wso = 0;
	GDateWeekday _tmp12_;
	gint offset = 0;
	GDateTime* data_range_first = NULL;
	GDateTime* _tmp13_;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	GDateTime* data_range_last = NULL;
	GDateTime* _tmp16_;
	GDateTime* _tmp17_;
	GDateTime* _tmp18_;
	CalendarUtilDateRange* _tmp19_;
	CalendarUtilDateRange* _tmp20_;
	CalendarUtilDateRange* _tmp21_;
	GeeList* _tmp22_;
	GeeList* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GDateTime* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GDateTime* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GDateTime* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
#line 347 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 348 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = calendar_event_store_state_settings;
#line 348 "../core/Services/Calendar/EventStore.vala"
	if (_tmp0_ != NULL) {
#line 2785 "EventStore.c"
		GSettings* _tmp1_;
		GDateTime* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 349 "../core/Services/Calendar/EventStore.vala"
		_tmp1_ = calendar_event_store_state_settings;
#line 349 "../core/Services/Calendar/EventStore.vala"
		_tmp2_ = self->priv->_month_start;
#line 349 "../core/Services/Calendar/EventStore.vala"
		_tmp3_ = g_date_time_format (_tmp2_, "%Y-%m");
#line 349 "../core/Services/Calendar/EventStore.vala"
		_tmp4_ = _tmp3_;
#line 349 "../core/Services/Calendar/EventStore.vala"
		g_settings_set_string (_tmp1_, "month-page", _tmp4_);
#line 349 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (_tmp4_);
#line 2802 "EventStore.c"
	}
#line 352 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = self->priv->_month_start;
#line 352 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = g_date_time_add_full (_tmp5_, 0, 1, 0, 0, 0, (gdouble) 0);
#line 352 "../core/Services/Calendar/EventStore.vala"
	month_end = _tmp6_;
#line 353 "../core/Services/Calendar/EventStore.vala"
	_tmp7_ = self->priv->_month_start;
#line 353 "../core/Services/Calendar/EventStore.vala"
	_tmp8_ = month_end;
#line 353 "../core/Services/Calendar/EventStore.vala"
	_tmp9_ = calendar_util_date_range_new (_tmp7_, _tmp8_);
#line 353 "../core/Services/Calendar/EventStore.vala"
	_tmp10_ = _tmp9_;
#line 353 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_set_month_range (self, _tmp10_);
#line 353 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_tmp10_);
#line 355 "../core/Services/Calendar/EventStore.vala"
	_tmp11_ = self->priv->_month_start;
#line 355 "../core/Services/Calendar/EventStore.vala"
	dow = g_date_time_get_day_of_week (_tmp11_);
#line 356 "../core/Services/Calendar/EventStore.vala"
	_tmp12_ = self->priv->_week_starts_on;
#line 356 "../core/Services/Calendar/EventStore.vala"
	wso = (gint) _tmp12_;
#line 357 "../core/Services/Calendar/EventStore.vala"
	offset = 0;
#line 361 "../core/Services/Calendar/EventStore.vala"
	if (wso < dow) {
#line 362 "../core/Services/Calendar/EventStore.vala"
		offset = dow - wso;
#line 2836 "EventStore.c"
	} else {
#line 363 "../core/Services/Calendar/EventStore.vala"
		if (wso > dow) {
#line 364 "../core/Services/Calendar/EventStore.vala"
			offset = (7 + dow) - wso;
#line 2842 "EventStore.c"
		}
	}
#line 367 "../core/Services/Calendar/EventStore.vala"
	_tmp13_ = self->priv->_month_start;
#line 367 "../core/Services/Calendar/EventStore.vala"
	_tmp14_ = g_date_time_add_days (_tmp13_, -offset);
#line 367 "../core/Services/Calendar/EventStore.vala"
	data_range_first = _tmp14_;
#line 369 "../core/Services/Calendar/EventStore.vala"
	_tmp15_ = month_end;
#line 369 "../core/Services/Calendar/EventStore.vala"
	dow = g_date_time_get_day_of_week (_tmp15_);
#line 371 "../core/Services/Calendar/EventStore.vala"
	offset = 0;
#line 372 "../core/Services/Calendar/EventStore.vala"
	if (wso < dow) {
#line 373 "../core/Services/Calendar/EventStore.vala"
		offset = dow - wso;
#line 2861 "EventStore.c"
	} else {
#line 374 "../core/Services/Calendar/EventStore.vala"
		if (wso > dow) {
#line 375 "../core/Services/Calendar/EventStore.vala"
			offset = (7 + dow) - wso;
#line 2867 "EventStore.c"
		}
	}
#line 379 "../core/Services/Calendar/EventStore.vala"
	offset = (-offset) + 7;
#line 381 "../core/Services/Calendar/EventStore.vala"
	_tmp16_ = month_end;
#line 381 "../core/Services/Calendar/EventStore.vala"
	_tmp17_ = g_date_time_add_days (_tmp16_, offset);
#line 381 "../core/Services/Calendar/EventStore.vala"
	data_range_last = _tmp17_;
#line 383 "../core/Services/Calendar/EventStore.vala"
	_tmp18_ = data_range_first;
#line 383 "../core/Services/Calendar/EventStore.vala"
	_tmp19_ = calendar_util_date_range_new (_tmp18_, data_range_last);
#line 383 "../core/Services/Calendar/EventStore.vala"
	_tmp20_ = _tmp19_;
#line 383 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_set_data_range (self, _tmp20_);
#line 383 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_tmp20_);
#line 384 "../core/Services/Calendar/EventStore.vala"
	_tmp21_ = self->priv->_data_range;
#line 384 "../core/Services/Calendar/EventStore.vala"
	_tmp22_ = calendar_util_date_range_to_list (_tmp21_);
#line 384 "../core/Services/Calendar/EventStore.vala"
	_tmp23_ = _tmp22_;
#line 384 "../core/Services/Calendar/EventStore.vala"
	_tmp24_ = gee_collection_get_size ((GeeCollection*) _tmp23_);
#line 384 "../core/Services/Calendar/EventStore.vala"
	_tmp25_ = _tmp24_;
#line 384 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_set_num_weeks (self, _tmp25_ / 7);
#line 384 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_tmp23_);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp26_ = data_range_first;
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp27_ = g_date_time_to_string (_tmp26_);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp28_ = _tmp27_;
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp29_ = self->priv->_month_start;
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp30_ = g_date_time_to_string (_tmp29_);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp31_ = _tmp30_;
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp32_ = month_end;
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp33_ = g_date_time_to_string (_tmp32_);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp34_ = _tmp33_;
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp35_ = g_date_time_to_string (data_range_last);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp36_ = _tmp35_;
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp37_ = g_strconcat ("Date ranges: (", _tmp28_, " <= ", _tmp31_, " < ", _tmp34_, " <= ", _tmp36_, ")", NULL);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_tmp38_ = _tmp37_;
#line 386 "../core/Services/Calendar/EventStore.vala"
	g_debug ("EventStore.vala:386: %s", _tmp38_);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp38_);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp36_);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp34_);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp31_);
#line 386 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp28_);
#line 347 "../core/Services/Calendar/EventStore.vala"
	_g_date_time_unref0 (data_range_last);
#line 347 "../core/Services/Calendar/EventStore.vala"
	_g_date_time_unref0 (data_range_first);
#line 347 "../core/Services/Calendar/EventStore.vala"
	_g_date_time_unref0 (month_end);
#line 2946 "EventStore.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 389 "../core/Services/Calendar/EventStore.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 389 "../core/Services/Calendar/EventStore.vala"
	return _data4_;
#line 2956 "EventStore.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 389 "../core/Services/Calendar/EventStore.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 2966 "EventStore.c"
		CalendarEventStore* self;
#line 389 "../core/Services/Calendar/EventStore.vala"
		self = _data4_->self;
#line 389 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data4_->client);
#line 389 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data4_->source);
#line 389 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self);
#line 389 "../core/Services/Calendar/EventStore.vala"
		g_slice_free (Block4Data, _data4_);
#line 2978 "EventStore.c"
	}
}

static void
___lambda5_ (Block4Data* _data4_,
             GSList* objects)
{
	CalendarEventStore* self;
#line 414 "../core/Services/Calendar/EventStore.vala"
	self = _data4_->self;
#line 414 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_on_objects_added (self, _data4_->source, _data4_->client, objects);
#line 2991 "EventStore.c"
}

static void
____lambda5__e_cal_client_view_objects_added (ECalClientView* _sender,
                                              GSList* objects,
                                              gpointer self)
{
#line 414 "../core/Services/Calendar/EventStore.vala"
	___lambda5_ (self, objects);
#line 3001 "EventStore.c"
}

static void
___lambda8_ (Block4Data* _data4_,
             GSList* objects)
{
	CalendarEventStore* self;
#line 415 "../core/Services/Calendar/EventStore.vala"
	self = _data4_->self;
#line 415 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_on_objects_removed (self, _data4_->source, _data4_->client, objects);
#line 3013 "EventStore.c"
}

static void
____lambda8__e_cal_client_view_objects_removed (ECalClientView* _sender,
                                                GSList* uids,
                                                gpointer self)
{
#line 415 "../core/Services/Calendar/EventStore.vala"
	___lambda8_ (self, uids);
#line 3023 "EventStore.c"
}

static void
___lambda10_ (Block4Data* _data4_,
              GSList* objects)
{
	CalendarEventStore* self;
#line 416 "../core/Services/Calendar/EventStore.vala"
	self = _data4_->self;
#line 416 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_on_objects_modified (self, _data4_->source, _data4_->client, objects);
#line 3035 "EventStore.c"
}

static void
____lambda10__e_cal_client_view_objects_modified (ECalClientView* _sender,
                                                  GSList* objects,
                                                  gpointer self)
{
#line 416 "../core/Services/Calendar/EventStore.vala"
	___lambda10_ (self, objects);
#line 3045 "EventStore.c"
}

static void
__lambda4_ (Block4Data* _data4_,
            GObject* obj,
            GAsyncResult* results)
{
	CalendarEventStore* self;
	ECalClientView* view = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GHashTable* _tmp11_;
	gchar* _tmp12_;
	ECalClientView* _tmp13_;
	ECalClientView* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 409 "../core/Services/Calendar/EventStore.vala"
	self = _data4_->self;
#line 409 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (results != NULL);
#line 411 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = e_source_dup_display_name (_data4_->source);
#line 411 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = _tmp0_;
#line 411 "../core/Services/Calendar/EventStore.vala"
	g_debug ("EventStore.vala:411: Received client-view for source '%s'", _tmp1_);
#line 411 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp1_);
#line 3074 "EventStore.c"
	{
		ECalClientView* _tmp2_ = NULL;
		ECalClientView* _tmp3_;
		ECalClientView* _tmp4_;
		ECalClientView* _tmp5_;
		ECalClientView* _tmp6_;
#line 413 "../core/Services/Calendar/EventStore.vala"
		e_cal_client_get_view_finish (_data4_->client, results, &_tmp2_, &_inner_error0_);
#line 413 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (view);
#line 413 "../core/Services/Calendar/EventStore.vala"
		view = _tmp2_;
#line 413 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3089 "EventStore.c"
			goto __catch0_g_error;
		}
#line 414 "../core/Services/Calendar/EventStore.vala"
		_tmp3_ = view;
#line 414 "../core/Services/Calendar/EventStore.vala"
		g_signal_connect_data (_tmp3_, "objects-added", (GCallback) ____lambda5__e_cal_client_view_objects_added, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 415 "../core/Services/Calendar/EventStore.vala"
		_tmp4_ = view;
#line 415 "../core/Services/Calendar/EventStore.vala"
		g_signal_connect_data (_tmp4_, "objects-removed", (GCallback) ____lambda8__e_cal_client_view_objects_removed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 416 "../core/Services/Calendar/EventStore.vala"
		_tmp5_ = view;
#line 416 "../core/Services/Calendar/EventStore.vala"
		g_signal_connect_data (_tmp5_, "objects-modified", (GCallback) ____lambda10__e_cal_client_view_objects_modified, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 417 "../core/Services/Calendar/EventStore.vala"
		_tmp6_ = view;
#line 417 "../core/Services/Calendar/EventStore.vala"
		e_cal_client_view_start (_tmp6_, &_inner_error0_);
#line 417 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3110 "EventStore.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 412 "../core/Services/Calendar/EventStore.vala"
		e = _inner_error0_;
#line 412 "../core/Services/Calendar/EventStore.vala"
		_inner_error0_ = NULL;
#line 419 "../core/Services/Calendar/EventStore.vala"
		_tmp7_ = e_source_dup_display_name (_data4_->source);
#line 419 "../core/Services/Calendar/EventStore.vala"
		_tmp8_ = _tmp7_;
#line 419 "../core/Services/Calendar/EventStore.vala"
		_tmp9_ = e;
#line 419 "../core/Services/Calendar/EventStore.vala"
		_tmp10_ = _tmp9_->message;
#line 419 "../core/Services/Calendar/EventStore.vala"
		g_critical ("EventStore.vala:419: Error from source '%s': %s", _tmp8_, _tmp10_);
#line 419 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (_tmp8_);
#line 412 "../core/Services/Calendar/EventStore.vala"
		_g_error_free0 (e);
#line 3140 "EventStore.c"
	}
	__finally0:
#line 412 "../core/Services/Calendar/EventStore.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 412 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (view);
#line 412 "../core/Services/Calendar/EventStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 412 "../core/Services/Calendar/EventStore.vala"
		g_clear_error (&_inner_error0_);
#line 412 "../core/Services/Calendar/EventStore.vala"
		return;
#line 3153 "EventStore.c"
	}
#line 422 "../core/Services/Calendar/EventStore.vala"
	_tmp11_ = self->priv->source_view;
#line 422 "../core/Services/Calendar/EventStore.vala"
	_tmp12_ = e_source_dup_uid (_data4_->source);
#line 422 "../core/Services/Calendar/EventStore.vala"
	_tmp13_ = view;
#line 422 "../core/Services/Calendar/EventStore.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 422 "../core/Services/Calendar/EventStore.vala"
	g_hash_table_insert (_tmp11_, _tmp12_, _tmp14_);
#line 409 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (view);
#line 3167 "EventStore.c"
}

static void
___lambda4__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 409 "../core/Services/Calendar/EventStore.vala"
	__lambda4_ (self, source_object, res);
#line 409 "../core/Services/Calendar/EventStore.vala"
	block4_data_unref (self);
#line 3179 "EventStore.c"
}

static void
calendar_event_store_load_source (CalendarEventStore* self,
                                  ESource* source)
{
	Block4Data* _data4_;
	ESource* _tmp0_;
	GeeTreeMultiMap* events = NULL;
	GCompareFunc _tmp1_;
	GeeTreeMultiMap* _tmp2_;
	GHashTable* _tmp3_;
	ESource* _tmp4_;
	GeeTreeMultiMap* _tmp5_;
	gchar* iso_first = NULL;
	CalendarUtilDateRange* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	gchar* _tmp9_;
	gchar* iso_last = NULL;
	CalendarUtilDateRange* _tmp10_;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	GDateTime* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* query = NULL;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GError* _inner_error0_ = NULL;
#line 389 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 389 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 389 "../core/Services/Calendar/EventStore.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 389 "../core/Services/Calendar/EventStore.vala"
	_data4_->_ref_count_ = 1;
#line 389 "../core/Services/Calendar/EventStore.vala"
	_data4_->self = g_object_ref (self);
#line 389 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 389 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data4_->source);
#line 389 "../core/Services/Calendar/EventStore.vala"
	_data4_->source = _tmp0_;
#line 391 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = ((GCompareFunc) g_strcmp0);
#line 391 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, e_cal_component_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GCompareDataFunc) _tmp1_, NULL, NULL, (GCompareDataFunc) calendar_util_ecalcomponent_compare_func, NULL, NULL);
#line 391 "../core/Services/Calendar/EventStore.vala"
	events = _tmp2_;
#line 394 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = self->priv->source_events;
#line 394 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = _g_object_ref0 (_data4_->source);
#line 394 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = _g_object_ref0 (events);
#line 394 "../core/Services/Calendar/EventStore.vala"
	g_hash_table_insert (_tmp3_, _tmp4_, _tmp5_);
#line 396 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = self->priv->_data_range;
#line 396 "../core/Services/Calendar/EventStore.vala"
	_tmp7_ = calendar_util_date_range_get_first_dt (_tmp6_);
#line 396 "../core/Services/Calendar/EventStore.vala"
	_tmp8_ = _tmp7_;
#line 396 "../core/Services/Calendar/EventStore.vala"
	_tmp9_ = isodate_from_time_t ((time_t) g_date_time_to_unix (_tmp8_));
#line 396 "../core/Services/Calendar/EventStore.vala"
	iso_first = _tmp9_;
#line 397 "../core/Services/Calendar/EventStore.vala"
	_tmp10_ = self->priv->_data_range;
#line 397 "../core/Services/Calendar/EventStore.vala"
	_tmp11_ = calendar_util_date_range_get_last_dt (_tmp10_);
#line 397 "../core/Services/Calendar/EventStore.vala"
	_tmp12_ = _tmp11_;
#line 397 "../core/Services/Calendar/EventStore.vala"
	_tmp13_ = g_date_time_add_days (_tmp12_, 1);
#line 397 "../core/Services/Calendar/EventStore.vala"
	_tmp14_ = _tmp13_;
#line 397 "../core/Services/Calendar/EventStore.vala"
	_tmp15_ = isodate_from_time_t ((time_t) g_date_time_to_unix (_tmp14_));
#line 397 "../core/Services/Calendar/EventStore.vala"
	_tmp16_ = _tmp15_;
#line 397 "../core/Services/Calendar/EventStore.vala"
	_g_date_time_unref0 (_tmp14_);
#line 397 "../core/Services/Calendar/EventStore.vala"
	iso_last = _tmp16_;
#line 398 "../core/Services/Calendar/EventStore.vala"
	_tmp17_ = string_to_string (iso_first);
#line 398 "../core/Services/Calendar/EventStore.vala"
	_tmp18_ = string_to_string (iso_last);
#line 398 "../core/Services/Calendar/EventStore.vala"
	_tmp19_ = g_strconcat ("(occur-in-time-range? (make-time \"", _tmp17_, "\") (make-time \"", _tmp18_, "\"))", NULL);
#line 398 "../core/Services/Calendar/EventStore.vala"
	query = _tmp19_;
#line 3280 "EventStore.c"
	{
		GHashTable* _tmp20_;
#line 401 "../core/Services/Calendar/EventStore.vala"
		_tmp20_ = self->priv->source_client;
#line 401 "../core/Services/Calendar/EventStore.vala"
		g_rec_mutex_lock (&self->priv->__lock_source_client);
#line 3287 "EventStore.c"
		{
			GHashTable* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gconstpointer _tmp24_;
			ECalClient* _tmp25_;
#line 402 "../core/Services/Calendar/EventStore.vala"
			_tmp21_ = self->priv->source_client;
#line 402 "../core/Services/Calendar/EventStore.vala"
			_tmp22_ = e_source_dup_uid (_data4_->source);
#line 402 "../core/Services/Calendar/EventStore.vala"
			_tmp23_ = _tmp22_;
#line 402 "../core/Services/Calendar/EventStore.vala"
			_tmp24_ = g_hash_table_lookup (_tmp21_, _tmp23_);
#line 402 "../core/Services/Calendar/EventStore.vala"
			_tmp25_ = _g_object_ref0 ((ECalClient*) _tmp24_);
#line 402 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (_data4_->client);
#line 402 "../core/Services/Calendar/EventStore.vala"
			_data4_->client = _tmp25_;
#line 402 "../core/Services/Calendar/EventStore.vala"
			_g_free0 (_tmp23_);
#line 3310 "EventStore.c"
		}
		__finally0:
		{
			GHashTable* _tmp26_;
#line 401 "../core/Services/Calendar/EventStore.vala"
			_tmp26_ = self->priv->source_client;
#line 401 "../core/Services/Calendar/EventStore.vala"
			g_rec_mutex_unlock (&self->priv->__lock_source_client);
#line 3319 "EventStore.c"
		}
#line 401 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 401 "../core/Services/Calendar/EventStore.vala"
			_g_free0 (query);
#line 401 "../core/Services/Calendar/EventStore.vala"
			_g_free0 (iso_last);
#line 401 "../core/Services/Calendar/EventStore.vala"
			_g_free0 (iso_first);
#line 401 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (events);
#line 401 "../core/Services/Calendar/EventStore.vala"
			block4_data_unref (_data4_);
#line 401 "../core/Services/Calendar/EventStore.vala"
			_data4_ = NULL;
#line 401 "../core/Services/Calendar/EventStore.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 401 "../core/Services/Calendar/EventStore.vala"
			g_clear_error (&_inner_error0_);
#line 401 "../core/Services/Calendar/EventStore.vala"
			return;
#line 3341 "EventStore.c"
		}
	}
#line 405 "../core/Services/Calendar/EventStore.vala"
	if (_data4_->client == NULL) {
#line 406 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (query);
#line 406 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (iso_last);
#line 406 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (iso_first);
#line 406 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (events);
#line 406 "../core/Services/Calendar/EventStore.vala"
		block4_data_unref (_data4_);
#line 406 "../core/Services/Calendar/EventStore.vala"
		_data4_ = NULL;
#line 406 "../core/Services/Calendar/EventStore.vala"
		return;
#line 3360 "EventStore.c"
	}
#line 408 "../core/Services/Calendar/EventStore.vala"
	_tmp27_ = e_source_dup_display_name (_data4_->source);
#line 408 "../core/Services/Calendar/EventStore.vala"
	_tmp28_ = _tmp27_;
#line 408 "../core/Services/Calendar/EventStore.vala"
	g_debug ("EventStore.vala:408: Getting client-view for source '%s'", _tmp28_);
#line 408 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp28_);
#line 409 "../core/Services/Calendar/EventStore.vala"
	e_cal_client_get_view (_data4_->client, query, NULL, ___lambda4__gasync_ready_callback, block4_data_ref (_data4_));
#line 389 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (query);
#line 389 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (iso_last);
#line 389 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (iso_first);
#line 389 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (events);
#line 389 "../core/Services/Calendar/EventStore.vala"
	block4_data_unref (_data4_);
#line 389 "../core/Services/Calendar/EventStore.vala"
	_data4_ = NULL;
#line 3384 "EventStore.c"
}

static void
calendar_event_store_add_source_async_data_free (gpointer _data)
{
	CalendarEventStoreAddSourceAsyncData* _data_;
	_data_ = _data;
#line 15 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data_->self);
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_slice_free (CalendarEventStoreAddSourceAsyncData, _data_);
#line 3396 "EventStore.c"
}

static void
calendar_event_store_add_source_async (CalendarEventStore* self,
                                       ESource* source,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	CalendarEventStoreAddSourceAsyncData* _data_;
	CalendarEventStore* _tmp0_;
	ESource* _tmp1_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_ = g_slice_new0 (CalendarEventStoreAddSourceAsyncData);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_task_set_task_data (_data_->_async_result, _data_, calendar_event_store_add_source_async_data_free);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_->self = _tmp0_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = _g_object_ref0 (source);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data_->source);
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_->source = _tmp1_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_add_source_async_co (_data_);
#line 3430 "EventStore.c"
}

static void
calendar_event_store_add_source_finish (CalendarEventStore* self,
                                        GAsyncResult* _res_)
{
	CalendarEventStoreAddSourceAsyncData* _data_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3440 "EventStore.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 427 "../core/Services/Calendar/EventStore.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 427 "../core/Services/Calendar/EventStore.vala"
	return _data5_;
#line 3450 "EventStore.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 427 "../core/Services/Calendar/EventStore.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 3460 "EventStore.c"
		CalendarEventStore* self;
#line 427 "../core/Services/Calendar/EventStore.vala"
		self = _data5_->self;
#line 427 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data5_->source);
#line 427 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self);
#line 427 "../core/Services/Calendar/EventStore.vala"
		g_slice_free (Block5Data, _data5_);
#line 3470 "EventStore.c"
	}
}

static void
calendar_event_store_add_source_async_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	CalendarEventStoreAddSourceAsyncData* _data_;
#line 432 "../core/Services/Calendar/EventStore.vala"
	_data_ = _user_data_;
#line 432 "../core/Services/Calendar/EventStore.vala"
	_data_->_source_object_ = source_object;
#line 432 "../core/Services/Calendar/EventStore.vala"
	_data_->_res_ = _res_;
#line 432 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_add_source_async_co (_data_);
#line 3488 "EventStore.c"
}

static gboolean
__lambda13_ (Block5Data* _data5_)
{
	CalendarEventStore* self;
	gboolean result;
#line 438 "../core/Services/Calendar/EventStore.vala"
	self = _data5_->self;
#line 439 "../core/Services/Calendar/EventStore.vala"
	g_signal_emit (self, calendar_event_store_signals[CALENDAR_EVENT_STORE_CONNECTED_SIGNAL], 0, _data5_->source);
#line 440 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_load_source (self, _data5_->source);
#line 441 "../core/Services/Calendar/EventStore.vala"
	result = FALSE;
#line 441 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 3506 "EventStore.c"
}

static gboolean
___lambda13__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda13_ (self);
#line 438 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 3516 "EventStore.c"
}

static gboolean
calendar_event_store_add_source_async_co (CalendarEventStoreAddSourceAsyncData* _data_)
{
#line 427 "../core/Services/Calendar/EventStore.vala"
	switch (_data_->_state_) {
#line 427 "../core/Services/Calendar/EventStore.vala"
		case 0:
#line 3526 "EventStore.c"
		goto _state_0;
#line 427 "../core/Services/Calendar/EventStore.vala"
		case 1:
#line 3530 "EventStore.c"
		goto _state_1;
		default:
#line 427 "../core/Services/Calendar/EventStore.vala"
		g_assert_not_reached ();
#line 3535 "EventStore.c"
	}
	_state_0:
#line 427 "../core/Services/Calendar/EventStore.vala"
	_data_->_data5_ = g_slice_new0 (Block5Data);
#line 427 "../core/Services/Calendar/EventStore.vala"
	_data_->_data5_->_ref_count_ = 1;
#line 427 "../core/Services/Calendar/EventStore.vala"
	_data_->_data5_->self = g_object_ref (_data_->self);
#line 427 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data_->_data5_->source);
#line 427 "../core/Services/Calendar/EventStore.vala"
	_data_->_data5_->source = _data_->source;
#line 427 "../core/Services/Calendar/EventStore.vala"
	_data_->_data5_->_async_data_ = _data_;
#line 428 "../core/Services/Calendar/EventStore.vala"
	_data_->_tmp0_ = e_source_dup_display_name (_data_->_data5_->source);
#line 428 "../core/Services/Calendar/EventStore.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 428 "../core/Services/Calendar/EventStore.vala"
	g_debug ("EventStore.vala:428: Adding source '%s'", _data_->_tmp1_);
#line 428 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_data_->_tmp1_);
#line 3558 "EventStore.c"
	{
#line 430 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp2_ = g_cancellable_new ();
#line 430 "../core/Services/Calendar/EventStore.vala"
		_data_->cancellable = _data_->_tmp2_;
#line 431 "../core/Services/Calendar/EventStore.vala"
		g_signal_emit (_data_->self, calendar_event_store_signals[CALENDAR_EVENT_STORE_CONNECTING_SIGNAL], 0, _data_->_data5_->source, _data_->cancellable);
#line 432 "../core/Services/Calendar/EventStore.vala"
		_data_->_state_ = 1;
#line 432 "../core/Services/Calendar/EventStore.vala"
		e_cal_client_connect (_data_->_data5_->source, E_CAL_CLIENT_SOURCE_TYPE_EVENTS, (guint32) -1, _data_->cancellable, calendar_event_store_add_source_async_ready, _data_);
#line 432 "../core/Services/Calendar/EventStore.vala"
		return FALSE;
#line 3572 "EventStore.c"
		_state_1:
#line 432 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp4_ = e_cal_client_connect_finish (_data_->_res_, &_data_->_inner_error0_);
#line 432 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp3_ = _data_->_tmp4_;
#line 432 "../core/Services/Calendar/EventStore.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 432 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (_data_->cancellable);
#line 3582 "EventStore.c"
			goto __catch0_g_error;
		}
#line 432 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, e_cal_client_get_type (), ECalClient));
#line 432 "../core/Services/Calendar/EventStore.vala"
		_data_->client = _data_->_tmp5_;
#line 433 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp6_ = _data_->self->priv->source_client;
#line 433 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp7_ = e_source_get_uid (_data_->_data5_->source);
#line 433 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp8_ = g_strdup (_data_->_tmp7_);
#line 433 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp9_ = _data_->client;
#line 433 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp9_);
#line 433 "../core/Services/Calendar/EventStore.vala"
		g_hash_table_insert (_data_->_tmp6_, _data_->_tmp8_, _data_->_tmp10_);
#line 429 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data_->client);
#line 429 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data_->_tmp3_);
#line 429 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data_->cancellable);
#line 3607 "EventStore.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 429 "../core/Services/Calendar/EventStore.vala"
		_data_->e = _data_->_inner_error0_;
#line 429 "../core/Services/Calendar/EventStore.vala"
		_data_->_inner_error0_ = NULL;
#line 435 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp11_ = _data_->e;
#line 435 "../core/Services/Calendar/EventStore.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 435 "../core/Services/Calendar/EventStore.vala"
		g_signal_emit (_data_->self, calendar_event_store_signals[CALENDAR_EVENT_STORE_ERROR_RECEIVED_SIGNAL], 0, _data_->_tmp12_);
#line 429 "../core/Services/Calendar/EventStore.vala"
		_g_error_free0 (_data_->e);
#line 3624 "EventStore.c"
	}
	__finally0:
#line 429 "../core/Services/Calendar/EventStore.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 429 "../core/Services/Calendar/EventStore.vala"
		block5_data_unref (_data_->_data5_);
#line 429 "../core/Services/Calendar/EventStore.vala"
		_data_->_data5_ = NULL;
#line 429 "../core/Services/Calendar/EventStore.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 429 "../core/Services/Calendar/EventStore.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 429 "../core/Services/Calendar/EventStore.vala"
		g_object_unref (_data_->_async_result);
#line 429 "../core/Services/Calendar/EventStore.vala"
		return FALSE;
#line 3641 "EventStore.c"
	}
#line 438 "../core/Services/Calendar/EventStore.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda13__gsource_func, block5_data_ref (_data_->_data5_), block5_data_unref);
#line 427 "../core/Services/Calendar/EventStore.vala"
	block5_data_unref (_data_->_data5_);
#line 427 "../core/Services/Calendar/EventStore.vala"
	_data_->_data5_ = NULL;
#line 427 "../core/Services/Calendar/EventStore.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 427 "../core/Services/Calendar/EventStore.vala"
	if (_data_->_state_ != 0) {
#line 427 "../core/Services/Calendar/EventStore.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 427 "../core/Services/Calendar/EventStore.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3657 "EventStore.c"
		}
	}
#line 427 "../core/Services/Calendar/EventStore.vala"
	g_object_unref (_data_->_async_result);
#line 427 "../core/Services/Calendar/EventStore.vala"
	return FALSE;
#line 3664 "EventStore.c"
}

static void
_vala_ECalComponentId_free (ECalComponentId* self)
{
#line 447 "../core/Services/Calendar/EventStore.vala"
	g_boxed_free (e_cal_component_id_get_type (), self);
#line 3672 "EventStore.c"
}

static void
calendar_event_store_debug_event (CalendarEventStore* self,
                                  ESource* source,
                                  ECalComponent* event,
                                  const gchar* message)
{
	ICalComponent* comp = NULL;
	ICalComponent* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	ICalTime* _tmp9_;
	ICalTime* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	ECalComponentId* _tmp16_;
	ECalComponentId* _tmp17_;
	const gchar* _tmp18_;
#line 445 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 445 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 445 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (event != NULL);
#line 445 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (message != NULL);
#line 446 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = e_cal_component_get_icalcomponent (event);
#line 446 "../core/Services/Calendar/EventStore.vala"
	comp = _tmp0_;
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = string_to_string (message);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = i_cal_component_get_summary (comp);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = string_to_string (_tmp2_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = e_source_dup_display_name (source);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = _tmp4_;
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = string_to_string (_tmp5_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp7_ = i_cal_component_get_uid (comp);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp8_ = string_to_string (_tmp7_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp9_ = i_cal_component_get_dtstart (comp);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp10_ = _tmp9_;
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp11_ = i_cal_time_as_ical_string (_tmp10_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp12_ = _tmp11_;
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp13_ = string_to_string (_tmp12_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp14_ = g_strconcat (_tmp1_, " Event ['", _tmp3_, "', ", _tmp6_, ", UID ", _tmp8_, ", START ", _tmp13_, ", RID %s )]", NULL);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp15_ = _tmp14_;
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp16_ = e_cal_component_get_id (event);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp17_ = _tmp16_;
#line 447 "../core/Services/Calendar/EventStore.vala"
	_tmp18_ = e_cal_component_id_get_rid (_tmp17_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	g_debug (_tmp15_, _tmp18_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	__vala_ECalComponentId_free0 (_tmp17_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp15_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp12_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_tmp10_);
#line 447 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp5_);
#line 3761 "EventStore.c"
}

static void
calendar_event_store_on_parameter_changed (CalendarEventStore* self)
{
#line 451 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 452 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_compute_ranges (self);
#line 453 "../core/Services/Calendar/EventStore.vala"
	g_signal_emit (self, calendar_event_store_signals[CALENDAR_EVENT_STORE_PARAMETERS_CHANGED_SIGNAL], 0);
#line 454 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_load_all_sources (self);
#line 3775 "EventStore.c"
}

static void
calendar_event_store_on_source_changed (CalendarEventStore* self,
                                        ESource* source)
{
#line 457 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 457 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 3786 "EventStore.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 461 "../core/Services/Calendar/EventStore.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 461 "../core/Services/Calendar/EventStore.vala"
	return _data6_;
#line 3796 "EventStore.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 461 "../core/Services/Calendar/EventStore.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 3806 "EventStore.c"
		CalendarEventStore* self;
#line 461 "../core/Services/Calendar/EventStore.vala"
		self = _data6_->self;
#line 461 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data6_->added_events);
#line 461 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data6_->events);
#line 461 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data6_->source);
#line 461 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data6_->client);
#line 461 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self);
#line 461 "../core/Services/Calendar/EventStore.vala"
		g_slice_free (Block6Data, _data6_);
#line 3822 "EventStore.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 466 "../core/Services/Calendar/EventStore.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 466 "../core/Services/Calendar/EventStore.vala"
	return _data7_;
#line 3833 "EventStore.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 466 "../core/Services/Calendar/EventStore.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 3843 "EventStore.c"
		CalendarEventStore* self;
#line 466 "../core/Services/Calendar/EventStore.vala"
		self = _data7_->_data6_->self;
#line 466 "../core/Services/Calendar/EventStore.vala"
		block6_data_unref (_data7_->_data6_);
#line 466 "../core/Services/Calendar/EventStore.vala"
		_data7_->_data6_ = NULL;
#line 466 "../core/Services/Calendar/EventStore.vala"
		g_slice_free (Block7Data, _data7_);
#line 3853 "EventStore.c"
	}
}

static gboolean
__lambda7_ (Block7Data* _data7_,
            ICalComponent* comp,
            ICalTime* start,
            ICalTime* end,
            GError** error)
{
	Block6Data* _data6_;
	CalendarEventStore* self;
	ECalComponent* event = NULL;
	ICalComponent* _tmp0_;
	ECalComponent* _tmp1_;
	ECalComponent* _tmp2_;
	gboolean result;
#line 468 "../core/Services/Calendar/EventStore.vala"
	_data6_ = _data7_->_data6_;
#line 468 "../core/Services/Calendar/EventStore.vala"
	self = _data6_->self;
#line 468 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (comp != NULL, FALSE);
#line 468 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (start != NULL, FALSE);
#line 468 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (end != NULL, FALSE);
#line 469 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = _g_object_ref0 (comp);
#line 469 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = e_cal_component_new_from_icalcomponent (_tmp0_);
#line 469 "../core/Services/Calendar/EventStore.vala"
	event = _tmp1_;
#line 470 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = event;
#line 470 "../core/Services/Calendar/EventStore.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _data6_->added_events, _tmp2_)) {
#line 3891 "EventStore.c"
		ECalComponent* _tmp3_;
		ECalComponent* _tmp4_;
		ESource* _tmp5_;
		ECalComponent* _tmp6_;
		ECalComponent* _tmp7_;
#line 471 "../core/Services/Calendar/EventStore.vala"
		_tmp3_ = event;
#line 471 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_debug_event (self, _data6_->source, _tmp3_, "ADDED");
#line 472 "../core/Services/Calendar/EventStore.vala"
		_tmp4_ = event;
#line 472 "../core/Services/Calendar/EventStore.vala"
		_tmp5_ = _g_object_ref0 (_data6_->source);
#line 472 "../core/Services/Calendar/EventStore.vala"
		g_object_set_data_full ((GObject*) _tmp4_, "source", _tmp5_, g_object_unref);
#line 473 "../core/Services/Calendar/EventStore.vala"
		_tmp6_ = event;
#line 473 "../core/Services/Calendar/EventStore.vala"
		gee_multi_map_set ((GeeMultiMap*) _data6_->events, _data7_->uid, _tmp6_);
#line 474 "../core/Services/Calendar/EventStore.vala"
		_tmp7_ = event;
#line 474 "../core/Services/Calendar/EventStore.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _data6_->added_events, _tmp7_);
#line 3915 "EventStore.c"
	}
#line 477 "../core/Services/Calendar/EventStore.vala"
	result = TRUE;
#line 477 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (event);
#line 477 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 3923 "EventStore.c"
}

static gboolean
___lambda7__ecal_recur_instance_cb (ICalComponent* icomp,
                                    ICalTime* instance_start,
                                    ICalTime* instance_end,
                                    gpointer self,
                                    GCancellable* cancellable,
                                    GError** error)
{
	gboolean result;
	result = __lambda7_ (self, icomp, instance_start, instance_end, error);
#line 468 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 3938 "EventStore.c"
}

static void
__lambda6_ (Block6Data* _data6_,
            ICalComponent* comp)
{
	CalendarEventStore* self;
	Block7Data* _data7_;
	const gchar* _tmp0_;
	CalendarUtilDateRange* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	CalendarUtilDateRange* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
#line 466 "../core/Services/Calendar/EventStore.vala"
	self = _data6_->self;
#line 466 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (comp != NULL);
#line 466 "../core/Services/Calendar/EventStore.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 466 "../core/Services/Calendar/EventStore.vala"
	_data7_->_ref_count_ = 1;
#line 466 "../core/Services/Calendar/EventStore.vala"
	_data7_->_data6_ = block6_data_ref (_data6_);
#line 467 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = i_cal_component_get_uid (comp);
#line 467 "../core/Services/Calendar/EventStore.vala"
	_data7_->uid = _tmp0_;
#line 468 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = self->priv->_data_range;
#line 468 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = calendar_util_date_range_get_first_dt (_tmp1_);
#line 468 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = _tmp2_;
#line 468 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = self->priv->_data_range;
#line 468 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = calendar_util_date_range_get_last_dt (_tmp4_);
#line 468 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = _tmp5_;
#line 468 "../core/Services/Calendar/EventStore.vala"
	e_cal_client_generate_instances_for_object_sync (_data6_->client, comp, (time_t) g_date_time_to_unix (_tmp3_), (time_t) g_date_time_to_unix (_tmp6_), NULL, ___lambda7__ecal_recur_instance_cb, _data7_);
#line 466 "../core/Services/Calendar/EventStore.vala"
	block7_data_unref (_data7_);
#line 466 "../core/Services/Calendar/EventStore.vala"
	_data7_ = NULL;
#line 3986 "EventStore.c"
}

static void
___lambda6__gfunc (gconstpointer data,
                   gpointer self)
{
#line 466 "../core/Services/Calendar/EventStore.vala"
	__lambda6_ (self, (ICalComponent*) data);
#line 3995 "EventStore.c"
}

static void
calendar_event_store_on_objects_added (CalendarEventStore* self,
                                       ESource* source,
                                       ECalClient* client,
                                       GSList* objects)
{
	Block6Data* _data6_;
	ESource* _tmp0_;
	ECalClient* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GHashTable* _tmp8_;
	gconstpointer _tmp9_;
	GeeTreeMultiMap* _tmp10_;
	GeeArrayList* _tmp11_;
	GeeBidirList* _tmp12_;
	GeeBidirList* _tmp13_;
	GeeBidirList* _tmp14_;
#line 461 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 461 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 461 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (client != NULL);
#line 461 "../core/Services/Calendar/EventStore.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 461 "../core/Services/Calendar/EventStore.vala"
	_data6_->_ref_count_ = 1;
#line 461 "../core/Services/Calendar/EventStore.vala"
	_data6_->self = g_object_ref (self);
#line 461 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 461 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data6_->source);
#line 461 "../core/Services/Calendar/EventStore.vala"
	_data6_->source = _tmp0_;
#line 461 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = _g_object_ref0 (client);
#line 461 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data6_->client);
#line 461 "../core/Services/Calendar/EventStore.vala"
	_data6_->client = _tmp1_;
#line 462 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = g_strdup_printf ("%u", g_slist_length (objects));
#line 462 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = _tmp2_;
#line 462 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = g_strconcat ("Received ", _tmp3_, " added event(s) for source '%s'", NULL);
#line 462 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = _tmp4_;
#line 462 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = e_source_dup_display_name (_data6_->source);
#line 462 "../core/Services/Calendar/EventStore.vala"
	_tmp7_ = _tmp6_;
#line 462 "../core/Services/Calendar/EventStore.vala"
	g_debug (_tmp5_, _tmp7_);
#line 462 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp7_);
#line 462 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp5_);
#line 462 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp3_);
#line 463 "../core/Services/Calendar/EventStore.vala"
	_tmp8_ = self->priv->source_events;
#line 463 "../core/Services/Calendar/EventStore.vala"
	_tmp9_ = g_hash_table_lookup (_tmp8_, _data6_->source);
#line 463 "../core/Services/Calendar/EventStore.vala"
	_tmp10_ = _g_object_ref0 ((GeeTreeMultiMap*) _tmp9_);
#line 463 "../core/Services/Calendar/EventStore.vala"
	_data6_->events = _tmp10_;
#line 464 "../core/Services/Calendar/EventStore.vala"
	_tmp11_ = gee_array_list_new (e_cal_component_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeEqualDataFunc) calendar_util_ecalcomponent_equal_func, NULL, NULL);
#line 464 "../core/Services/Calendar/EventStore.vala"
	_data6_->added_events = _tmp11_;
#line 466 "../core/Services/Calendar/EventStore.vala"
	g_slist_foreach (objects, ___lambda6__gfunc, _data6_);
#line 481 "../core/Services/Calendar/EventStore.vala"
	_tmp12_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _data6_->added_events);
#line 481 "../core/Services/Calendar/EventStore.vala"
	_tmp13_ = _tmp12_;
#line 481 "../core/Services/Calendar/EventStore.vala"
	_tmp14_ = _tmp13_;
#line 481 "../core/Services/Calendar/EventStore.vala"
	g_signal_emit (self, calendar_event_store_signals[CALENDAR_EVENT_STORE_EVENTS_ADDED_SIGNAL], 0, _data6_->source, (GeeCollection*) _tmp14_);
#line 481 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_tmp14_);
#line 461 "../core/Services/Calendar/EventStore.vala"
	block6_data_unref (_data6_);
#line 461 "../core/Services/Calendar/EventStore.vala"
	_data6_ = NULL;
#line 4092 "EventStore.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 484 "../core/Services/Calendar/EventStore.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 484 "../core/Services/Calendar/EventStore.vala"
	return _data8_;
#line 4102 "EventStore.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 484 "../core/Services/Calendar/EventStore.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 4112 "EventStore.c"
		CalendarEventStore* self;
#line 484 "../core/Services/Calendar/EventStore.vala"
		self = _data8_->self;
#line 484 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data8_->added_events);
#line 484 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data8_->removed_events);
#line 484 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data8_->updated_events);
#line 484 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data8_->source);
#line 484 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data8_->client);
#line 484 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self);
#line 484 "../core/Services/Calendar/EventStore.vala"
		g_slice_free (Block8Data, _data8_);
#line 4130 "EventStore.c"
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 490 "../core/Services/Calendar/EventStore.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 490 "../core/Services/Calendar/EventStore.vala"
	return _data9_;
#line 4141 "EventStore.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 490 "../core/Services/Calendar/EventStore.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 4151 "EventStore.c"
		CalendarEventStore* self;
#line 490 "../core/Services/Calendar/EventStore.vala"
		self = _data9_->_data8_->self;
#line 490 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data9_->events_for_source);
#line 490 "../core/Services/Calendar/EventStore.vala"
		block8_data_unref (_data9_->_data8_);
#line 490 "../core/Services/Calendar/EventStore.vala"
		_data9_->_data8_ = NULL;
#line 490 "../core/Services/Calendar/EventStore.vala"
		g_slice_free (Block9Data, _data9_);
#line 4163 "EventStore.c"
	}
}

static gboolean
___lambda12_ (Block9Data* _data9_,
              ICalComponent* comp,
              ICalTime* start,
              ICalTime* end,
              GError** error)
{
	Block8Data* _data8_;
	CalendarEventStore* self;
	ECalComponent* event = NULL;
	ICalComponent* _tmp0_;
	ECalComponent* _tmp1_;
	ESource* _tmp2_;
	GeeTreeMultiMap* _tmp3_;
	const gchar* _tmp4_;
	gboolean result;
#line 506 "../core/Services/Calendar/EventStore.vala"
	_data8_ = _data9_->_data8_;
#line 506 "../core/Services/Calendar/EventStore.vala"
	self = _data8_->self;
#line 506 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (comp != NULL, FALSE);
#line 506 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (start != NULL, FALSE);
#line 506 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (end != NULL, FALSE);
#line 507 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = _g_object_ref0 (comp);
#line 507 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = e_cal_component_new_from_icalcomponent (_tmp0_);
#line 507 "../core/Services/Calendar/EventStore.vala"
	event = _tmp1_;
#line 508 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = _g_object_ref0 (_data8_->source);
#line 508 "../core/Services/Calendar/EventStore.vala"
	g_object_set_data_full ((GObject*) event, "source", _tmp2_, g_object_unref);
#line 509 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_debug_event (self, _data8_->source, event, "MODIFIED - GENERATED");
#line 510 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = _data9_->events_for_source;
#line 510 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = _data9_->uid;
#line 510 "../core/Services/Calendar/EventStore.vala"
	gee_multi_map_set ((GeeMultiMap*) _tmp3_, _tmp4_, event);
#line 511 "../core/Services/Calendar/EventStore.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _data8_->added_events, event);
#line 512 "../core/Services/Calendar/EventStore.vala"
	result = TRUE;
#line 512 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (event);
#line 512 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 4219 "EventStore.c"
}

static gboolean
____lambda12__ecal_recur_instance_cb (ICalComponent* icomp,
                                      ICalTime* instance_start,
                                      ICalTime* instance_end,
                                      gpointer self,
                                      GCancellable* cancellable,
                                      GError** error)
{
	gboolean result;
	result = ___lambda12_ (self, icomp, instance_start, instance_end, error);
#line 506 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 4234 "EventStore.c"
}

static void
__lambda11_ (Block8Data* _data8_,
             ICalComponent* comp)
{
	CalendarEventStore* self;
	Block9Data* _data9_;
	const gchar* _tmp0_;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_;
	GeeTreeMultiMap* _tmp3_;
	GeeCollection* events_for_uid = NULL;
	GeeTreeMultiMap* _tmp4_;
	const gchar* _tmp5_;
	GeeCollection* _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	GeeCollection* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 490 "../core/Services/Calendar/EventStore.vala"
	self = _data8_->self;
#line 490 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (comp != NULL);
#line 490 "../core/Services/Calendar/EventStore.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 490 "../core/Services/Calendar/EventStore.vala"
	_data9_->_ref_count_ = 1;
#line 490 "../core/Services/Calendar/EventStore.vala"
	_data9_->_data8_ = block8_data_ref (_data8_);
#line 491 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = i_cal_component_get_uid (comp);
#line 491 "../core/Services/Calendar/EventStore.vala"
	_data9_->uid = _tmp0_;
#line 492 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = self->priv->source_events;
#line 492 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = g_hash_table_lookup (_tmp1_, _data8_->source);
#line 492 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = _g_object_ref0 ((GeeTreeMultiMap*) _tmp2_);
#line 492 "../core/Services/Calendar/EventStore.vala"
	_data9_->events_for_source = _tmp3_;
#line 493 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = _data9_->events_for_source;
#line 493 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = _data9_->uid;
#line 493 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = gee_multi_map_get ((GeeMultiMap*) _tmp4_, _tmp5_);
#line 493 "../core/Services/Calendar/EventStore.vala"
	events_for_uid = _tmp6_;
#line 494 "../core/Services/Calendar/EventStore.vala"
	_tmp9_ = events_for_uid;
#line 494 "../core/Services/Calendar/EventStore.vala"
	_tmp10_ = gee_collection_get_size (_tmp9_);
#line 494 "../core/Services/Calendar/EventStore.vala"
	_tmp11_ = _tmp10_;
#line 494 "../core/Services/Calendar/EventStore.vala"
	if (_tmp11_ > 1) {
#line 494 "../core/Services/Calendar/EventStore.vala"
		_tmp8_ = TRUE;
#line 4296 "EventStore.c"
	} else {
		GeeCollection* _tmp12_;
		gint _tmp13_ = 0;
		gpointer* _tmp14_;
		ECalComponent** _tmp15_;
		gint _tmp15__length1;
		ECalComponent* _tmp16_;
		ICalComponent* _tmp17_;
		ICalTime* _tmp18_;
		ICalTime* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp12_ = events_for_uid;
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp14_ = gee_collection_to_array (_tmp12_, &_tmp13_);
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp15_ = _tmp14_;
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp15__length1 = _tmp13_;
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp16_ = _tmp15_[0];
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp17_ = e_cal_component_get_icalcomponent (_tmp16_);
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp18_ = i_cal_component_get_recurrenceid (_tmp17_);
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp19_ = _tmp18_;
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp20_ = i_cal_time_as_ical_string (_tmp19_);
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp21_ = _tmp20_;
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp8_ = _tmp21_ != NULL;
#line 495 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (_tmp21_);
#line 495 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_tmp19_);
#line 495 "../core/Services/Calendar/EventStore.vala"
		_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_object_unref), NULL);
#line 4337 "EventStore.c"
	}
#line 494 "../core/Services/Calendar/EventStore.vala"
	if (_tmp8_) {
#line 494 "../core/Services/Calendar/EventStore.vala"
		_tmp7_ = TRUE;
#line 4343 "EventStore.c"
	} else {
		ICalTime* _tmp22_;
		ICalTime* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
#line 496 "../core/Services/Calendar/EventStore.vala"
		_tmp22_ = i_cal_component_get_recurrenceid (comp);
#line 496 "../core/Services/Calendar/EventStore.vala"
		_tmp23_ = _tmp22_;
#line 496 "../core/Services/Calendar/EventStore.vala"
		_tmp24_ = i_cal_time_as_ical_string (_tmp23_);
#line 496 "../core/Services/Calendar/EventStore.vala"
		_tmp25_ = _tmp24_;
#line 496 "../core/Services/Calendar/EventStore.vala"
		_tmp7_ = _tmp25_ != NULL;
#line 496 "../core/Services/Calendar/EventStore.vala"
		_g_free0 (_tmp25_);
#line 496 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_tmp23_);
#line 4363 "EventStore.c"
	}
#line 494 "../core/Services/Calendar/EventStore.vala"
	if (_tmp7_) {
#line 4367 "EventStore.c"
		GeeTreeMultiMap* _tmp26_;
		const gchar* _tmp27_;
		CalendarUtilDateRange* _tmp35_;
		GDateTime* _tmp36_;
		GDateTime* _tmp37_;
		CalendarUtilDateRange* _tmp38_;
		GDateTime* _tmp39_;
		GDateTime* _tmp40_;
#line 500 "../core/Services/Calendar/EventStore.vala"
		_tmp26_ = _data9_->events_for_source;
#line 500 "../core/Services/Calendar/EventStore.vala"
		_tmp27_ = _data9_->uid;
#line 500 "../core/Services/Calendar/EventStore.vala"
		gee_multi_map_remove_all ((GeeMultiMap*) _tmp26_, _tmp27_);
#line 4382 "EventStore.c"
		{
			GeeIterator* _event_it = NULL;
			GeeCollection* _tmp28_;
			GeeIterator* _tmp29_;
#line 501 "../core/Services/Calendar/EventStore.vala"
			_tmp28_ = events_for_uid;
#line 501 "../core/Services/Calendar/EventStore.vala"
			_tmp29_ = gee_iterable_iterator ((GeeIterable*) _tmp28_);
#line 501 "../core/Services/Calendar/EventStore.vala"
			_event_it = _tmp29_;
#line 501 "../core/Services/Calendar/EventStore.vala"
			while (TRUE) {
#line 4395 "EventStore.c"
				GeeIterator* _tmp30_;
				ECalComponent* event = NULL;
				GeeIterator* _tmp31_;
				gpointer _tmp32_;
				ECalComponent* _tmp33_;
				ECalComponent* _tmp34_;
#line 501 "../core/Services/Calendar/EventStore.vala"
				_tmp30_ = _event_it;
#line 501 "../core/Services/Calendar/EventStore.vala"
				if (!gee_iterator_next (_tmp30_)) {
#line 501 "../core/Services/Calendar/EventStore.vala"
					break;
#line 4408 "EventStore.c"
				}
#line 501 "../core/Services/Calendar/EventStore.vala"
				_tmp31_ = _event_it;
#line 501 "../core/Services/Calendar/EventStore.vala"
				_tmp32_ = gee_iterator_get (_tmp31_);
#line 501 "../core/Services/Calendar/EventStore.vala"
				event = (ECalComponent*) _tmp32_;
#line 502 "../core/Services/Calendar/EventStore.vala"
				_tmp33_ = event;
#line 502 "../core/Services/Calendar/EventStore.vala"
				calendar_event_store_debug_event (self, _data8_->source, _tmp33_, "MODIFIED - ORIGINAL");
#line 503 "../core/Services/Calendar/EventStore.vala"
				_tmp34_ = event;
#line 503 "../core/Services/Calendar/EventStore.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data8_->removed_events, _tmp34_);
#line 501 "../core/Services/Calendar/EventStore.vala"
				_g_object_unref0 (event);
#line 4426 "EventStore.c"
			}
#line 501 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (_event_it);
#line 4430 "EventStore.c"
		}
#line 506 "../core/Services/Calendar/EventStore.vala"
		_tmp35_ = self->priv->_data_range;
#line 506 "../core/Services/Calendar/EventStore.vala"
		_tmp36_ = calendar_util_date_range_get_first_dt (_tmp35_);
#line 506 "../core/Services/Calendar/EventStore.vala"
		_tmp37_ = _tmp36_;
#line 506 "../core/Services/Calendar/EventStore.vala"
		_tmp38_ = self->priv->_data_range;
#line 506 "../core/Services/Calendar/EventStore.vala"
		_tmp39_ = calendar_util_date_range_get_last_dt (_tmp38_);
#line 506 "../core/Services/Calendar/EventStore.vala"
		_tmp40_ = _tmp39_;
#line 506 "../core/Services/Calendar/EventStore.vala"
		e_cal_client_generate_instances_for_object_sync (_data8_->client, comp, (time_t) g_date_time_to_unix (_tmp37_), (time_t) g_date_time_to_unix (_tmp40_), NULL, ____lambda12__ecal_recur_instance_cb, _data9_);
#line 4446 "EventStore.c"
	} else {
		GeeCollection* _tmp41_;
		gint _tmp42_ = 0;
		gpointer* _tmp43_;
		ECalComponent** _tmp44_;
		gint _tmp44__length1;
		ECalComponent* _tmp45_;
		GeeCollection* _tmp46_;
		gint _tmp47_ = 0;
		gpointer* _tmp48_;
		ECalComponent** _tmp49_;
		gint _tmp49__length1;
		ECalComponent* _tmp50_;
#line 515 "../core/Services/Calendar/EventStore.vala"
		_tmp41_ = events_for_uid;
#line 515 "../core/Services/Calendar/EventStore.vala"
		_tmp43_ = gee_collection_to_array (_tmp41_, &_tmp42_);
#line 515 "../core/Services/Calendar/EventStore.vala"
		_tmp44_ = _tmp43_;
#line 515 "../core/Services/Calendar/EventStore.vala"
		_tmp44__length1 = _tmp42_;
#line 515 "../core/Services/Calendar/EventStore.vala"
		_tmp45_ = _tmp44_[0];
#line 515 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_debug_event (self, _data8_->source, _tmp45_, "MODIFIED - UPDATED");
#line 515 "../core/Services/Calendar/EventStore.vala"
		_tmp44_ = (_vala_array_free (_tmp44_, _tmp44__length1, (GDestroyNotify) g_object_unref), NULL);
#line 516 "../core/Services/Calendar/EventStore.vala"
		_tmp46_ = events_for_uid;
#line 516 "../core/Services/Calendar/EventStore.vala"
		_tmp48_ = gee_collection_to_array (_tmp46_, &_tmp47_);
#line 516 "../core/Services/Calendar/EventStore.vala"
		_tmp49_ = _tmp48_;
#line 516 "../core/Services/Calendar/EventStore.vala"
		_tmp49__length1 = _tmp47_;
#line 516 "../core/Services/Calendar/EventStore.vala"
		_tmp50_ = _tmp49_[0];
#line 516 "../core/Services/Calendar/EventStore.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _data8_->updated_events, _tmp50_);
#line 516 "../core/Services/Calendar/EventStore.vala"
		_tmp49_ = (_vala_array_free (_tmp49_, _tmp49__length1, (GDestroyNotify) g_object_unref), NULL);
#line 4488 "EventStore.c"
	}
#line 490 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (events_for_uid);
#line 490 "../core/Services/Calendar/EventStore.vala"
	block9_data_unref (_data9_);
#line 490 "../core/Services/Calendar/EventStore.vala"
	_data9_ = NULL;
#line 4496 "EventStore.c"
}

static void
___lambda11__gfunc (gconstpointer data,
                    gpointer self)
{
#line 490 "../core/Services/Calendar/EventStore.vala"
	__lambda11_ (self, (ICalComponent*) data);
#line 4505 "EventStore.c"
}

static void
calendar_event_store_on_objects_modified (CalendarEventStore* self,
                                          ESource* source,
                                          ECalClient* client,
                                          GSList* objects)
{
	Block8Data* _data8_;
	ESource* _tmp0_;
	ECalClient* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	GeeBidirList* _tmp11_;
	GeeBidirList* _tmp12_;
	GeeBidirList* _tmp13_;
	GeeBidirList* _tmp14_;
	GeeBidirList* _tmp15_;
	GeeBidirList* _tmp16_;
	GeeBidirList* _tmp17_;
	GeeBidirList* _tmp18_;
	GeeBidirList* _tmp19_;
#line 484 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 484 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 484 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (client != NULL);
#line 484 "../core/Services/Calendar/EventStore.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 484 "../core/Services/Calendar/EventStore.vala"
	_data8_->_ref_count_ = 1;
#line 484 "../core/Services/Calendar/EventStore.vala"
	_data8_->self = g_object_ref (self);
#line 484 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 484 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data8_->source);
#line 484 "../core/Services/Calendar/EventStore.vala"
	_data8_->source = _tmp0_;
#line 484 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = _g_object_ref0 (client);
#line 484 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data8_->client);
#line 484 "../core/Services/Calendar/EventStore.vala"
	_data8_->client = _tmp1_;
#line 485 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = g_strdup_printf ("%u", g_slist_length (objects));
#line 485 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = _tmp2_;
#line 485 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = g_strconcat ("Received ", _tmp3_, " modified event(s) for source '%s'", NULL);
#line 485 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = _tmp4_;
#line 485 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = e_source_dup_display_name (_data8_->source);
#line 485 "../core/Services/Calendar/EventStore.vala"
	_tmp7_ = _tmp6_;
#line 485 "../core/Services/Calendar/EventStore.vala"
	g_debug (_tmp5_, _tmp7_);
#line 485 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp7_);
#line 485 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp5_);
#line 485 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp3_);
#line 486 "../core/Services/Calendar/EventStore.vala"
	_tmp8_ = gee_array_list_new (e_cal_component_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeEqualDataFunc) calendar_util_ecalcomponent_equal_func, NULL, NULL);
#line 486 "../core/Services/Calendar/EventStore.vala"
	_data8_->updated_events = _tmp8_;
#line 487 "../core/Services/Calendar/EventStore.vala"
	_tmp9_ = gee_array_list_new (e_cal_component_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeEqualDataFunc) calendar_util_ecalcomponent_equal_func, NULL, NULL);
#line 487 "../core/Services/Calendar/EventStore.vala"
	_data8_->removed_events = _tmp9_;
#line 488 "../core/Services/Calendar/EventStore.vala"
	_tmp10_ = gee_array_list_new (e_cal_component_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeEqualDataFunc) calendar_util_ecalcomponent_equal_func, NULL, NULL);
#line 488 "../core/Services/Calendar/EventStore.vala"
	_data8_->added_events = _tmp10_;
#line 490 "../core/Services/Calendar/EventStore.vala"
	g_slist_foreach (objects, ___lambda11__gfunc, _data8_);
#line 520 "../core/Services/Calendar/EventStore.vala"
	_tmp11_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _data8_->removed_events);
#line 520 "../core/Services/Calendar/EventStore.vala"
	_tmp12_ = _tmp11_;
#line 520 "../core/Services/Calendar/EventStore.vala"
	_tmp13_ = _tmp12_;
#line 520 "../core/Services/Calendar/EventStore.vala"
	g_signal_emit (self, calendar_event_store_signals[CALENDAR_EVENT_STORE_EVENTS_REMOVED_SIGNAL], 0, _data8_->source, (GeeCollection*) _tmp13_);
#line 520 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_tmp13_);
#line 521 "../core/Services/Calendar/EventStore.vala"
	_tmp14_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _data8_->added_events);
#line 521 "../core/Services/Calendar/EventStore.vala"
	_tmp15_ = _tmp14_;
#line 521 "../core/Services/Calendar/EventStore.vala"
	_tmp16_ = _tmp15_;
#line 521 "../core/Services/Calendar/EventStore.vala"
	g_signal_emit (self, calendar_event_store_signals[CALENDAR_EVENT_STORE_EVENTS_ADDED_SIGNAL], 0, _data8_->source, (GeeCollection*) _tmp16_);
#line 521 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_tmp16_);
#line 522 "../core/Services/Calendar/EventStore.vala"
	_tmp17_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _data8_->updated_events);
#line 522 "../core/Services/Calendar/EventStore.vala"
	_tmp18_ = _tmp17_;
#line 522 "../core/Services/Calendar/EventStore.vala"
	_tmp19_ = _tmp18_;
#line 522 "../core/Services/Calendar/EventStore.vala"
	g_signal_emit (self, calendar_event_store_signals[CALENDAR_EVENT_STORE_EVENTS_UPDATED_SIGNAL], 0, _data8_->source, (GeeCollection*) _tmp19_);
#line 522 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_tmp19_);
#line 484 "../core/Services/Calendar/EventStore.vala"
	block8_data_unref (_data8_);
#line 484 "../core/Services/Calendar/EventStore.vala"
	_data8_ = NULL;
#line 4627 "EventStore.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 525 "../core/Services/Calendar/EventStore.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 525 "../core/Services/Calendar/EventStore.vala"
	return _data10_;
#line 4637 "EventStore.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 525 "../core/Services/Calendar/EventStore.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 4647 "EventStore.c"
		CalendarEventStore* self;
#line 525 "../core/Services/Calendar/EventStore.vala"
		self = _data10_->self;
#line 525 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data10_->removed_events);
#line 525 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data10_->events);
#line 525 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_data10_->source);
#line 525 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self);
#line 525 "../core/Services/Calendar/EventStore.vala"
		g_slice_free (Block10Data, _data10_);
#line 4661 "EventStore.c"
	}
}

static void
__lambda9_ (Block10Data* _data10_,
            ECalComponentId* cid)
{
	CalendarEventStore* self;
	GeeCollection* comps = NULL;
	const gchar* _tmp0_;
	GeeCollection* _tmp1_;
	const gchar* _tmp2_;
#line 529 "../core/Services/Calendar/EventStore.vala"
	self = _data10_->self;
#line 530 "../core/Services/Calendar/EventStore.vala"
	if (cid == NULL) {
#line 531 "../core/Services/Calendar/EventStore.vala"
		return;
#line 4680 "EventStore.c"
	}
#line 533 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = e_cal_component_id_get_uid (cid);
#line 533 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = gee_multi_map_get ((GeeMultiMap*) _data10_->events, _tmp0_);
#line 533 "../core/Services/Calendar/EventStore.vala"
	comps = _tmp1_;
#line 534 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = e_cal_component_id_get_uid (cid);
#line 534 "../core/Services/Calendar/EventStore.vala"
	gee_multi_map_remove_all ((GeeMultiMap*) _data10_->events, _tmp2_);
#line 4692 "EventStore.c"
	{
		GeeIterator* _event_it = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
#line 535 "../core/Services/Calendar/EventStore.vala"
		_tmp3_ = comps;
#line 535 "../core/Services/Calendar/EventStore.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 535 "../core/Services/Calendar/EventStore.vala"
		_event_it = _tmp4_;
#line 535 "../core/Services/Calendar/EventStore.vala"
		while (TRUE) {
#line 4705 "EventStore.c"
			GeeIterator* _tmp5_;
			ECalComponent* event = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			ECalComponent* _tmp8_;
			ECalComponent* _tmp9_;
#line 535 "../core/Services/Calendar/EventStore.vala"
			_tmp5_ = _event_it;
#line 535 "../core/Services/Calendar/EventStore.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 535 "../core/Services/Calendar/EventStore.vala"
				break;
#line 4718 "EventStore.c"
			}
#line 535 "../core/Services/Calendar/EventStore.vala"
			_tmp6_ = _event_it;
#line 535 "../core/Services/Calendar/EventStore.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 535 "../core/Services/Calendar/EventStore.vala"
			event = (ECalComponent*) _tmp7_;
#line 536 "../core/Services/Calendar/EventStore.vala"
			_tmp8_ = event;
#line 536 "../core/Services/Calendar/EventStore.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _data10_->removed_events, _tmp8_);
#line 537 "../core/Services/Calendar/EventStore.vala"
			_tmp9_ = event;
#line 537 "../core/Services/Calendar/EventStore.vala"
			calendar_event_store_debug_event (self, _data10_->source, _tmp9_, "");
#line 535 "../core/Services/Calendar/EventStore.vala"
			_g_object_unref0 (event);
#line 4736 "EventStore.c"
		}
#line 535 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (_event_it);
#line 4740 "EventStore.c"
	}
#line 529 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (comps);
#line 4744 "EventStore.c"
}

static void
___lambda9__gfunc (gconstpointer data,
                   gpointer self)
{
#line 529 "../core/Services/Calendar/EventStore.vala"
	__lambda9_ (self, (ECalComponentId*) data);
#line 4753 "EventStore.c"
}

static void
calendar_event_store_on_objects_removed (CalendarEventStore* self,
                                         ESource* source,
                                         ECalClient* client,
                                         GSList* cids)
{
	Block10Data* _data10_;
	ESource* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GHashTable* _tmp7_;
	gconstpointer _tmp8_;
	GeeTreeMultiMap* _tmp9_;
	GeeArrayList* _tmp10_;
	GeeBidirList* _tmp11_;
	GeeBidirList* _tmp12_;
	GeeBidirList* _tmp13_;
#line 525 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 525 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (source != NULL);
#line 525 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (client != NULL);
#line 525 "../core/Services/Calendar/EventStore.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 525 "../core/Services/Calendar/EventStore.vala"
	_data10_->_ref_count_ = 1;
#line 525 "../core/Services/Calendar/EventStore.vala"
	_data10_->self = g_object_ref (self);
#line 525 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 525 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_data10_->source);
#line 525 "../core/Services/Calendar/EventStore.vala"
	_data10_->source = _tmp0_;
#line 526 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = g_strdup_printf ("%u", g_slist_length (cids));
#line 526 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = _tmp1_;
#line 526 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = g_strconcat ("Received ", _tmp2_, " removed event(s) for source '%s'", NULL);
#line 526 "../core/Services/Calendar/EventStore.vala"
	_tmp4_ = _tmp3_;
#line 526 "../core/Services/Calendar/EventStore.vala"
	_tmp5_ = e_source_dup_display_name (_data10_->source);
#line 526 "../core/Services/Calendar/EventStore.vala"
	_tmp6_ = _tmp5_;
#line 526 "../core/Services/Calendar/EventStore.vala"
	g_debug (_tmp4_, _tmp6_);
#line 526 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp6_);
#line 526 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp4_);
#line 526 "../core/Services/Calendar/EventStore.vala"
	_g_free0 (_tmp2_);
#line 527 "../core/Services/Calendar/EventStore.vala"
	_tmp7_ = self->priv->source_events;
#line 527 "../core/Services/Calendar/EventStore.vala"
	_tmp8_ = g_hash_table_lookup (_tmp7_, _data10_->source);
#line 527 "../core/Services/Calendar/EventStore.vala"
	_tmp9_ = _g_object_ref0 ((GeeTreeMultiMap*) _tmp8_);
#line 527 "../core/Services/Calendar/EventStore.vala"
	_data10_->events = _tmp9_;
#line 528 "../core/Services/Calendar/EventStore.vala"
	_tmp10_ = gee_array_list_new (e_cal_component_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeEqualDataFunc) calendar_util_ecalcomponent_equal_func, NULL, NULL);
#line 528 "../core/Services/Calendar/EventStore.vala"
	_data10_->removed_events = _tmp10_;
#line 529 "../core/Services/Calendar/EventStore.vala"
	g_slist_foreach (cids, ___lambda9__gfunc, _data10_);
#line 541 "../core/Services/Calendar/EventStore.vala"
	_tmp11_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _data10_->removed_events);
#line 541 "../core/Services/Calendar/EventStore.vala"
	_tmp12_ = _tmp11_;
#line 541 "../core/Services/Calendar/EventStore.vala"
	_tmp13_ = _tmp12_;
#line 541 "../core/Services/Calendar/EventStore.vala"
	g_signal_emit (self, calendar_event_store_signals[CALENDAR_EVENT_STORE_EVENTS_REMOVED_SIGNAL], 0, _data10_->source, (GeeCollection*) _tmp13_);
#line 541 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (_tmp13_);
#line 525 "../core/Services/Calendar/EventStore.vala"
	block10_data_unref (_data10_);
#line 525 "../core/Services/Calendar/EventStore.vala"
	_data10_ = NULL;
#line 4843 "EventStore.c"
}

CalendarUtilDateRange*
calendar_event_store_get_data_range (CalendarEventStore* self)
{
	CalendarUtilDateRange* result;
	CalendarUtilDateRange* _tmp0_;
#line 27 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = self->priv->_data_range;
#line 27 "../core/Services/Calendar/EventStore.vala"
	result = _tmp0_;
#line 27 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 4859 "EventStore.c"
}

static void
calendar_event_store_set_data_range (CalendarEventStore* self,
                                     CalendarUtilDateRange* value)
{
	CalendarUtilDateRange* old_value;
#line 27 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 27 "../core/Services/Calendar/EventStore.vala"
	old_value = calendar_event_store_get_data_range (self);
#line 27 "../core/Services/Calendar/EventStore.vala"
	if (old_value != value) {
#line 4873 "EventStore.c"
		CalendarUtilDateRange* _tmp0_;
#line 27 "../core/Services/Calendar/EventStore.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self->priv->_data_range);
#line 27 "../core/Services/Calendar/EventStore.vala"
		self->priv->_data_range = _tmp0_;
#line 27 "../core/Services/Calendar/EventStore.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_event_store_properties[CALENDAR_EVENT_STORE_DATA_RANGE_PROPERTY]);
#line 4883 "EventStore.c"
	}
}

CalendarUtilDateRange*
calendar_event_store_get_month_range (CalendarEventStore* self)
{
	CalendarUtilDateRange* result;
	CalendarUtilDateRange* _tmp0_;
#line 28 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = self->priv->_month_range;
#line 28 "../core/Services/Calendar/EventStore.vala"
	result = _tmp0_;
#line 28 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 4900 "EventStore.c"
}

static void
calendar_event_store_set_month_range (CalendarEventStore* self,
                                      CalendarUtilDateRange* value)
{
	CalendarUtilDateRange* old_value;
#line 28 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 28 "../core/Services/Calendar/EventStore.vala"
	old_value = calendar_event_store_get_month_range (self);
#line 28 "../core/Services/Calendar/EventStore.vala"
	if (old_value != value) {
#line 4914 "EventStore.c"
		CalendarUtilDateRange* _tmp0_;
#line 28 "../core/Services/Calendar/EventStore.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self->priv->_month_range);
#line 28 "../core/Services/Calendar/EventStore.vala"
		self->priv->_month_range = _tmp0_;
#line 28 "../core/Services/Calendar/EventStore.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_event_store_properties[CALENDAR_EVENT_STORE_MONTH_RANGE_PROPERTY]);
#line 4924 "EventStore.c"
	}
}

ESourceRegistry*
calendar_event_store_get_registry (CalendarEventStore* self)
{
	ESourceRegistry* result;
	ESourceRegistry* _tmp0_;
#line 29 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = self->priv->_registry;
#line 29 "../core/Services/Calendar/EventStore.vala"
	result = _tmp0_;
#line 29 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 4941 "EventStore.c"
}

static void
calendar_event_store_set_registry (CalendarEventStore* self,
                                   ESourceRegistry* value)
{
	ESourceRegistry* old_value;
#line 29 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 29 "../core/Services/Calendar/EventStore.vala"
	old_value = calendar_event_store_get_registry (self);
#line 29 "../core/Services/Calendar/EventStore.vala"
	if (old_value != value) {
#line 4955 "EventStore.c"
		ESourceRegistry* _tmp0_;
#line 29 "../core/Services/Calendar/EventStore.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self->priv->_registry);
#line 29 "../core/Services/Calendar/EventStore.vala"
		self->priv->_registry = _tmp0_;
#line 29 "../core/Services/Calendar/EventStore.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_event_store_properties[CALENDAR_EVENT_STORE_REGISTRY_PROPERTY]);
#line 4965 "EventStore.c"
	}
}

GDateTime*
calendar_event_store_get_month_start (CalendarEventStore* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 32 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = self->priv->_month_start;
#line 32 "../core/Services/Calendar/EventStore.vala"
	result = _tmp0_;
#line 32 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 4982 "EventStore.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 32 "../core/Services/Calendar/EventStore.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 4990 "EventStore.c"
}

void
calendar_event_store_set_month_start (CalendarEventStore* self,
                                      GDateTime* value)
{
	GDateTime* old_value;
#line 32 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 32 "../core/Services/Calendar/EventStore.vala"
	old_value = calendar_event_store_get_month_start (self);
#line 32 "../core/Services/Calendar/EventStore.vala"
	if (old_value != value) {
#line 5004 "EventStore.c"
		GDateTime* _tmp0_;
#line 32 "../core/Services/Calendar/EventStore.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 32 "../core/Services/Calendar/EventStore.vala"
		_g_date_time_unref0 (self->priv->_month_start);
#line 32 "../core/Services/Calendar/EventStore.vala"
		self->priv->_month_start = _tmp0_;
#line 32 "../core/Services/Calendar/EventStore.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_event_store_properties[CALENDAR_EVENT_STORE_MONTH_START_PROPERTY]);
#line 5014 "EventStore.c"
	}
}

gint
calendar_event_store_get_num_weeks (CalendarEventStore* self)
{
	gint result;
#line 35 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "../core/Services/Calendar/EventStore.vala"
	result = self->priv->_num_weeks;
#line 35 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 5028 "EventStore.c"
}

static void
calendar_event_store_set_num_weeks (CalendarEventStore* self,
                                    gint value)
{
	gint old_value;
#line 35 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 35 "../core/Services/Calendar/EventStore.vala"
	old_value = calendar_event_store_get_num_weeks (self);
#line 35 "../core/Services/Calendar/EventStore.vala"
	if (old_value != value) {
#line 35 "../core/Services/Calendar/EventStore.vala"
		self->priv->_num_weeks = value;
#line 35 "../core/Services/Calendar/EventStore.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_event_store_properties[CALENDAR_EVENT_STORE_NUM_WEEKS_PROPERTY]);
#line 5046 "EventStore.c"
	}
}

GDateWeekday
calendar_event_store_get_week_starts_on (CalendarEventStore* self)
{
	GDateWeekday result;
#line 38 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../core/Services/Calendar/EventStore.vala"
	result = self->priv->_week_starts_on;
#line 38 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 5060 "EventStore.c"
}

void
calendar_event_store_set_week_starts_on (CalendarEventStore* self,
                                         GDateWeekday value)
{
	GDateWeekday old_value;
#line 38 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 38 "../core/Services/Calendar/EventStore.vala"
	old_value = calendar_event_store_get_week_starts_on (self);
#line 38 "../core/Services/Calendar/EventStore.vala"
	if (old_value != value) {
#line 38 "../core/Services/Calendar/EventStore.vala"
		self->priv->_week_starts_on = value;
#line 38 "../core/Services/Calendar/EventStore.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_event_store_properties[CALENDAR_EVENT_STORE_WEEK_STARTS_ON_PROPERTY]);
#line 5078 "EventStore.c"
	}
}

ECalComponent*
calendar_event_store_get_drag_component (CalendarEventStore* self)
{
	ECalComponent* result;
	ECalComponent* _tmp0_;
#line 41 "../core/Services/Calendar/EventStore.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = self->priv->_drag_component;
#line 41 "../core/Services/Calendar/EventStore.vala"
	result = _tmp0_;
#line 41 "../core/Services/Calendar/EventStore.vala"
	return result;
#line 5095 "EventStore.c"
}

void
calendar_event_store_set_drag_component (CalendarEventStore* self,
                                         ECalComponent* value)
{
	ECalComponent* old_value;
#line 41 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (self != NULL);
#line 41 "../core/Services/Calendar/EventStore.vala"
	old_value = calendar_event_store_get_drag_component (self);
#line 41 "../core/Services/Calendar/EventStore.vala"
	if (old_value != value) {
#line 5109 "EventStore.c"
		ECalComponent* _tmp0_;
#line 41 "../core/Services/Calendar/EventStore.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (self->priv->_drag_component);
#line 41 "../core/Services/Calendar/EventStore.vala"
		self->priv->_drag_component = _tmp0_;
#line 41 "../core/Services/Calendar/EventStore.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_event_store_properties[CALENDAR_EVENT_STORE_DRAG_COMPONENT_PROPERTY]);
#line 5119 "EventStore.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_return_if_fail (n_param_values == 3);
#line 15 "../core/Services/Calendar/EventStore.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 15 "../core/Services/Calendar/EventStore.vala"
		data1 = closure->data;
#line 15 "../core/Services/Calendar/EventStore.vala"
		data2 = param_values->data[0].v_pointer;
#line 5145 "EventStore.c"
	} else {
#line 15 "../core/Services/Calendar/EventStore.vala"
		data1 = param_values->data[0].v_pointer;
#line 15 "../core/Services/Calendar/EventStore.vala"
		data2 = closure->data;
#line 5151 "EventStore.c"
	}
#line 15 "../core/Services/Calendar/EventStore.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 15 "../core/Services/Calendar/EventStore.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 5157 "EventStore.c"
}

static void
calendar_event_store_class_init (CalendarEventStoreClass * klass,
                                 gpointer klass_data)
{
	GSettingsSchemaSource* _tmp0_;
	GSettingsSchema* _tmp1_;
	GSettingsSchema* _tmp2_;
	gboolean _tmp3_;
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_parent_class = g_type_class_peek_parent (klass);
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_type_class_adjust_private_offset (klass, &CalendarEventStore_private_offset);
#line 15 "../core/Services/Calendar/EventStore.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_calendar_event_store_get_property;
#line 15 "../core/Services/Calendar/EventStore.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_calendar_event_store_set_property;
#line 15 "../core/Services/Calendar/EventStore.vala"
	G_OBJECT_CLASS (klass)->finalize = calendar_event_store_finalize;
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_EVENT_STORE_DATA_RANGE_PROPERTY, calendar_event_store_properties[CALENDAR_EVENT_STORE_DATA_RANGE_PROPERTY] = g_param_spec_object ("data-range", "data-range", "data-range", CALENDAR_UTIL_TYPE_DATE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_EVENT_STORE_MONTH_RANGE_PROPERTY, calendar_event_store_properties[CALENDAR_EVENT_STORE_MONTH_RANGE_PROPERTY] = g_param_spec_object ("month-range", "month-range", "month-range", CALENDAR_UTIL_TYPE_DATE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_EVENT_STORE_REGISTRY_PROPERTY, calendar_event_store_properties[CALENDAR_EVENT_STORE_REGISTRY_PROPERTY] = g_param_spec_object ("registry", "registry", "registry", e_source_registry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_EVENT_STORE_MONTH_START_PROPERTY, calendar_event_store_properties[CALENDAR_EVENT_STORE_MONTH_START_PROPERTY] = g_param_spec_boxed ("month-start", "month-start", "month-start", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_EVENT_STORE_NUM_WEEKS_PROPERTY, calendar_event_store_properties[CALENDAR_EVENT_STORE_NUM_WEEKS_PROPERTY] = g_param_spec_int ("num-weeks", "num-weeks", "num-weeks", G_MININT, G_MAXINT, 6, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_EVENT_STORE_WEEK_STARTS_ON_PROPERTY, calendar_event_store_properties[CALENDAR_EVENT_STORE_WEEK_STARTS_ON_PROPERTY] = g_param_spec_int ("week-starts-on", "week-starts-on", "week-starts-on", G_MININT, G_MAXINT, G_DATE_MONDAY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../core/Services/Calendar/EventStore.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_EVENT_STORE_DRAG_COMPONENT_PROPERTY, calendar_event_store_properties[CALENDAR_EVENT_STORE_DRAG_COMPONENT_PROPERTY] = g_param_spec_object ("drag-component", "drag-component", "drag-component", e_cal_component_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_signals[CALENDAR_EVENT_STORE_EVENTS_ADDED_SIGNAL] = g_signal_new ("events-added", CALENDAR_TYPE_EVENT_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, e_source_get_type (), GEE_TYPE_COLLECTION);
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_signals[CALENDAR_EVENT_STORE_EVENTS_UPDATED_SIGNAL] = g_signal_new ("events-updated", CALENDAR_TYPE_EVENT_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, e_source_get_type (), GEE_TYPE_COLLECTION);
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_signals[CALENDAR_EVENT_STORE_EVENTS_REMOVED_SIGNAL] = g_signal_new ("events-removed", CALENDAR_TYPE_EVENT_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, e_source_get_type (), GEE_TYPE_COLLECTION);
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_signals[CALENDAR_EVENT_STORE_CONNECTING_SIGNAL] = g_signal_new ("connecting", CALENDAR_TYPE_EVENT_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, e_source_get_type (), g_cancellable_get_type ());
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_signals[CALENDAR_EVENT_STORE_CONNECTED_SIGNAL] = g_signal_new ("connected", CALENDAR_TYPE_EVENT_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, e_source_get_type ());
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_signals[CALENDAR_EVENT_STORE_ERROR_RECEIVED_SIGNAL] = g_signal_new ("error-received", CALENDAR_TYPE_EVENT_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 15 "../core/Services/Calendar/EventStore.vala"
	calendar_event_store_signals[CALENDAR_EVENT_STORE_PARAMETERS_CHANGED_SIGNAL] = g_signal_new ("parameters-changed", CALENDAR_TYPE_EVENT_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 72 "../core/Services/Calendar/EventStore.vala"
	_tmp0_ = g_settings_schema_source_get_default ();
#line 72 "../core/Services/Calendar/EventStore.vala"
	_tmp1_ = g_settings_schema_source_lookup (_tmp0_, "io.elementary.calendar.savedstate", TRUE);
#line 72 "../core/Services/Calendar/EventStore.vala"
	_tmp2_ = _tmp1_;
#line 72 "../core/Services/Calendar/EventStore.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 72 "../core/Services/Calendar/EventStore.vala"
	_g_settings_schema_unref0 (_tmp2_);
#line 72 "../core/Services/Calendar/EventStore.vala"
	if (_tmp3_) {
#line 5218 "EventStore.c"
		GSettings* _tmp4_;
#line 73 "../core/Services/Calendar/EventStore.vala"
		_tmp4_ = g_settings_new ("io.elementary.calendar.savedstate");
#line 73 "../core/Services/Calendar/EventStore.vala"
		_g_object_unref0 (calendar_event_store_state_settings);
#line 73 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_state_settings = _tmp4_;
#line 5226 "EventStore.c"
	}
}

static void
calendar_event_store_instance_init (CalendarEventStore * self,
                                    gpointer klass)
{
#line 15 "../core/Services/Calendar/EventStore.vala"
	self->priv = calendar_event_store_get_instance_private (self);
#line 35 "../core/Services/Calendar/EventStore.vala"
	self->priv->_num_weeks = 6;
#line 38 "../core/Services/Calendar/EventStore.vala"
	self->priv->_week_starts_on = G_DATE_MONDAY;
#line 55 "../core/Services/Calendar/EventStore.vala"
	g_rec_mutex_init (&self->priv->__lock_source_client);
#line 5242 "EventStore.c"
}

static void
calendar_event_store_finalize (GObject * obj)
{
	CalendarEventStore * self;
#line 15 "../core/Services/Calendar/EventStore.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CALENDAR_TYPE_EVENT_STORE, CalendarEventStore);
#line 27 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (self->priv->_data_range);
#line 28 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (self->priv->_month_range);
#line 29 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (self->priv->_registry);
#line 32 "../core/Services/Calendar/EventStore.vala"
	_g_date_time_unref0 (self->priv->_month_start);
#line 41 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (self->priv->_drag_component);
#line 55 "../core/Services/Calendar/EventStore.vala"
	g_rec_mutex_clear (&self->priv->__lock_source_client);
#line 55 "../core/Services/Calendar/EventStore.vala"
	_g_hash_table_unref0 (self->priv->source_client);
#line 56 "../core/Services/Calendar/EventStore.vala"
	_g_hash_table_unref0 (self->priv->source_view);
#line 57 "../core/Services/Calendar/EventStore.vala"
	_g_hash_table_unref0 (self->priv->source_events);
#line 59 "../core/Services/Calendar/EventStore.vala"
	(self->calendar_trash == NULL) ? NULL : (self->calendar_trash = (_g_queue_free__g_object_unref0_ (self->calendar_trash), NULL));
#line 60 "../core/Services/Calendar/EventStore.vala"
	_g_object_unref0 (self->priv->credentials_prompter);
#line 15 "../core/Services/Calendar/EventStore.vala"
	G_OBJECT_CLASS (calendar_event_store_parent_class)->finalize (obj);
#line 5275 "EventStore.c"
}

static GType
calendar_event_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CalendarEventStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) calendar_event_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CalendarEventStore), 0, (GInstanceInitFunc) calendar_event_store_instance_init, NULL };
	GType calendar_event_store_type_id;
	calendar_event_store_type_id = g_type_register_static (G_TYPE_OBJECT, "CalendarEventStore", &g_define_type_info, 0);
	CalendarEventStore_private_offset = g_type_add_instance_private (calendar_event_store_type_id, sizeof (CalendarEventStorePrivate));
	return calendar_event_store_type_id;
}

GType
calendar_event_store_get_type (void)
{
	static volatile gsize calendar_event_store_type_id__once = 0;
	if (g_once_init_enter (&calendar_event_store_type_id__once)) {
		GType calendar_event_store_type_id;
		calendar_event_store_type_id = calendar_event_store_get_type_once ();
		g_once_init_leave (&calendar_event_store_type_id__once, calendar_event_store_type_id);
	}
	return calendar_event_store_type_id__once;
}

static void
_vala_calendar_event_store_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	CalendarEventStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CALENDAR_TYPE_EVENT_STORE, CalendarEventStore);
#line 15 "../core/Services/Calendar/EventStore.vala"
	switch (property_id) {
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_DATA_RANGE_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		g_value_set_object (value, calendar_event_store_get_data_range (self));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_MONTH_RANGE_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		g_value_set_object (value, calendar_event_store_get_month_range (self));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_REGISTRY_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		g_value_set_object (value, calendar_event_store_get_registry (self));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_MONTH_START_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		g_value_set_boxed (value, calendar_event_store_get_month_start (self));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_NUM_WEEKS_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		g_value_set_int (value, calendar_event_store_get_num_weeks (self));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_WEEK_STARTS_ON_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		g_value_set_int (value, calendar_event_store_get_week_starts_on (self));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_DRAG_COMPONENT_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		g_value_set_object (value, calendar_event_store_get_drag_component (self));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 5352 "EventStore.c"
		default:
#line 15 "../core/Services/Calendar/EventStore.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 5358 "EventStore.c"
	}
}

static void
_vala_calendar_event_store_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	CalendarEventStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CALENDAR_TYPE_EVENT_STORE, CalendarEventStore);
#line 15 "../core/Services/Calendar/EventStore.vala"
	switch (property_id) {
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_DATA_RANGE_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_set_data_range (self, g_value_get_object (value));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_MONTH_RANGE_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_set_month_range (self, g_value_get_object (value));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_REGISTRY_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_set_registry (self, g_value_get_object (value));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_MONTH_START_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_set_month_start (self, g_value_get_boxed (value));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_NUM_WEEKS_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_set_num_weeks (self, g_value_get_int (value));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_WEEK_STARTS_ON_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_set_week_starts_on (self, g_value_get_int (value));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 15 "../core/Services/Calendar/EventStore.vala"
		case CALENDAR_EVENT_STORE_DRAG_COMPONENT_PROPERTY:
#line 15 "../core/Services/Calendar/EventStore.vala"
		calendar_event_store_set_drag_component (self, g_value_get_object (value));
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 5414 "EventStore.c"
		default:
#line 15 "../core/Services/Calendar/EventStore.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../core/Services/Calendar/EventStore.vala"
		break;
#line 5420 "EventStore.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

